<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="xml"/>
	<xsl:template match="/">
		<rss version="2.0" xmlns:dc="http://purl.org/dc/elements/1.1/">
			<channel>
				<title>Search Results: <xsl:value-of select="/RSSConnectSearchResults/Summary/SearchText" /></title>

				<xsl:if test="string(/RSSConnectSearchResults/Summary/StopWords)">
					<description>The following words are very common and were not included in your search:
						<xsl:value-of select="/RSSConnectSearchResults/Summary/StopWords" />
					</description>
				</xsl:if>
				<xsl:if test="count(/RSSConnectSearchResults/Table) &lt;= 0 ">
					<item>
						<title>0 matching entries found.</title>
					</item>
				</xsl:if>
				<xsl:for-each select="/RSSConnectSearchResults/Table">
					<item>
						<title><xsl:value-of select="Title" /></title>
						<link><xsl:value-of select="Link" /></link>
						<description><xsl:value-of select="Description" /></description>
						<pubDate><xsl:value-of select="Date" /></pubDate>
					</item>
				</xsl:for-each>
			</channel>
		</rss>
	</xsl:template>
</xsl:stylesheet>

  