<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="xml"/>
	<xsl:param name="sourceFileName"/>
	
	<xsl:template match="/">
		<xsl:choose>
			<xsl:when test="string(/opml/head/title)">
				<treenode text="{/opml/head/title}" title="{/opml/head/title}" type="folder">
					<xsl:apply-templates select="/opml/body"/>
				</treenode>
			</xsl:when>
			<xsl:otherwise>
				<treenode text="{$sourceFileName}" title="{$sourceFileName}" type="folder">
					<xsl:apply-templates select="/opml/body"/>
				</treenode>	
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template match="/opml/body">
		<xsl:call-template name="processOutlineNodes" />
	</xsl:template>
	
	<xsl:template name="processOutlineNodes">
		<xsl:for-each select="outline">
			<xsl:choose>
				<xsl:when test="count(child::*) &gt; 0">
					<treenode text="{@title}">
						<xsl:if test="string(@xmlUrl)">
						<xsl:attribute name="feedUrl"><xsl:value-of select="@xmlUrl"/></xsl:attribute>
						</xsl:if>
						<xsl:attribute name="type">folder</xsl:attribute>
						<xsl:call-template name="processOutlineNodes"/>
					</treenode>
				</xsl:when>
				<xsl:otherwise>
					<treenode text="{@title}" feedUrl="{@xmlUrl}"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:for-each>
	</xsl:template>
</xsl:stylesheet>

  