#region USING
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
#endregion
namespace RSSConnect
{
	/// <summary>
	/// Form allows adding new feed or updating tree node (feed/folder/opml) properties
	/// </summary>
	public class frmAddNew : System.Windows.Forms.Form
	{
		#region PUBLIC FIELDS
		public string feedTitle;
		public string feedUrl;
		public string opmlUrl;
		public nodeTypeEnum nodeType;
		#endregion
		#region PRIVATE CONTROL FIELDS
		private System.Windows.Forms.Button btnAdd;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.TextBox txtFeedTitle;
		private System.Windows.Forms.TextBox txtFeedUrl;
		private System.Windows.Forms.TextBox txtOPMLUrl;
		private System.Windows.Forms.Label lblTitle;
		private System.Windows.Forms.Label lblFeedUrl;
		private System.Windows.Forms.Label lblOPMLUrl;
		private System.ComponentModel.Container components = null;
		#endregion
		#region CTOR_DTOR
		public frmAddNew()
		{
			InitializeComponent();
			nodeType = nodeTypeEnum.feedNode;
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#endregion
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnAdd = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.lblTitle = new System.Windows.Forms.Label();
			this.txtFeedTitle = new System.Windows.Forms.TextBox();
			this.txtFeedUrl = new System.Windows.Forms.TextBox();
			this.lblFeedUrl = new System.Windows.Forms.Label();
			this.txtOPMLUrl = new System.Windows.Forms.TextBox();
			this.lblOPMLUrl = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// btnAdd
			// 
			this.btnAdd.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnAdd.Location = new System.Drawing.Point(296, 152);
			this.btnAdd.Name = "btnAdd";
			this.btnAdd.TabIndex = 7;
			this.btnAdd.Text = "&Add";
			this.btnAdd.Click += new System.EventHandler(this.btnAdd_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(384, 152);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 8;
			this.btnCancel.Text = "Cancel";
			// 
			// lblTitle
			// 
			this.lblTitle.AutoSize = true;
			this.lblTitle.Location = new System.Drawing.Point(16, 8);
			this.lblTitle.Name = "lblTitle";
			this.lblTitle.Size = new System.Drawing.Size(29, 16);
			this.lblTitle.TabIndex = 1;
			this.lblTitle.Text = "&Title:";
			// 
			// txtFeedTitle
			// 
			this.txtFeedTitle.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtFeedTitle.Location = new System.Drawing.Point(16, 25);
			this.txtFeedTitle.Name = "txtFeedTitle";
			this.txtFeedTitle.Size = new System.Drawing.Size(448, 20);
			this.txtFeedTitle.TabIndex = 2;
			this.txtFeedTitle.Text = "";
			this.txtFeedTitle.TextChanged += new System.EventHandler(this.txtFeedTitle_TextChanged);
			// 
			// txtFeedUrl
			// 
			this.txtFeedUrl.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtFeedUrl.Location = new System.Drawing.Point(16, 72);
			this.txtFeedUrl.Name = "txtFeedUrl";
			this.txtFeedUrl.Size = new System.Drawing.Size(448, 20);
			this.txtFeedUrl.TabIndex = 4;
			this.txtFeedUrl.Text = "";
			this.txtFeedUrl.TextChanged += new System.EventHandler(this.txtFeedUrl_TextChanged);
			// 
			// lblFeedUrl
			// 
			this.lblFeedUrl.AutoSize = true;
			this.lblFeedUrl.Location = new System.Drawing.Point(16, 56);
			this.lblFeedUrl.Name = "lblFeedUrl";
			this.lblFeedUrl.Size = new System.Drawing.Size(59, 16);
			this.lblFeedUrl.TabIndex = 3;
			this.lblFeedUrl.Text = "&Feed URL:";
			// 
			// txtOPMLUrl
			// 
			this.txtOPMLUrl.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtOPMLUrl.Location = new System.Drawing.Point(16, 120);
			this.txtOPMLUrl.Name = "txtOPMLUrl";
			this.txtOPMLUrl.Size = new System.Drawing.Size(448, 20);
			this.txtOPMLUrl.TabIndex = 6;
			this.txtOPMLUrl.Text = "";
			this.txtOPMLUrl.TextChanged += new System.EventHandler(this.txtOPMLUrl_TextChanged);
			// 
			// lblOPMLUrl
			// 
			this.lblOPMLUrl.AutoSize = true;
			this.lblOPMLUrl.Location = new System.Drawing.Point(16, 104);
			this.lblOPMLUrl.Name = "lblOPMLUrl";
			this.lblOPMLUrl.Size = new System.Drawing.Size(65, 16);
			this.lblOPMLUrl.TabIndex = 5;
			this.lblOPMLUrl.Text = "&OPML URL:";
			// 
			// frmAddNew
			// 
			this.AcceptButton = this.btnAdd;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(472, 192);
			this.Controls.Add(this.txtOPMLUrl);
			this.Controls.Add(this.lblOPMLUrl);
			this.Controls.Add(this.txtFeedUrl);
			this.Controls.Add(this.lblFeedUrl);
			this.Controls.Add(this.txtFeedTitle);
			this.Controls.Add(this.lblTitle);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnAdd);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.SizableToolWindow;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.MinimumSize = new System.Drawing.Size(480, 216);
			this.Name = "frmAddNew";
			this.ShowInTaskbar = false;
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Add New Feed";
			this.Load += new System.EventHandler(this.frmAddNew_Load);
			this.ResumeLayout(false);

		}
		#endregion
		#region EVENT_HANDLERS
		private void frmAddNew_Load(object sender, System.EventArgs e)
		{
			try
			{
				if( (nodeType & nodeTypeEnum.childNodeToOPML) == nodeTypeEnum.childNodeToOPML )
				{
					lblFeedUrl.Enabled = false;
					txtFeedUrl.Enabled = false;
					
					lblTitle.Enabled = false;
					txtFeedTitle.Enabled = false;

					lblOPMLUrl.Enabled = false;
					txtOPMLUrl.Enabled = false;
				}
				else if(  ((nodeType & nodeTypeEnum.feedNode) == nodeTypeEnum.feedNode) ||
					((nodeType & nodeTypeEnum.folderNode) == nodeTypeEnum.folderNode) )
				{
					txtOPMLUrl.Enabled = false;
					lblOPMLUrl.Enabled = false;
				}
				else if  (((nodeType & nodeTypeEnum.opmlNode) == nodeTypeEnum.opmlNode)) 
					lblFeedUrl.Text = "Main &Feed URL:";

			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			try
			{
				if(feedTitle != null)
					txtFeedTitle.Text = feedTitle;

				if(feedUrl != null)
					txtFeedUrl.Text = feedUrl;

				if(opmlUrl != null)
					txtOPMLUrl.Text = opmlUrl;

				if(feedTitle != null || feedUrl != null || opmlUrl != null)
				{
					btnAdd.Text = "&Update";
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			EnableDisbaleButtons();
		}

		private void btnAdd_Click(object sender, System.EventArgs e)
		{
			feedTitle = txtFeedTitle.Text;
			feedUrl = txtFeedUrl.Text;
			DialogResult = DialogResult.OK;
			this.Close();
		}

		private void txtFeedTitle_TextChanged(object sender, System.EventArgs e)
		{
			EnableDisbaleButtons();
		}

		private void txtFeedUrl_TextChanged(object sender, System.EventArgs e)
		{
			EnableDisbaleButtons();
		}

		private void txtOPMLUrl_TextChanged(object sender, System.EventArgs e)
		{
			EnableDisbaleButtons();
		}

		#endregion
		#region SUPPORTING FUNCTIONS
		private void EnableDisbaleButtons()
		{
			if( (nodeType & nodeTypeEnum.childNodeToOPML) == nodeTypeEnum.childNodeToOPML )
				btnAdd.Enabled = false;
			else if(  ((nodeType & nodeTypeEnum.feedNode) == nodeTypeEnum.feedNode) ||
				((nodeType & nodeTypeEnum.folderNode) == nodeTypeEnum.folderNode) )
				btnAdd.Enabled = txtFeedTitle.Text.Length > 0;
			else if  (((nodeType & nodeTypeEnum.opmlNode) == nodeTypeEnum.opmlNode)) 
				btnAdd.Enabled = txtFeedTitle.Text.Length > 0 && txtOPMLUrl.Text.Length > 0;
		}
		#endregion
	}
}
