#region USING
using System;

using System.Reflection;

using System.Threading;

using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using System.Data;

using System.Data.SqlClient;
using System.Data.SqlTypes;

using System.Xml;
using System.Xml.XPath;
using System.Xml.Xsl;

using System.Configuration;

using System.IO;
using System.Text;

using System.Runtime.InteropServices;
using MSXML2;
#endregion
namespace RSSConnect
{
	public class frmMain : System.Windows.Forms.Form
	{
		#region PRIVATE_MEMBERS
		private frmSplash splashScreen;

		private TreeNode rootNode;
		private TreeNode webSitesRootNode;
		private bool websitesTabLoaded;

		private XmlDocument feedsXMLDoc = null;
		private XmlDocument favXMLDoc = null;
		
		private string feedsFileName;
		private string favFileName;
		
		private Synchronizer threadSyncData = new Synchronizer();
	
		private Hashtable feedList;
		private Hashtable favList;
		#endregion
		#region FORMCONTROLS
		private System.Windows.Forms.NotifyIcon trayRSSConnect;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem menuItem10;
		private System.Windows.Forms.MenuItem menuFile;
		private System.Windows.Forms.MenuItem menuView;
		private System.Windows.Forms.MenuItem menuFav;
		private System.Windows.Forms.MenuItem menuAddToFav;
		private System.Windows.Forms.MenuItem menuTools;
		private System.Windows.Forms.MenuItem menuOptions;
		private System.Windows.Forms.MenuItem menuHelp;
		private System.Windows.Forms.MenuItem menuContact;
		private System.Windows.Forms.MenuItem menuAbout;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuExit;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.ImageList imagelistMisc;
		private System.Windows.Forms.ContextMenu contextMenuTree;
		private System.Windows.Forms.MenuItem tcmRefresh;
		private System.Windows.Forms.ContextMenu contextMenuTray;
		private System.Windows.Forms.MenuItem traymenuOpen;
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.MenuItem traymenuExit;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem tcmRename;
		private System.Windows.Forms.MenuItem tcmDelete;
		private System.Windows.Forms.MenuItem menuItem12;
		private System.Windows.Forms.MenuItem tcmAddToFav;
		private System.Windows.Forms.MenuItem menuItem9;
		private System.Windows.Forms.MenuItem menuSearch;
		private System.Windows.Forms.MenuItem menuCheckForNewFeeds;
		private System.Windows.Forms.MenuItem menuRefreshCurrentFeed;
		private System.Windows.Forms.MenuItem menuViewFeedListTree;
		private System.Windows.Forms.MenuItem menuViewStatusBar;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuViewHomePage;
		private System.Windows.Forms.ImageList imagelistTabs;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuViewSkin;
		private System.Windows.Forms.MenuItem tcmProperties;
		private System.Windows.Forms.MenuItem menuViewFeedXML;
		private System.Windows.Forms.MenuItem tcmAdd;
		private System.Windows.Forms.MenuItem tcmAddFeed;
		private System.Windows.Forms.MenuItem tcmAddFolder;
		private System.Windows.Forms.MenuItem menuItem11;
		private System.Windows.Forms.MenuItem menuViewFeedHTML;
		private System.Windows.Forms.MenuItem menuExport;
		private System.Windows.Forms.MenuItem menuItem13;
		private System.Windows.Forms.ContextMenu contextMenuWebsites;
		private System.Windows.Forms.MenuItem tcmWebSitesRefresh;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem tcmRefreshOPML;
		private System.Windows.Forms.MenuItem menuItem15;
		private System.Windows.Forms.MenuItem menuNewFeed;
		private System.Windows.Forms.MenuItem menuNewFolder;
		private System.Windows.Forms.Panel browserOuterPanel;
		private System.Windows.Forms.MenuItem menuViewWebNavigation;
		private System.Windows.Forms.ToolTip toolTip1;
		private System.Windows.Forms.ContextMenu contextMenuSearch;
		private System.Windows.Forms.MenuItem menuItem19;
		private System.Windows.Forms.MenuItem menuItem22;
		private System.Windows.Forms.MenuItem menuItem24;
		private System.Windows.Forms.MenuItem menuItem25;
		private System.Windows.Forms.MenuItem tcmGoogleWebSearch;
		private System.Windows.Forms.MenuItem tcmGoogleGroupsSearch;
		private System.Windows.Forms.MenuItem tcmGoogleNewsSearch;
		private System.Windows.Forms.MenuItem tcmMSDNSearch;
		private System.Windows.Forms.MenuItem tcmMSKBSearch;
		private System.Windows.Forms.MenuItem tcmIBMdWSearch;
		private System.Windows.Forms.MenuItem tcmPerfectXMLSearch;
		private System.Windows.Forms.MenuItem tcmJavaSearch;
		private System.Windows.Forms.MenuItem menuCheckAppUpdates;
		private System.Windows.Forms.MenuItem tcmExport;
		private System.Windows.Forms.MenuItem menuViewRecentSearchResults;
		private System.Windows.Forms.MenuItem menuOPMLImport;
		private System.Windows.Forms.MenuItem menuOPMLExport;
		private System.Windows.Forms.MenuItem tcmDeleteChilds;
		private System.Windows.Forms.OpenFileDialog openFileDialog;
		private System.Windows.Forms.SaveFileDialog saveFileDialog;
		private System.Windows.Forms.MenuItem menuItem14;
		private System.Windows.Forms.TabControl tabControlMain;
		private System.Windows.Forms.TabPage tabRSSFeeds;
		private System.Windows.Forms.TreeView tvFeeds;
		private System.Windows.Forms.TabPage tabWebSites;
		private System.Windows.Forms.TreeView tvWebSites;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Panel browserInnerPanel;
		private System.Windows.Forms.StatusBar statusMain;
		private System.Windows.Forms.StatusBarPanel statusBarPanelTreeInfo;
		private System.Windows.Forms.StatusBarPanel statusBarPanelBrowserDetails;
		private AxSHDocVw.AxWebBrowser axFeedReaderWebBrowser;
		private System.Windows.Forms.Panel panelBrowserNavigation;
		private System.Windows.Forms.PictureBox pictureSearch;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtSearchText;
		private System.Windows.Forms.Label lblAddress;
		private System.Windows.Forms.PictureBox pictureGO;
		private System.Windows.Forms.TextBox txtAddressBar;
		private System.Windows.Forms.PictureBox pictureForward;
		private System.Windows.Forms.PictureBox pictureBack;
		private System.Windows.Forms.MenuItem menuRefreshSkinList;
		private System.Windows.Forms.MenuItem menuItem17;
		private System.ComponentModel.IContainer components;
		#endregion
		#region CTOR_DTOR
		public frmMain()
		{
			websitesTabLoaded = false;
			feedList = new Hashtable(250);	//	initial size
			favList = new Hashtable(25);	//	initial size
			
			InitializeComponent();	// Required for Windows Form Designer support

			bool showSpashScreen = true;
			try
			{
				if (Convert.ToInt32(AppOptions.Instance.GetOption("showSplashScreen")) <= 0)
					showSpashScreen = false;
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			if(showSpashScreen)
			{
				splashScreen = new frmSplash();
				splashScreen.Show();
				Application.DoEvents();
			}
		}

		protected override void Dispose( bool disposing )	// Clean up any resources being used.
		{
			if( disposing )
				if (components != null) 
					components.Dispose();

			base.Dispose( disposing );
		}
		#endregion
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmMain));
			this.trayRSSConnect = new System.Windows.Forms.NotifyIcon(this.components);
			this.contextMenuTray = new System.Windows.Forms.ContextMenu();
			this.traymenuOpen = new System.Windows.Forms.MenuItem();
			this.menuItem8 = new System.Windows.Forms.MenuItem();
			this.traymenuExit = new System.Windows.Forms.MenuItem();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuFile = new System.Windows.Forms.MenuItem();
			this.menuItem15 = new System.Windows.Forms.MenuItem();
			this.menuNewFeed = new System.Windows.Forms.MenuItem();
			this.menuNewFolder = new System.Windows.Forms.MenuItem();
			this.menuRefreshCurrentFeed = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuOPMLImport = new System.Windows.Forms.MenuItem();
			this.menuOPMLExport = new System.Windows.Forms.MenuItem();
			this.menuItem14 = new System.Windows.Forms.MenuItem();
			this.menuExport = new System.Windows.Forms.MenuItem();
			this.menuItem13 = new System.Windows.Forms.MenuItem();
			this.menuExit = new System.Windows.Forms.MenuItem();
			this.menuView = new System.Windows.Forms.MenuItem();
			this.menuViewFeedListTree = new System.Windows.Forms.MenuItem();
			this.menuViewStatusBar = new System.Windows.Forms.MenuItem();
			this.menuViewWebNavigation = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuViewSkin = new System.Windows.Forms.MenuItem();
			this.menuRefreshSkinList = new System.Windows.Forms.MenuItem();
			this.menuItem17 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.menuViewFeedHTML = new System.Windows.Forms.MenuItem();
			this.menuViewFeedXML = new System.Windows.Forms.MenuItem();
			this.menuItem11 = new System.Windows.Forms.MenuItem();
			this.menuViewHomePage = new System.Windows.Forms.MenuItem();
			this.menuViewRecentSearchResults = new System.Windows.Forms.MenuItem();
			this.menuFav = new System.Windows.Forms.MenuItem();
			this.menuAddToFav = new System.Windows.Forms.MenuItem();
			this.menuItem10 = new System.Windows.Forms.MenuItem();
			this.menuTools = new System.Windows.Forms.MenuItem();
			this.menuOptions = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuSearch = new System.Windows.Forms.MenuItem();
			this.menuCheckForNewFeeds = new System.Windows.Forms.MenuItem();
			this.menuHelp = new System.Windows.Forms.MenuItem();
			this.menuCheckAppUpdates = new System.Windows.Forms.MenuItem();
			this.menuContact = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.menuAbout = new System.Windows.Forms.MenuItem();
			this.contextMenuTree = new System.Windows.Forms.ContextMenu();
			this.tcmRefresh = new System.Windows.Forms.MenuItem();
			this.tcmExport = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.tcmAddToFav = new System.Windows.Forms.MenuItem();
			this.menuItem12 = new System.Windows.Forms.MenuItem();
			this.tcmAdd = new System.Windows.Forms.MenuItem();
			this.tcmAddFeed = new System.Windows.Forms.MenuItem();
			this.tcmAddFolder = new System.Windows.Forms.MenuItem();
			this.tcmRename = new System.Windows.Forms.MenuItem();
			this.tcmDelete = new System.Windows.Forms.MenuItem();
			this.tcmDeleteChilds = new System.Windows.Forms.MenuItem();
			this.menuItem9 = new System.Windows.Forms.MenuItem();
			this.tcmProperties = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.tcmRefreshOPML = new System.Windows.Forms.MenuItem();
			this.imagelistMisc = new System.Windows.Forms.ImageList(this.components);
			this.contextMenuWebsites = new System.Windows.Forms.ContextMenu();
			this.tcmWebSitesRefresh = new System.Windows.Forms.MenuItem();
			this.imagelistTabs = new System.Windows.Forms.ImageList(this.components);
			this.browserOuterPanel = new System.Windows.Forms.Panel();
			this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.pictureSearch = new System.Windows.Forms.PictureBox();
			this.contextMenuSearch = new System.Windows.Forms.ContextMenu();
			this.tcmGoogleWebSearch = new System.Windows.Forms.MenuItem();
			this.tcmGoogleGroupsSearch = new System.Windows.Forms.MenuItem();
			this.tcmGoogleNewsSearch = new System.Windows.Forms.MenuItem();
			this.menuItem19 = new System.Windows.Forms.MenuItem();
			this.tcmPerfectXMLSearch = new System.Windows.Forms.MenuItem();
			this.menuItem25 = new System.Windows.Forms.MenuItem();
			this.tcmMSDNSearch = new System.Windows.Forms.MenuItem();
			this.tcmMSKBSearch = new System.Windows.Forms.MenuItem();
			this.menuItem22 = new System.Windows.Forms.MenuItem();
			this.tcmIBMdWSearch = new System.Windows.Forms.MenuItem();
			this.menuItem24 = new System.Windows.Forms.MenuItem();
			this.tcmJavaSearch = new System.Windows.Forms.MenuItem();
			this.pictureGO = new System.Windows.Forms.PictureBox();
			this.pictureForward = new System.Windows.Forms.PictureBox();
			this.pictureBack = new System.Windows.Forms.PictureBox();
			this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
			this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
			this.statusMain = new System.Windows.Forms.StatusBar();
			this.statusBarPanelTreeInfo = new System.Windows.Forms.StatusBarPanel();
			this.statusBarPanelBrowserDetails = new System.Windows.Forms.StatusBarPanel();
			this.tabControlMain = new System.Windows.Forms.TabControl();
			this.tabRSSFeeds = new System.Windows.Forms.TabPage();
			this.tvFeeds = new System.Windows.Forms.TreeView();
			this.tabWebSites = new System.Windows.Forms.TabPage();
			this.tvWebSites = new System.Windows.Forms.TreeView();
			this.browserInnerPanel = new System.Windows.Forms.Panel();
			this.axFeedReaderWebBrowser = new AxSHDocVw.AxWebBrowser();
			this.panelBrowserNavigation = new System.Windows.Forms.Panel();
			this.label1 = new System.Windows.Forms.Label();
			this.txtSearchText = new System.Windows.Forms.TextBox();
			this.lblAddress = new System.Windows.Forms.Label();
			this.txtAddressBar = new System.Windows.Forms.TextBox();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanelTreeInfo)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanelBrowserDetails)).BeginInit();
			this.tabControlMain.SuspendLayout();
			this.tabRSSFeeds.SuspendLayout();
			this.tabWebSites.SuspendLayout();
			this.browserInnerPanel.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.axFeedReaderWebBrowser)).BeginInit();
			this.panelBrowserNavigation.SuspendLayout();
			this.SuspendLayout();
			// 
			// trayRSSConnect
			// 
			this.trayRSSConnect.ContextMenu = this.contextMenuTray;
			this.trayRSSConnect.Icon = ((System.Drawing.Icon)(resources.GetObject("trayRSSConnect.Icon")));
			this.trayRSSConnect.Text = "RSSConnect by PerfectXML.com";
			this.trayRSSConnect.DoubleClick += new System.EventHandler(this.trayRSSConnect_DoubleClick);
			// 
			// contextMenuTray
			// 
			this.contextMenuTray.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							this.traymenuOpen,
																							this.menuItem8,
																							this.traymenuExit});
			// 
			// traymenuOpen
			// 
			this.traymenuOpen.Index = 0;
			this.traymenuOpen.Text = "&Open RSSConnect...";
			this.traymenuOpen.Click += new System.EventHandler(this.traymenuOpen_Click);
			// 
			// menuItem8
			// 
			this.menuItem8.Index = 1;
			this.menuItem8.Text = "-";
			// 
			// traymenuExit
			// 
			this.traymenuExit.Index = 2;
			this.traymenuExit.Text = "E&xit";
			this.traymenuExit.Click += new System.EventHandler(this.traymenuExit_Click);
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuFile,
																					  this.menuView,
																					  this.menuFav,
																					  this.menuTools,
																					  this.menuHelp});
			// 
			// menuFile
			// 
			this.menuFile.Index = 0;
			this.menuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuItem15,
																					 this.menuRefreshCurrentFeed,
																					 this.menuItem1,
																					 this.menuOPMLImport,
																					 this.menuOPMLExport,
																					 this.menuItem14,
																					 this.menuExport,
																					 this.menuItem13,
																					 this.menuExit});
			this.menuFile.Text = "&File";
			this.menuFile.Popup += new System.EventHandler(this.menuFile_Popup);
			// 
			// menuItem15
			// 
			this.menuItem15.Index = 0;
			this.menuItem15.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.menuNewFeed,
																					   this.menuNewFolder});
			this.menuItem15.Text = "&New";
			// 
			// menuNewFeed
			// 
			this.menuNewFeed.Index = 0;
			this.menuNewFeed.Shortcut = System.Windows.Forms.Shortcut.CtrlN;
			this.menuNewFeed.Text = "&Feed";
			this.menuNewFeed.Click += new System.EventHandler(this.menuNewFeed_Click);
			// 
			// menuNewFolder
			// 
			this.menuNewFolder.Index = 1;
			this.menuNewFolder.Shortcut = System.Windows.Forms.Shortcut.CtrlShiftN;
			this.menuNewFolder.Text = "F&older";
			this.menuNewFolder.Click += new System.EventHandler(this.menuNewFolder_Click);
			// 
			// menuRefreshCurrentFeed
			// 
			this.menuRefreshCurrentFeed.Index = 1;
			this.menuRefreshCurrentFeed.Shortcut = System.Windows.Forms.Shortcut.F5;
			this.menuRefreshCurrentFeed.Text = "&Refresh Current Feed";
			this.menuRefreshCurrentFeed.Click += new System.EventHandler(this.menuRefreshCurrentFeed_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 2;
			this.menuItem1.Text = "-";
			// 
			// menuOPMLImport
			// 
			this.menuOPMLImport.Index = 3;
			this.menuOPMLImport.Text = "&Import Local OPML File...";
			this.menuOPMLImport.Click += new System.EventHandler(this.menuOPMLImport_Click);
			// 
			// menuOPMLExport
			// 
			this.menuOPMLExport.Index = 4;
			this.menuOPMLExport.Text = "&Export as OPML File...";
			this.menuOPMLExport.Click += new System.EventHandler(this.menuOPMLExport_Click);
			// 
			// menuItem14
			// 
			this.menuItem14.Index = 5;
			this.menuItem14.Text = "-";
			// 
			// menuExport
			// 
			this.menuExport.Index = 6;
			this.menuExport.Text = "&Export to Database";
			this.menuExport.Click += new System.EventHandler(this.menuExport_Click);
			// 
			// menuItem13
			// 
			this.menuItem13.Index = 7;
			this.menuItem13.Text = "-";
			// 
			// menuExit
			// 
			this.menuExit.Index = 8;
			this.menuExit.Text = "E&xit";
			this.menuExit.Click += new System.EventHandler(this.menuExit_Click);
			// 
			// menuView
			// 
			this.menuView.Index = 1;
			this.menuView.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuViewFeedListTree,
																					 this.menuViewStatusBar,
																					 this.menuViewWebNavigation,
																					 this.menuItem3,
																					 this.menuViewSkin,
																					 this.menuItem5,
																					 this.menuViewFeedHTML,
																					 this.menuViewFeedXML,
																					 this.menuItem11,
																					 this.menuViewHomePage,
																					 this.menuViewRecentSearchResults});
			this.menuView.Text = "&View";
			this.menuView.Popup += new System.EventHandler(this.menuView_Popup);
			// 
			// menuViewFeedListTree
			// 
			this.menuViewFeedListTree.Checked = true;
			this.menuViewFeedListTree.Index = 0;
			this.menuViewFeedListTree.Shortcut = System.Windows.Forms.Shortcut.F11;
			this.menuViewFeedListTree.Text = "&Feeds / Web sites Tree";
			this.menuViewFeedListTree.Click += new System.EventHandler(this.menuViewFeedListTree_Click);
			// 
			// menuViewStatusBar
			// 
			this.menuViewStatusBar.Checked = true;
			this.menuViewStatusBar.Index = 1;
			this.menuViewStatusBar.Shortcut = System.Windows.Forms.Shortcut.F12;
			this.menuViewStatusBar.Text = "&Status Bar";
			this.menuViewStatusBar.Click += new System.EventHandler(this.menuViewStatusBar_Click);
			// 
			// menuViewWebNavigation
			// 
			this.menuViewWebNavigation.Checked = true;
			this.menuViewWebNavigation.Index = 2;
			this.menuViewWebNavigation.Shortcut = System.Windows.Forms.Shortcut.Ctrl0;
			this.menuViewWebNavigation.Text = "&Browser Navigation Bar";
			this.menuViewWebNavigation.Click += new System.EventHandler(this.menuViewWebNavigation_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 3;
			this.menuItem3.Text = "-";
			// 
			// menuViewSkin
			// 
			this.menuViewSkin.Index = 4;
			this.menuViewSkin.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.menuRefreshSkinList,
																						 this.menuItem17});
			this.menuViewSkin.Text = "Sk&in";
			// 
			// menuRefreshSkinList
			// 
			this.menuRefreshSkinList.Index = 0;
			this.menuRefreshSkinList.Text = "&Refresh this Skin Files List";
			this.menuRefreshSkinList.Click += new System.EventHandler(this.menuRefreshSkinList_Click);
			// 
			// menuItem17
			// 
			this.menuItem17.Index = 1;
			this.menuItem17.Text = "-";
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 5;
			this.menuItem5.Text = "-";
			// 
			// menuViewFeedHTML
			// 
			this.menuViewFeedHTML.Checked = true;
			this.menuViewFeedHTML.Index = 6;
			this.menuViewFeedHTML.Shortcut = System.Windows.Forms.Shortcut.CtrlH;
			this.menuViewFeedHTML.Text = "Feed as &HTML";
			this.menuViewFeedHTML.Click += new System.EventHandler(this.menuViewFeedHTML_Click);
			// 
			// menuViewFeedXML
			// 
			this.menuViewFeedXML.Index = 7;
			this.menuViewFeedXML.Shortcut = System.Windows.Forms.Shortcut.CtrlX;
			this.menuViewFeedXML.Text = "Feed as &XML";
			this.menuViewFeedXML.Click += new System.EventHandler(this.menuViewFeedXML_Click);
			// 
			// menuItem11
			// 
			this.menuItem11.Index = 8;
			this.menuItem11.Text = "-";
			// 
			// menuViewHomePage
			// 
			this.menuViewHomePage.Index = 9;
			this.menuViewHomePage.Text = "&Home Page";
			this.menuViewHomePage.Click += new System.EventHandler(this.menuViewHomePage_Click);
			// 
			// menuViewRecentSearchResults
			// 
			this.menuViewRecentSearchResults.Index = 10;
			this.menuViewRecentSearchResults.Text = "&Recent Search Results";
			this.menuViewRecentSearchResults.Click += new System.EventHandler(this.menuViewRecentSearchResults_Click);
			// 
			// menuFav
			// 
			this.menuFav.Index = 2;
			this.menuFav.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.menuAddToFav,
																					this.menuItem10});
			this.menuFav.Text = "F&avorites";
			this.menuFav.Popup += new System.EventHandler(this.menuFav_Popup);
			// 
			// menuAddToFav
			// 
			this.menuAddToFav.Index = 0;
			this.menuAddToFav.Shortcut = System.Windows.Forms.Shortcut.CtrlD;
			this.menuAddToFav.Text = "&Add to Favorites";
			this.menuAddToFav.Click += new System.EventHandler(this.menuAddToFav_Click);
			// 
			// menuItem10
			// 
			this.menuItem10.Index = 1;
			this.menuItem10.Text = "-";
			// 
			// menuTools
			// 
			this.menuTools.Index = 3;
			this.menuTools.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuOptions,
																					  this.menuItem2,
																					  this.menuSearch,
																					  this.menuCheckForNewFeeds});
			this.menuTools.Text = "&Tools";
			// 
			// menuOptions
			// 
			this.menuOptions.Index = 0;
			this.menuOptions.Text = "&Options...";
			this.menuOptions.Click += new System.EventHandler(this.menuOptions_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 1;
			this.menuItem2.Text = "-";
			// 
			// menuSearch
			// 
			this.menuSearch.Index = 2;
			this.menuSearch.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
			this.menuSearch.Text = "&Search...";
			this.menuSearch.Click += new System.EventHandler(this.menuSearch_Click);
			// 
			// menuCheckForNewFeeds
			// 
			this.menuCheckForNewFeeds.Index = 3;
			this.menuCheckForNewFeeds.Text = "&Check for New Feeds...";
			this.menuCheckForNewFeeds.Click += new System.EventHandler(this.menuCheckForNewFeeds_Click);
			// 
			// menuHelp
			// 
			this.menuHelp.Index = 4;
			this.menuHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuCheckAppUpdates,
																					 this.menuContact,
																					 this.menuItem6,
																					 this.menuAbout});
			this.menuHelp.Text = "&Help";
			// 
			// menuCheckAppUpdates
			// 
			this.menuCheckAppUpdates.Index = 0;
			this.menuCheckAppUpdates.Text = "&Check for Updates";
			this.menuCheckAppUpdates.Click += new System.EventHandler(this.menuCheckAppUpdates_Click);
			// 
			// menuContact
			// 
			this.menuContact.Index = 1;
			this.menuContact.Text = "Contact &PerfectXML.com...";
			this.menuContact.Click += new System.EventHandler(this.menuContact_Click);
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 2;
			this.menuItem6.Text = "-";
			// 
			// menuAbout
			// 
			this.menuAbout.Index = 3;
			this.menuAbout.Text = "&About RSSConnect...";
			this.menuAbout.Click += new System.EventHandler(this.menuAbout_Click);
			// 
			// contextMenuTree
			// 
			this.contextMenuTree.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							this.tcmRefresh,
																							this.tcmExport,
																							this.menuItem4,
																							this.tcmAddToFav,
																							this.menuItem12,
																							this.tcmAdd,
																							this.tcmRename,
																							this.tcmDelete,
																							this.tcmDeleteChilds,
																							this.menuItem9,
																							this.tcmProperties,
																							this.menuItem7,
																							this.tcmRefreshOPML});
			this.contextMenuTree.Popup += new System.EventHandler(this.contextMenuTree_Popup);
			// 
			// tcmRefresh
			// 
			this.tcmRefresh.Index = 0;
			this.tcmRefresh.Shortcut = System.Windows.Forms.Shortcut.F5;
			this.tcmRefresh.Text = "&Refresh";
			this.tcmRefresh.Click += new System.EventHandler(this.tcmRefresh_Click);
			// 
			// tcmExport
			// 
			this.tcmExport.Index = 1;
			this.tcmExport.Text = "&Export to Database";
			this.tcmExport.Click += new System.EventHandler(this.tcmExport_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 2;
			this.menuItem4.Text = "-";
			// 
			// tcmAddToFav
			// 
			this.tcmAddToFav.Index = 3;
			this.tcmAddToFav.Shortcut = System.Windows.Forms.Shortcut.CtrlD;
			this.tcmAddToFav.Text = "Add to &Favorites";
			this.tcmAddToFav.Click += new System.EventHandler(this.tcmAddToFav_Click);
			// 
			// menuItem12
			// 
			this.menuItem12.Index = 4;
			this.menuItem12.Text = "-";
			// 
			// tcmAdd
			// 
			this.tcmAdd.Index = 5;
			this.tcmAdd.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																				   this.tcmAddFeed,
																				   this.tcmAddFolder});
			this.tcmAdd.Text = "&Add";
			// 
			// tcmAddFeed
			// 
			this.tcmAddFeed.Index = 0;
			this.tcmAddFeed.Shortcut = System.Windows.Forms.Shortcut.CtrlN;
			this.tcmAddFeed.Text = "&Feed...";
			this.tcmAddFeed.Click += new System.EventHandler(this.tcmAddFeed_Click);
			// 
			// tcmAddFolder
			// 
			this.tcmAddFolder.Index = 1;
			this.tcmAddFolder.Shortcut = System.Windows.Forms.Shortcut.CtrlShiftN;
			this.tcmAddFolder.Text = "F&older...";
			this.tcmAddFolder.Click += new System.EventHandler(this.tcmAddFolder_Click);
			// 
			// tcmRename
			// 
			this.tcmRename.Index = 6;
			this.tcmRename.Shortcut = System.Windows.Forms.Shortcut.F2;
			this.tcmRename.Text = "Re&name";
			this.tcmRename.Click += new System.EventHandler(this.tcmRename_Click);
			// 
			// tcmDelete
			// 
			this.tcmDelete.Index = 7;
			this.tcmDelete.Shortcut = System.Windows.Forms.Shortcut.Del;
			this.tcmDelete.Text = "&Delete this Node";
			this.tcmDelete.Click += new System.EventHandler(this.tcmDelete_Click);
			// 
			// tcmDeleteChilds
			// 
			this.tcmDeleteChilds.Index = 8;
			this.tcmDeleteChilds.Text = "Delete &Child Nodes";
			this.tcmDeleteChilds.Click += new System.EventHandler(this.tcmDeleteChilds_Click);
			// 
			// menuItem9
			// 
			this.menuItem9.Index = 9;
			this.menuItem9.Text = "-";
			// 
			// tcmProperties
			// 
			this.tcmProperties.Index = 10;
			this.tcmProperties.Text = "&Properties...";
			this.tcmProperties.Click += new System.EventHandler(this.tcmProperties_Click);
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 11;
			this.menuItem7.Text = "-";
			// 
			// tcmRefreshOPML
			// 
			this.tcmRefreshOPML.Enabled = false;
			this.tcmRefreshOPML.Index = 12;
			this.tcmRefreshOPML.Text = "Refresh &OPML List";
			this.tcmRefreshOPML.Click += new System.EventHandler(this.tcmRefreshOPML_Click);
			// 
			// imagelistMisc
			// 
			this.imagelistMisc.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit;
			this.imagelistMisc.ImageSize = new System.Drawing.Size(16, 16);
			this.imagelistMisc.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imagelistMisc.ImageStream")));
			this.imagelistMisc.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// contextMenuWebsites
			// 
			this.contextMenuWebsites.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																								this.tcmWebSitesRefresh});
			this.contextMenuWebsites.Popup += new System.EventHandler(this.contextMenuWebsites_Popup);
			// 
			// tcmWebSitesRefresh
			// 
			this.tcmWebSitesRefresh.Index = 0;
			this.tcmWebSitesRefresh.Text = "&Refresh";
			this.tcmWebSitesRefresh.Click += new System.EventHandler(this.tcmWebSitesRefresh_Click);
			// 
			// imagelistTabs
			// 
			this.imagelistTabs.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit;
			this.imagelistTabs.ImageSize = new System.Drawing.Size(18, 18);
			this.imagelistTabs.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imagelistTabs.ImageStream")));
			this.imagelistTabs.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// browserOuterPanel
			// 
			this.browserOuterPanel.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(123)), ((System.Byte)(150)), ((System.Byte)(222)));
			this.browserOuterPanel.Dock = System.Windows.Forms.DockStyle.Fill;
			this.browserOuterPanel.Location = new System.Drawing.Point(0, 0);
			this.browserOuterPanel.Name = "browserOuterPanel";
			this.browserOuterPanel.Size = new System.Drawing.Size(688, 377);
			this.browserOuterPanel.TabIndex = 11;
			// 
			// splitter1
			// 
			this.splitter1.BackColor = System.Drawing.Color.Gray;
			this.splitter1.Location = new System.Drawing.Point(232, 0);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(3, 355);
			this.splitter1.TabIndex = 14;
			this.splitter1.TabStop = false;
			this.toolTip1.SetToolTip(this.splitter1, "Double click here to hide the tree");
			this.splitter1.DoubleClick += new System.EventHandler(this.splitter1_DoubleClick);
			// 
			// pictureSearch
			// 
			this.pictureSearch.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.pictureSearch.BackColor = System.Drawing.SystemColors.Control;
			this.pictureSearch.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("pictureSearch.BackgroundImage")));
			this.pictureSearch.ContextMenu = this.contextMenuSearch;
			this.pictureSearch.Cursor = System.Windows.Forms.Cursors.Hand;
			this.pictureSearch.Location = new System.Drawing.Point(408, 3);
			this.pictureSearch.Name = "pictureSearch";
			this.pictureSearch.Size = new System.Drawing.Size(35, 36);
			this.pictureSearch.TabIndex = 6;
			this.pictureSearch.TabStop = false;
			this.toolTip1.SetToolTip(this.pictureSearch, "Search...");
			this.pictureSearch.Click += new System.EventHandler(this.pictureSearch_Click);
			// 
			// contextMenuSearch
			// 
			this.contextMenuSearch.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							  this.tcmGoogleWebSearch,
																							  this.tcmGoogleGroupsSearch,
																							  this.tcmGoogleNewsSearch,
																							  this.menuItem19,
																							  this.tcmPerfectXMLSearch,
																							  this.menuItem25,
																							  this.tcmMSDNSearch,
																							  this.tcmMSKBSearch,
																							  this.menuItem22,
																							  this.tcmIBMdWSearch,
																							  this.menuItem24,
																							  this.tcmJavaSearch});
			this.contextMenuSearch.Popup += new System.EventHandler(this.contextMenuSearch_Popup);
			// 
			// tcmGoogleWebSearch
			// 
			this.tcmGoogleWebSearch.Index = 0;
			this.tcmGoogleWebSearch.Text = "Google &Web";
			this.tcmGoogleWebSearch.Click += new System.EventHandler(this.tcmGoogleWebSearch_Click);
			// 
			// tcmGoogleGroupsSearch
			// 
			this.tcmGoogleGroupsSearch.Index = 1;
			this.tcmGoogleGroupsSearch.Text = "Google &Groups";
			this.tcmGoogleGroupsSearch.Click += new System.EventHandler(this.tcmGoogleGroupsSearch_Click);
			// 
			// tcmGoogleNewsSearch
			// 
			this.tcmGoogleNewsSearch.Index = 2;
			this.tcmGoogleNewsSearch.Text = "Google &News";
			this.tcmGoogleNewsSearch.Click += new System.EventHandler(this.tcmGoogleNewsSearch_Click);
			// 
			// menuItem19
			// 
			this.menuItem19.Index = 3;
			this.menuItem19.Text = "-";
			// 
			// tcmPerfectXMLSearch
			// 
			this.tcmPerfectXMLSearch.Checked = true;
			this.tcmPerfectXMLSearch.Index = 4;
			this.tcmPerfectXMLSearch.Text = "&PerfectXML.com";
			this.tcmPerfectXMLSearch.Click += new System.EventHandler(this.tcmPerfectXMLSearch_Click);
			// 
			// menuItem25
			// 
			this.menuItem25.Index = 5;
			this.menuItem25.Text = "-";
			// 
			// tcmMSDNSearch
			// 
			this.tcmMSDNSearch.Index = 6;
			this.tcmMSDNSearch.Text = "&MSDN";
			this.tcmMSDNSearch.Click += new System.EventHandler(this.tcmMSDNSearch_Click);
			// 
			// tcmMSKBSearch
			// 
			this.tcmMSKBSearch.Index = 7;
			this.tcmMSKBSearch.Text = "Microsoft &KB Articles";
			this.tcmMSKBSearch.Click += new System.EventHandler(this.tcmMSKBSearch_Click);
			// 
			// menuItem22
			// 
			this.menuItem22.Index = 8;
			this.menuItem22.Text = "-";
			// 
			// tcmIBMdWSearch
			// 
			this.tcmIBMdWSearch.Index = 9;
			this.tcmIBMdWSearch.Text = "IBM &developerWorks";
			this.tcmIBMdWSearch.Click += new System.EventHandler(this.tcmIBMdWSearch_Click);
			// 
			// menuItem24
			// 
			this.menuItem24.Index = 10;
			this.menuItem24.Text = "-";
			// 
			// tcmJavaSearch
			// 
			this.tcmJavaSearch.Index = 11;
			this.tcmJavaSearch.Text = "java.&sun.com";
			this.tcmJavaSearch.Click += new System.EventHandler(this.tcmJavaSearch_Click);
			// 
			// pictureGO
			// 
			this.pictureGO.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.pictureGO.BackColor = System.Drawing.SystemColors.Control;
			this.pictureGO.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("pictureGO.BackgroundImage")));
			this.pictureGO.Cursor = System.Windows.Forms.Cursors.Hand;
			this.pictureGO.Location = new System.Drawing.Point(224, 14);
			this.pictureGO.Name = "pictureGO";
			this.pictureGO.Size = new System.Drawing.Size(22, 22);
			this.pictureGO.TabIndex = 3;
			this.pictureGO.TabStop = false;
			this.toolTip1.SetToolTip(this.pictureGO, "GO");
			this.pictureGO.Click += new System.EventHandler(this.pictureGO_Click);
			// 
			// pictureForward
			// 
			this.pictureForward.BackColor = System.Drawing.SystemColors.Control;
			this.pictureForward.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("pictureForward.BackgroundImage")));
			this.pictureForward.Cursor = System.Windows.Forms.Cursors.Hand;
			this.pictureForward.Location = new System.Drawing.Point(44, 5);
			this.pictureForward.Name = "pictureForward";
			this.pictureForward.Size = new System.Drawing.Size(55, 31);
			this.pictureForward.TabIndex = 1;
			this.pictureForward.TabStop = false;
			this.toolTip1.SetToolTip(this.pictureForward, "Forward");
			this.pictureForward.Click += new System.EventHandler(this.pictureForward_Click);
			// 
			// pictureBack
			// 
			this.pictureBack.BackColor = System.Drawing.SystemColors.Control;
			this.pictureBack.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("pictureBack.BackgroundImage")));
			this.pictureBack.Cursor = System.Windows.Forms.Cursors.Hand;
			this.pictureBack.Location = new System.Drawing.Point(2, 4);
			this.pictureBack.Name = "pictureBack";
			this.pictureBack.Size = new System.Drawing.Size(37, 31);
			this.pictureBack.TabIndex = 0;
			this.pictureBack.TabStop = false;
			this.toolTip1.SetToolTip(this.pictureBack, "Back");
			this.pictureBack.Click += new System.EventHandler(this.pictureBack_Click);
			// 
			// openFileDialog
			// 
			this.openFileDialog.DefaultExt = "opml";
			this.openFileDialog.Filter = "OPML files (*.opml)|*.opml|All files (*.*)|*.*";
			this.openFileDialog.RestoreDirectory = true;
			this.openFileDialog.Title = "Select OPML File to Import into RSSConnect";
			// 
			// saveFileDialog
			// 
			this.saveFileDialog.DefaultExt = "opml";
			this.saveFileDialog.Filter = "OPML files (*.opml)|*.opml|All files (*.*)|*.*";
			this.saveFileDialog.RestoreDirectory = true;
			// 
			// statusMain
			// 
			this.statusMain.Location = new System.Drawing.Point(0, 355);
			this.statusMain.Name = "statusMain";
			this.statusMain.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																						  this.statusBarPanelTreeInfo,
																						  this.statusBarPanelBrowserDetails});
			this.statusMain.ShowPanels = true;
			this.statusMain.Size = new System.Drawing.Size(688, 22);
			this.statusMain.SizingGrip = false;
			this.statusMain.TabIndex = 12;
			// 
			// statusBarPanelTreeInfo
			// 
			this.statusBarPanelTreeInfo.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents;
			this.statusBarPanelTreeInfo.MinWidth = 320;
			this.statusBarPanelTreeInfo.Text = "Ready";
			this.statusBarPanelTreeInfo.Width = 320;
			// 
			// statusBarPanelBrowserDetails
			// 
			this.statusBarPanelBrowserDetails.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.statusBarPanelBrowserDetails.Width = 368;
			// 
			// tabControlMain
			// 
			this.tabControlMain.Alignment = System.Windows.Forms.TabAlignment.Bottom;
			this.tabControlMain.Controls.Add(this.tabRSSFeeds);
			this.tabControlMain.Controls.Add(this.tabWebSites);
			this.tabControlMain.Dock = System.Windows.Forms.DockStyle.Left;
			this.tabControlMain.ImageList = this.imagelistTabs;
			this.tabControlMain.Location = new System.Drawing.Point(0, 0);
			this.tabControlMain.Name = "tabControlMain";
			this.tabControlMain.SelectedIndex = 0;
			this.tabControlMain.ShowToolTips = true;
			this.tabControlMain.Size = new System.Drawing.Size(232, 355);
			this.tabControlMain.TabIndex = 13;
			this.tabControlMain.SelectedIndexChanged += new System.EventHandler(this.tabControlMain_SelectedIndexChanged);
			// 
			// tabRSSFeeds
			// 
			this.tabRSSFeeds.BackColor = System.Drawing.SystemColors.Control;
			this.tabRSSFeeds.Controls.Add(this.tvFeeds);
			this.tabRSSFeeds.ImageIndex = 1;
			this.tabRSSFeeds.Location = new System.Drawing.Point(4, 4);
			this.tabRSSFeeds.Name = "tabRSSFeeds";
			this.tabRSSFeeds.Size = new System.Drawing.Size(224, 326);
			this.tabRSSFeeds.TabIndex = 0;
			this.tabRSSFeeds.Text = "RSS Feeds";
			this.tabRSSFeeds.ToolTipText = "View RSS Feeds";
			// 
			// tvFeeds
			// 
			this.tvFeeds.AllowDrop = true;
			this.tvFeeds.ContextMenu = this.contextMenuTree;
			this.tvFeeds.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tvFeeds.HideSelection = false;
			this.tvFeeds.ImageIndex = 1;
			this.tvFeeds.ImageList = this.imagelistMisc;
			this.tvFeeds.Indent = 19;
			this.tvFeeds.LabelEdit = true;
			this.tvFeeds.Location = new System.Drawing.Point(0, 0);
			this.tvFeeds.Name = "tvFeeds";
			this.tvFeeds.Nodes.AddRange(new System.Windows.Forms.TreeNode[] {
																				new System.Windows.Forms.TreeNode("RSSConnect", 0, 0)});
			this.tvFeeds.SelectedImageIndex = 1;
			this.tvFeeds.ShowLines = false;
			this.tvFeeds.Size = new System.Drawing.Size(224, 326);
			this.tvFeeds.TabIndex = 7;
			this.tvFeeds.DragOver += new System.Windows.Forms.DragEventHandler(this.tvFeeds_DragOver);
			this.tvFeeds.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.tvFeeds_AfterSelect);
			this.tvFeeds.AfterLabelEdit += new System.Windows.Forms.NodeLabelEditEventHandler(this.tvFeeds_AfterLabelEdit);
			this.tvFeeds.DragEnter += new System.Windows.Forms.DragEventHandler(this.tvFeeds_DragEnter);
			this.tvFeeds.ItemDrag += new System.Windows.Forms.ItemDragEventHandler(this.tvFeeds_ItemDrag);
			this.tvFeeds.DragDrop += new System.Windows.Forms.DragEventHandler(this.tvFeeds_DragDrop);
			// 
			// tabWebSites
			// 
			this.tabWebSites.BackColor = System.Drawing.SystemColors.Control;
			this.tabWebSites.Controls.Add(this.tvWebSites);
			this.tabWebSites.ImageIndex = 0;
			this.tabWebSites.Location = new System.Drawing.Point(4, 4);
			this.tabWebSites.Name = "tabWebSites";
			this.tabWebSites.Size = new System.Drawing.Size(224, 326);
			this.tabWebSites.TabIndex = 1;
			this.tabWebSites.Text = "Web Sites";
			this.tabWebSites.ToolTipText = "View Favorites Web sites";
			this.tabWebSites.Visible = false;
			// 
			// tvWebSites
			// 
			this.tvWebSites.ContextMenu = this.contextMenuWebsites;
			this.tvWebSites.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tvWebSites.HideSelection = false;
			this.tvWebSites.ImageList = this.imagelistTabs;
			this.tvWebSites.Indent = 19;
			this.tvWebSites.Location = new System.Drawing.Point(0, 0);
			this.tvWebSites.Name = "tvWebSites";
			this.tvWebSites.Nodes.AddRange(new System.Windows.Forms.TreeNode[] {
																				   new System.Windows.Forms.TreeNode("Web Sites", 0, 0)});
			this.tvWebSites.ShowLines = false;
			this.tvWebSites.Size = new System.Drawing.Size(224, 326);
			this.tvWebSites.TabIndex = 0;
			this.tvWebSites.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.tvWebSites_AfterSelect);
			// 
			// browserInnerPanel
			// 
			this.browserInnerPanel.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(123)), ((System.Byte)(150)), ((System.Byte)(222)));
			this.browserInnerPanel.Controls.Add(this.axFeedReaderWebBrowser);
			this.browserInnerPanel.Controls.Add(this.panelBrowserNavigation);
			this.browserInnerPanel.Dock = System.Windows.Forms.DockStyle.Fill;
			this.browserInnerPanel.DockPadding.All = 3;
			this.browserInnerPanel.Location = new System.Drawing.Point(235, 0);
			this.browserInnerPanel.Name = "browserInnerPanel";
			this.browserInnerPanel.Size = new System.Drawing.Size(453, 355);
			this.browserInnerPanel.TabIndex = 15;
			// 
			// axFeedReaderWebBrowser
			// 
			this.axFeedReaderWebBrowser.ContainingControl = this;
			this.axFeedReaderWebBrowser.Dock = System.Windows.Forms.DockStyle.Fill;
			this.axFeedReaderWebBrowser.Enabled = true;
			this.axFeedReaderWebBrowser.Location = new System.Drawing.Point(3, 3);
			this.axFeedReaderWebBrowser.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("axFeedReaderWebBrowser.OcxState")));
			this.axFeedReaderWebBrowser.Size = new System.Drawing.Size(447, 309);
			this.axFeedReaderWebBrowser.TabIndex = 1;
			this.axFeedReaderWebBrowser.StatusTextChange += new AxSHDocVw.DWebBrowserEvents2_StatusTextChangeEventHandler(this.axFeedReaderWebBrowser_StatusTextChange);
			// 
			// panelBrowserNavigation
			// 
			this.panelBrowserNavigation.BackColor = System.Drawing.Color.White;
			this.panelBrowserNavigation.Controls.Add(this.pictureSearch);
			this.panelBrowserNavigation.Controls.Add(this.label1);
			this.panelBrowserNavigation.Controls.Add(this.txtSearchText);
			this.panelBrowserNavigation.Controls.Add(this.lblAddress);
			this.panelBrowserNavigation.Controls.Add(this.pictureGO);
			this.panelBrowserNavigation.Controls.Add(this.txtAddressBar);
			this.panelBrowserNavigation.Controls.Add(this.pictureForward);
			this.panelBrowserNavigation.Controls.Add(this.pictureBack);
			this.panelBrowserNavigation.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.panelBrowserNavigation.Location = new System.Drawing.Point(3, 312);
			this.panelBrowserNavigation.Name = "panelBrowserNavigation";
			this.panelBrowserNavigation.Size = new System.Drawing.Size(447, 40);
			this.panelBrowserNavigation.TabIndex = 0;
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.label1.Location = new System.Drawing.Point(261, 1);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(48, 12);
			this.label1.TabIndex = 5;
			this.label1.Text = "&Search";
			// 
			// txtSearchText
			// 
			this.txtSearchText.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.txtSearchText.BackColor = System.Drawing.SystemColors.Window;
			this.txtSearchText.Location = new System.Drawing.Point(262, 16);
			this.txtSearchText.Name = "txtSearchText";
			this.txtSearchText.Size = new System.Drawing.Size(144, 20);
			this.txtSearchText.TabIndex = 4;
			this.txtSearchText.Text = "";
			this.txtSearchText.KeyUp += new System.Windows.Forms.KeyEventHandler(this.txtSearchText_KeyUp);
			// 
			// lblAddress
			// 
			this.lblAddress.Location = new System.Drawing.Point(110, 1);
			this.lblAddress.Name = "lblAddress";
			this.lblAddress.Size = new System.Drawing.Size(48, 12);
			this.lblAddress.TabIndex = 2;
			this.lblAddress.Text = "A&ddress";
			// 
			// txtAddressBar
			// 
			this.txtAddressBar.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtAddressBar.BackColor = System.Drawing.SystemColors.Window;
			this.txtAddressBar.Location = new System.Drawing.Point(112, 16);
			this.txtAddressBar.Name = "txtAddressBar";
			this.txtAddressBar.Size = new System.Drawing.Size(111, 20);
			this.txtAddressBar.TabIndex = 3;
			this.txtAddressBar.Text = "";
			this.txtAddressBar.KeyUp += new System.Windows.Forms.KeyEventHandler(this.txtAddressBar_KeyUp);
			// 
			// frmMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(688, 377);
			this.Controls.Add(this.browserInnerPanel);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.tabControlMain);
			this.Controls.Add(this.statusMain);
			this.Controls.Add(this.browserOuterPanel);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu1;
			this.Name = "frmMain";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.Text = "RSSConnect by PerfectXML.com";
			this.Resize += new System.EventHandler(this.frmMain_Resize);
			this.Closing += new System.ComponentModel.CancelEventHandler(this.frmMain_Closing);
			this.Load += new System.EventHandler(this.frmMain_Load);
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanelTreeInfo)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanelBrowserDetails)).EndInit();
			this.tabControlMain.ResumeLayout(false);
			this.tabRSSFeeds.ResumeLayout(false);
			this.tabWebSites.ResumeLayout(false);
			this.browserInnerPanel.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.axFeedReaderWebBrowser)).EndInit();
			this.panelBrowserNavigation.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion
		#region MAIN
		[STAThread]
		static void Main() 
		{
			DebugLog.Instance.BeginLog(Application.ExecutablePath + ".log");
			
			Application.Run(new frmMain());
			
			DebugLog.Instance.EndLog();
		}
		#endregion
		#region EVENT_HANDLERS (Private functions)

		#region FORM_LOAD_UNLOAD
		private void frmMain_Load(object sender, System.EventArgs e)
		{
			try
			{
				statusBarPanelTreeInfo.Text = "Please wait...";
				Cursor = Cursors.WaitCursor;
				PrepareUI();
				Application.ApplicationExit += new EventHandler(this.ExitApplication);
			}
			catch(Exception exp)
			{
				DebugLog.Instance.REPORT(exp);
				MessageBox.Show(exp.ToString(), "Error");
			}
			finally 
			{
				Cursor = Cursors.Default;
				if(splashScreen != null)
				{
					System.Threading.Thread.Sleep(2000);
					splashScreen.Dispose();
				}
			}
		}

		private void frmMain_Resize(object sender, System.EventArgs e)
		{
			if(WindowState == FormWindowState.Minimized)
			{
				if(AppOptions.Instance.GetOption("hideWhenMinimized").ToString().CompareTo("1") == 0)
				{
					ShowAsTrayIcon(true);
				}
			}
		}

		private void frmMain_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if(AppOptions.Instance.GetOption("hideWhenClosed").ToString().CompareTo("1") == 0)
			{
				ShowAsTrayIcon(true);
				e.Cancel = true;	//	Stop application from exiting
			}
			else
			{
				e.Cancel = false;	//	allow application to exit
				trayRSSConnect.Visible = false;
			}
		}

		#endregion
		#region WEB_BROWSER_EVENTS
		private void axFeedReaderWebBrowser_StatusTextChange(object sender, AxSHDocVw.DWebBrowserEvents2_StatusTextChangeEvent e)
		{
			try
			{
				if(e.text != null)
				{
					statusBarPanelBrowserDetails.Text = e.text;
				}
			}
			catch(Exception exp)
			{DebugLog.Instance.REPORT(exp);}
			
		}
		#endregion
		#region TRAY_ICON
		private void traymenuOpen_Click(object sender, System.EventArgs e)
		{
			ShowAsTrayIcon(false);
		}

		private void trayRSSConnect_DoubleClick(object sender, System.EventArgs e)
		{
			ShowAsTrayIcon(false);
		}

		private void traymenuExit_Click(object sender, System.EventArgs e)
		{
			Application.Exit();
		}

		#endregion
		
		#region RSS_FEED_TREE
		private void tvFeeds_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			//	When rapidly down and up arrow keys are pressed to navigate the tree
			//	We do not want to handle all the AfterSelect events
			//	Using special timer threading code to implement this
			try
			{
				if(!threadSyncData.IsInThread)
				{
					DebugLog.Instance.DEBUG3("Entering...");
					lock(threadSyncData)
					{
						threadSyncData.IsInThread = true;
					}
					TimerCallback callback = new TimerCallback(TimerFeeds);
					System.Threading.Timer timer = new System.Threading.Timer(callback, 
						null, //	no state data
						750, //	wait 3/4 sec
						Timeout.Infinite	//	just call once, no repetition
						);
				}
				else
				{
					DebugLog.Instance.DEBUG3("Skipping...");
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void tvFeeds_AfterLabelEdit(object sender, System.Windows.Forms.NodeLabelEditEventArgs e)
		{
			try
			{
				TreeNode treeNode = tvFeeds.SelectedNode;
				if(treeNode != null)
				{
					string treeNodeText = treeNode.Text;
					string newText = e.Label;

					if(newText == null || newText.Length <= 0)
						return;

					if (treeNodeText.CompareTo(newText) != 0)
					{
						XmlNode xmlNode = GetFeedXmlNodeByName(treeNodeText);
						XmlNode attribNode = xmlNode.Attributes["text"];

						if(attribNode != null)
						{
							attribNode.Value = newText;

							DebugLog.Instance.DEBUG2("Saving the updated document...");
							feedsXMLDoc.Save(feedsFileName);
						}

					}
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			
		}

		private void contextMenuTree_Popup(object sender, System.EventArgs e)
		{
			Point pt = new Point(MousePosition.X, MousePosition.Y);
			pt = tvFeeds.PointToClient(pt);
			tvFeeds.SelectedNode = tvFeeds.GetNodeAt(pt.X, pt.Y);
			
			EnableDisableMenuItems();
		}

		private void splitter1_DoubleClick(object sender, System.EventArgs e)
		{
			ShowHideTree();
		}

		private void tcmExport_Click(object sender, System.EventArgs e)
		{
			ExportToDatabase();
		}

		private void tcmProperties_Click(object sender, System.EventArgs e)
		{
			try
			{
				TreeNode treeNode = tvFeeds.SelectedNode;
				
				string oldNodeText = treeNode.Text;
				string oldFeedUrl = null;
				string oldOPMLUrl = null;

				frmAddNew addNewFeedForm = new frmAddNew();

				if(treeNode != null && treeNode.Tag != null)
				{
					if( ( ((TreeNodeTag)(treeNode.Tag)).nodeType & nodeTypeEnum.childNodeToOPML) == nodeTypeEnum.childNodeToOPML)
						addNewFeedForm.nodeType = nodeTypeEnum.childNodeToOPML;
					else if( ( ((TreeNodeTag)(treeNode.Tag)).nodeType & nodeTypeEnum.opmlNode) == nodeTypeEnum.opmlNode)
						addNewFeedForm.nodeType = nodeTypeEnum.opmlNode;
					else if( (((TreeNodeTag)(treeNode.Tag)).nodeType & nodeTypeEnum.feedNode) == nodeTypeEnum.feedNode )
						addNewFeedForm.nodeType = nodeTypeEnum.feedNode;
					else
						addNewFeedForm.nodeType = ((TreeNodeTag)(treeNode.Tag)).nodeType;

					oldFeedUrl = ((TreeNodeTag)(treeNode.Tag)).feedUrl;
					addNewFeedForm.feedUrl = oldFeedUrl;

					oldOPMLUrl = ((TreeNodeTag)(treeNode.Tag)).opmlUrl;
					addNewFeedForm.opmlUrl = oldOPMLUrl;
				}
				
				addNewFeedForm.feedTitle = oldNodeText;
				
				if(addNewFeedForm.ShowDialog() == DialogResult.OK)
				{
					UpdateNode(oldNodeText, oldFeedUrl, oldOPMLUrl,
						addNewFeedForm.feedTitle, //	new title
						addNewFeedForm.feedUrl, //	Updated feed URL
						addNewFeedForm.opmlUrl,	//	Updated OPML URL
						treeNode);	
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void tcmRefresh_Click(object sender, System.EventArgs e)
		{
			ShowRSS(true);
		}
		
		private void tcmRename_Click(object sender, System.EventArgs e)
		{
			TreeNode treeNode = tvFeeds.SelectedNode;
			if(treeNode != null)
				treeNode.BeginEdit();
		}

		private void tcmRefreshOPML_Click(object sender, System.EventArgs e)
		{
			RefreshOPMLNode(tvFeeds.SelectedNode);
		}

		private void tcmAddFolder_Click(object sender, System.EventArgs e)
		{
			AddFolderNode(tvFeeds.SelectedNode, "New Folder", true);
		}

		private void tcmAddFeed_Click(object sender, System.EventArgs e)
		{
			AddFeedNodeWithUI();
		}

		private void tcmDelete_Click(object sender, System.EventArgs e)
		{//Updated in 1.0.0.1: Created following new supporting function
			DeleteNode(false);
		}

		private void tcmAddToFav_Click(object sender, System.EventArgs e)
		{
			AddSelectedNodeToFav();
		}

		private void tcmDeleteChilds_Click(object sender, System.EventArgs e)
		{//1.0.0.1 Change
			DeleteNode(true);
		}


		#region DRAG_DROP
		private void tvFeeds_ItemDrag(object sender, System.Windows.Forms.ItemDragEventArgs e)
		{
			//	Enable Drag-Drop
			DoDragDrop(e.Item, DragDropEffects.Move);
		}

		private void tvFeeds_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
		{
			try
			{
				e.Effect = DragDropEffects.Move;
				if (e.Data.GetDataPresent(DataFormats.Text)) 
				{
					e.Effect = DragDropEffects.All; 
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void tvFeeds_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			try
			{
				Point pt = ((TreeView)sender).PointToClient(new Point(e.X, e.Y));
				TreeNode DestinationNode = ((TreeView)sender).GetNodeAt(pt);

				//	TreeNode drop
				if(e.Data.GetDataPresent("System.Windows.Forms.TreeNode", false))
				{
					TreeNode nodeToBeMoved;
					nodeToBeMoved = (TreeNode)e.Data.GetData("System.Windows.Forms.TreeNode");
					if(DestinationNode != null && nodeToBeMoved != null)
					{
						MoveNode(nodeToBeMoved, DestinationNode);
					}
				}
				else
				{
					//	URL drop
					string droppedUrl = e.Data.GetData("Text", false).ToString();
					if(droppedUrl != null && droppedUrl.Length > 0)
					{
						AddFeedNode(droppedUrl, droppedUrl, DestinationNode);
					}
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
 		
		}

		private void tvFeeds_DragOver(object sender, System.Windows.Forms.DragEventArgs e)
		{
			try
			{
				if (e.Data.GetDataPresent(DataFormats.Text)) 
					e.Effect = DragDropEffects.All; 

				//	Support Scrolling
				Point pt = tvFeeds.PointToClient(new Point(e.X,e.Y)); 
				int delta = tvFeeds.Height - pt.Y; 
				if ((delta < tvFeeds.Height / 2) && (delta > 0)) 
				{ 
					TreeNode tn = tvFeeds.GetNodeAt(pt.X, pt.Y); 
					if (tn != null && tn.NextVisibleNode != null) 
						tn.NextVisibleNode.EnsureVisible(); 
				} 
	 
				if ((delta > tvFeeds.Height / 2) && (delta < tvFeeds.Height)) 
				{ 
					TreeNode tn = tvFeeds.GetNodeAt(pt.X, pt.Y); 
					if (tn != null && tn.PrevVisibleNode != null) 
						tn.PrevVisibleNode.EnsureVisible(); 
				} 
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		#endregion

		#endregion

		#region WEB_SITES_TAB
		private void tabControlMain_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (tabControlMain.SelectedIndex == 1 && //Web sites tab
				!websitesTabLoaded)
			{
				try
				{
					DebugLog.Instance.DEBUG2("Loading Web sites tree...");
					websitesTabLoaded = LoadWebSitesTree();
					webSitesRootNode.Expand();
				}
				catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			}
		}

		private void tvWebSites_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			try
			{
				TreeNode treeNode = tvWebSites.SelectedNode;

				if(treeNode != null && treeNode.Tag != null && treeNode.Text != null)
				{
					string webSiteURL = treeNode.Tag.ToString();
					BrowseWebSite(webSiteURL, true);
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void contextMenuWebsites_Popup(object sender, System.EventArgs e)
		{
			try
			{
				Point pt = new Point(MousePosition.X, MousePosition.Y);
				pt = tvWebSites.PointToClient(pt);
				TreeNode treeNode =  tvWebSites.GetNodeAt(pt.X, pt.Y);
				tcmWebSitesRefresh.Enabled = (treeNode == webSitesRootNode);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void tcmWebSitesRefresh_Click(object sender, System.EventArgs e)
		{
			try
			{
				webSitesRootNode.Nodes.Clear();
				websitesTabLoaded = LoadWebSitesTree();
				webSitesRootNode.Expand();
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		#endregion

		#region MAIN_MENU
		private void menuViewFeedHTML_Click(object sender, System.EventArgs e)
		{
			SwitchToXML(false);
		}
		private void menuViewFeedXML_Click(object sender, System.EventArgs e)
		{
			SwitchToXML(true);
		}
		private void menuViewFeedListTree_Click(object sender, System.EventArgs e)
		{
			ShowHideTree();
		}
		private void menuViewStatusBar_Click(object sender, System.EventArgs e)
		{
			try
			{
				menuViewStatusBar.Checked = !menuViewStatusBar.Checked;
				statusMain.Visible = menuViewStatusBar.Checked;

				if(menuViewStatusBar.Checked)
					AppOptions.Instance.SetOption("showStatusBar", "1");
				else
					AppOptions.Instance.SetOption("showStatusBar", "0");
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void menuViewWebNavigation_Click(object sender, System.EventArgs e)
		{
			try
			{
				menuViewWebNavigation.Checked = !menuViewWebNavigation.Checked;
				panelBrowserNavigation.Visible = menuViewWebNavigation.Checked;
				if(menuViewWebNavigation.Checked)
					AppOptions.Instance.SetOption("navigationBar", "1");
				else
					AppOptions.Instance.SetOption("navigationBar", "0");
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			
		}

		private void menuView_Popup(object sender, System.EventArgs e)
		{
			try
			{
				string searchHTMLFile = Application.StartupPath + @"\cache\SearchResult.html";
				menuViewRecentSearchResults.Enabled = File.Exists(searchHTMLFile);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		
		}

		private void menuViewRecentSearchResults_Click(object sender, System.EventArgs e)
		{
			try
			{
				string searchHTMLFile = Application.StartupPath + @"\cache\SearchResult.html";
				if(File.Exists(searchHTMLFile))
					BrowseWebSite(searchHTMLFile, false);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}
		private void menuRefreshSkinList_Click(object sender, System.EventArgs e)
		{
			BuildSkinsMenu();
		}

		private void menuAddToFav_Click(object sender, System.EventArgs e)
		{
			AddSelectedNodeToFav();
		}

		private void menuFav_Popup(object sender, System.EventArgs e)
		{
			LoadFavMenuItems();
		}

		private void menuOptions_Click(object sender, System.EventArgs e)
		{
			try
			{
				LoadFavMenuItems();
				frmOptions optionsForm = new frmOptions(favList);
				if(DialogResult.OK == optionsForm.ShowDialog())
				{
					foreach(string favFeedUrl in optionsForm.removedFavs)
					{
						RemoveFavorite(favFeedUrl);
						favList.Remove(favFeedUrl);
					}
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void menuSearch_Click(object sender, System.EventArgs e)
		{
			try
			{
				frmSearch searchForm = new frmSearch();
				if(DialogResult.OK == searchForm.ShowDialog())
				{
					Cursor = Cursors.WaitCursor;
					statusBarPanelTreeInfo.Text = "Please wait...";
					if(searchForm.searchText != null && searchForm.searchText.Length > 0)
					{

						Utility utility = new Utility();
						string htmlFileName = utility.PerformSearch(searchForm.searchText, searchForm.searchType);
						if(htmlFileName != null && htmlFileName.Length > 0)
						{
							BrowseWebSite(htmlFileName, false);
						}
					}
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			finally
			{
				Cursor = Cursors.Default;
				statusBarPanelTreeInfo.Text = "Search Results";
			}
		}

		private void menuExit_Click(object sender, System.EventArgs e)
		{
			Application.Exit();
		}

		private void menuRefreshCurrentFeed_Click(object sender, System.EventArgs e)
		{
			ShowRSS(true);
		}

		private void menuNewFeed_Click(object sender, System.EventArgs e)
		{
			AddFeedNodeWithUI();
		}

		private void menuNewFolder_Click(object sender, System.EventArgs e)
		{
			AddFolderNode(tvFeeds.SelectedNode, "New Folder", true);
		}
		private void menuNewOPML_Click(object sender, System.EventArgs e)
		{
		
		}
		private void menuCheckForNewFeeds_Click(object sender, System.EventArgs e)
		{	
			try
			{
				frmNewFeeds newFeeds = new frmNewFeeds(feedList);
				if(newFeeds.ShowDialog() == DialogResult.OK)
				{
					foreach(NewFeedInfo newFeed in newFeeds.newFeedsColl)
					{
						if(newFeed.feedUrl != null)
						{
							DebugLog.Instance.DEBUG2("Adding new feed node..." + newFeed.feedTitle 
								+ " " + newFeed.feedUrl);
							AddFeedNode(newFeed.feedTitle, newFeed.feedUrl, newFeed.parentFolderName);
						}
					}
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void menuContact_Click(object sender, System.EventArgs e)
		{
			System.Diagnostics.Process.Start("http://www.PerfectXML.com/ContactUs.asp");
		}

		private void menuAbout_Click(object sender, System.EventArgs e)
		{
			frmSplash aboutForm = new frmSplash();
			aboutForm.showAsAboutBox = true;
			aboutForm.ShowDialog();
		}

		private void menuViewHomePage_Click(object sender, System.EventArgs e)
		{
			tvFeeds.SelectedNode = rootNode;
		}

		private void menuExport_Click(object sender, System.EventArgs e)
		{
			ExportToDatabase();
		}

		private void showFavFeed_Click(object sender, EventArgs e)
		{
			try
			{
				tabControlMain.SelectedIndex = 0;
				MenuItem curMenuItem = ((MenuItem)sender);
				string nodeText = curMenuItem.Text.Replace("&&", "&");
				tvFeeds.SelectedNode = GetNodeByName(nodeText, tvFeeds.Nodes);
				tvFeeds.Select();
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

		}

		private void changeSkinMenu_Click(object sender, EventArgs e)
		{
			try
			{
				MenuItem curMenuItem = ((MenuItem)sender);
				
				//	Update the app option
				AppOptions.Instance.SetOption("xsltFile", curMenuItem.Text + ".xsl");

				//	Show the RSS (only if HTML view)
				if(menuViewFeedHTML.Checked)
					ShowRSS(false);

				//	Uncheck all checks
				foreach(MenuItem menuItem in curMenuItem.Parent.MenuItems)
					menuItem.Checked = false;

				//	Check the current selection
				curMenuItem.Checked = true;

			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void menuCheckAppUpdates_Click(object sender, System.EventArgs e)
		{
			try
			{
				Cursor = Cursors.WaitCursor;
				Utility utility = new Utility();
				string updateMessages = utility.CheckForAppUpdates();
				Cursor = Cursors.Default;
				MessageBox.Show(updateMessages, Application.ProductName);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			finally
			{
				Cursor = Cursors.Default;
			}
		}
		private void menuFile_Popup(object sender, System.EventArgs e)
		{//1.0.0.1 Change
			try
			{
				TreeNode treeNode = tvFeeds.SelectedNode;
				if(treeNode == rootNode || 
					(treeNode.Tag != null && ((((TreeNodeTag)(treeNode.Tag)).nodeType & nodeTypeEnum.folderNode) == nodeTypeEnum.folderNode ) ) )
					menuOPMLImport.Enabled = true;
				else
					menuOPMLImport.Enabled = false;
			}
			catch(Exception exp){DebugLog.Instance.REPORT(exp);}
		}

		private void tcmAddOPML_Click(object sender, System.EventArgs e)
		{//1.0.0.1 Change
		
		}

		private void menuOPMLImport_Click(object sender, System.EventArgs e)
		{//1.0.0.1 Change
			try
			{
				Cursor = Cursors.WaitCursor;
				if(DialogResult.OK == openFileDialog.ShowDialog())
				{
					ImportOPML(tvFeeds.SelectedNode, openFileDialog.FileName);
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			finally
			{
				Cursor = Cursors.Default;
				tvFeeds.SelectedNode.Expand();
			}
		}

		private void menuOPMLExport_Click(object sender, System.EventArgs e)
		{//1.0.0.1 Change
			try
			{
				Cursor = Cursors.WaitCursor;
				TreeNode treeNode = tvFeeds.SelectedNode;
				string nodeText = treeNode.Text;
				Utility utility = new Utility();
				string escapedNodeText = utility.GetValidFileName(nodeText);;
				saveFileDialog.Title = "Export " + treeNode.Text + " to";
				try
				{
					saveFileDialog.FileName = escapedNodeText + ".opml";
				}
				catch(Exception) {saveFileDialog.FileName="";}
				if(DialogResult.OK == saveFileDialog.ShowDialog())
					if(utility.ExportNodeToOPMLFile(treeNode, saveFileDialog.FileName))
					{
						if(MessageBox.Show(treeNode.Text + " successfully exported as OPML to " + saveFileDialog.FileName +
							"\n\nWould you like to view this file now?", Application.ProductName, 
							MessageBoxButtons.YesNo) == DialogResult.Yes)
						{
							System.Diagnostics.Process.Start("notepad.exe", saveFileDialog.FileName);
						}
					}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			finally 
			{
				Cursor = Cursors.Default;
			}
		}

		#endregion

		#region NAVIGATION_BAR
		private void tcmGoogleWebSearch_Click(object sender, System.EventArgs e)
		{
			try
			{
				BrowseSearchPage("http://www.google.com/search?hl=en&ie=UTF-8&oe=UTF-8&q=", 
					txtSearchText.Text, tcmGoogleWebSearch.Text);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void tcmGoogleGroupsSearch_Click(object sender, System.EventArgs e)
		{
			try
			{
				BrowseSearchPage("http://groups.google.com/groups?hl=en&lr=&ie=UTF-8&oe=UTF-8&q=", 
					txtSearchText.Text, tcmGoogleGroupsSearch.Text);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void tcmGoogleNewsSearch_Click(object sender, System.EventArgs e)
		{
			try
			{
				BrowseSearchPage("http://news.google.com/news?hl=en&lr=&ie=UTF-8&oe=UTF-8&q=", 
					txtSearchText.Text, tcmGoogleNewsSearch.Text);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void tcmPerfectXMLSearch_Click(object sender, System.EventArgs e)
		{
			try
			{
				BrowseSearchPage("http://www.PerfectXML.com/SiteSearch.asp?sType=1&x=35&y=10&searchText=", 
					txtSearchText.Text, tcmPerfectXMLSearch.Text);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void tcmMSDNSearch_Click(object sender, System.EventArgs e)
		{
			try
			{
				BrowseSearchPage("http://search.microsoft.com/default.asp?so=RECCNT&siteid=us%2Fdev&p=1&nq=NEW&IntlSearch=&boolean=ALL&ig=01&i=00&i=01&i=02&i=03&i=04&i=05&i=06&i=07&i=08&i=09&i=10&i=11&i=12&i=13&i=14&i=15&i=16&i=17&i=18&i=19&i=20&i=21&i=22&i=23&i=24&i=25&i=26&i=27&i=28&i=29&i=30&i=31&i=32&i=33&i=34&i=35&i=36&i=37&i=38&i=39&i=40&i=41&ig=02&i=42&i=43&i=44&i=45&i=46&i=47&i=48&i=49&i=50&i=51&i=52&i=53&i=54&i=55&i=56&i=57&i=58&i=59&i=60&i=61&i=62&i=63&ig=03&ig=04&ig=05&ig=06&ig=07&ig=08&i=99&qu=", 
					txtSearchText.Text, tcmMSDNSearch.Text);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}
		private void tcmMSKBSearch_Click(object sender, System.EventArgs e)
		{
			try
			{
				BrowseSearchPage("http://support.microsoft.com/search/default.aspx?Catalog=LCID%3D1033%26CDID%3DEN-US-KB%26PRODLISTSRC%3DON&withinResults=&QuerySource=gASr_Query&Product=msall&Queryc=xml&KeywordType=ALL&maxResults=150&Titles=false&numDays=&Query=", 
					txtSearchText.Text, tcmMSKBSearch.Text);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void tcmIBMdWSearch_Click(object sender, System.EventArgs e)
		{
			try
			{
				BrowseSearchPage("http://www-106.ibm.com/search/searchResults.jsp?searchType=1&searchSite=dW&searchScope=dW&Search.x=46&Search.y=17&query=", 
					txtSearchText.Text, tcmIBMdWSearch.Text);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void tcmJavaSearch_Click(object sender, System.EventArgs e)
		{
			try
			{
				BrowseSearchPage("http://search.java.sun.com/search/java/?&Search.x=0&Search.y=0&qt=", 
					txtSearchText.Text, tcmIBMdWSearch.Text);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void contextMenuSearch_Popup(object sender, System.EventArgs e)
		{
			try
			{
				bool enabled = txtSearchText.Text.Length > 0;
				string searchMenuID = AppOptions.Instance.GetOption("searchUsing");

				foreach(MenuItem menuItem in contextMenuSearch.MenuItems)
				{
					menuItem.Checked = (searchMenuID.CompareTo(menuItem.Text) == 0);
					menuItem.Enabled = enabled;
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void pictureSearch_Click(object sender, System.EventArgs e)
		{
			try
			{
				Point pt = new Point(MousePosition.X, MousePosition.Y);
				pt = pictureSearch.PointToClient(pt);
				contextMenuSearch.Show(pictureSearch, pt);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void txtAddressBar_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			try
			{
				string webAddress = txtAddressBar.Text;
				if ( (webAddress.Length > 0) && ((e.Modifiers & Keys.Control) == Keys.Control) && (e.KeyCode == Keys.Enter))
				{
					webAddress = "http://www." + webAddress + ".com";
					txtAddressBar.Text = webAddress;
				}

				if(e.KeyCode == Keys.Enter)
				{
					try
					{
						if(webAddress.Length > 0)
						{
							BrowseWebSite(webAddress, true);
						}
					}
					catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void pictureGO_Click(object sender, System.EventArgs e)
		{
			try
			{
				string webAddress = txtAddressBar.Text;
				if(webAddress.Length > 0)
					BrowseWebSite(webAddress, true);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void pictureForward_Click(object sender, System.EventArgs e)
		{
			try
			{
				axFeedReaderWebBrowser.GoForward();
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void pictureBack_Click(object sender, System.EventArgs e)
		{
			try
			{
				axFeedReaderWebBrowser.GoBack();
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void txtSearchText_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			try
			{
				string searchText = txtSearchText.Text;
				if(e.KeyCode == Keys.Enter)
				{
					string searchUsing = AppOptions.Instance.GetOption("searchUsing");
					foreach(MenuItem menuItem in contextMenuSearch.MenuItems)
					{
						if( (menuItem.Text.CompareTo(searchUsing)) == 0)
						{
							menuItem.PerformClick();
							return;
						}
					}

					try
					{
						if(searchText.Length > 0)
						{
							searchText = System.Web.HttpUtility.UrlEncode(searchText);
							string searchUrl = "http://www.PerfectXML.com/SiteSearch.asp?searchText=" + searchText + "&sType=1&x=35&y=10";
							BrowseWebSite(searchUrl, true);
						}
					}
					catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		#endregion
		#endregion
		#region SUPPORTING_FUNCTIONS
		private void TimerFeeds(object state)
		{
			try
			{
				if(threadSyncData.IsInThread)
					ShowRSS(false);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void PrepareUI()
		{
			//	Build the Feed Tree
			try
			{
				//	Get the Feeds XML file path/name to load
				feedsFileName = ConfigurationSettings.AppSettings["FeedsXmlFile"];
				favFileName = ConfigurationSettings.AppSettings["FavoritesDataFile"];

				if(feedsFileName == null)
					feedsFileName = "Feeds.xml";
				if(feedsFileName.Length <= 0)
					feedsFileName = "Feeds.xml";
				DebugLog.Instance.DEBUG2("Feeds XML File is: " + feedsFileName);

				if(favFileName == null)
					favFileName = "Fav.xml";
				if(favFileName.Length <= 0)
					favFileName = "Fav.xml";
				DebugLog.Instance.DEBUG2("Favorites XML File is: " + favFileName);

				if(tvFeeds.Nodes.Count <= 0)
					tvFeeds.Nodes.Add("RSSConnect");

				if(tvWebSites.Nodes.Count <= 0)
					tvWebSites.Nodes.Add("Web Sites");

				rootNode = tvFeeds.Nodes[0];
				rootNode.ImageIndex = (int)feedTreeImageEnum.home;
				rootNode.SelectedImageIndex = (int)feedTreeImageEnum.home;
				webSitesRootNode = tvWebSites.Nodes[0];

				//	Begin reading the XML file
				XmlTextReader reader = new XmlTextReader(feedsFileName);

				try
				{
					//	Disables any redrawing of the tree view till we are done
					tvFeeds.BeginUpdate();

					//	recursively process the XML and create tree nodes
					ProcessXML(reader, rootNode);
				}
				catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
				finally
				{
					//	Enables the redrawing of the tree view.
					tvFeeds.EndUpdate();
					try {reader.Close();} 
					catch(Exception){}
				}
				
				rootNode.Expand();

				try
				{//	Browse to the same feed/node, which was selected when the application was last closed
					string selNodeWhenAppExited = AppOptions.Instance.GetOption("selNodeWhenAppExited");
					if(selNodeWhenAppExited.Length > 0)
					{
						TreeNode lastNode = GetNodeByName(selNodeWhenAppExited, tvFeeds.Nodes);
						if(lastNode != null)
							tvFeeds.SelectedNode = lastNode;
					}
					else
					{
						tvFeeds.SelectedNode = rootNode;
						tvFeeds.Select();
					}
				}
				catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			}
			catch(Exception exp)
			{
				DebugLog.Instance.REPORT(exp);
				MessageBox.Show(exp.ToString(), "Error");
			}

			//	Process Starup Options
			ProcessStartupOptions();
		}

		//	recursive function that reads the XML file, OPML file, and creates tree nodes
		private void ProcessXML(XmlTextReader reader, TreeNode curParentNode)
		{
			while(reader.Read())
			{
				try
				{
					//	NOTE::: IMPORTANT </treenode> indicates end the current recursion
					if ( (reader.NodeType == XmlNodeType.EndElement) &&
						(reader.Name.CompareTo("treenode") == 0) && 
						reader.AttributeCount == 0)
					{
						return;
					}

					//	if beginning of element node named "treenode" or "outline"
					if(reader.NodeType == XmlNodeType.Element &&
						(reader.Name.CompareTo("treenode") == 0 || 
						reader.Name.CompareTo("outline") == 0))
					{
						//	create a new tree node and append it under current parent node
						TreeNode treeNode = new TreeNode();
						treeNode.Tag = new TreeNodeTag();

						curParentNode.Nodes.Add(treeNode);
						
						//	process <treenode> or <outline> element attributes
						while(reader.MoveToNextAttribute())
						{
							switch(reader.Name)
							{
								case "xmlUrl":
									((TreeNodeTag)(treeNode.Tag)).feedUrl = reader.Value.ToString();
									((TreeNodeTag)(treeNode.Tag)).nodeType = nodeTypeEnum.childNodeToOPML | nodeTypeEnum.feedNode;
									treeNode.ImageIndex = (int)feedTreeImageEnum.feed;
									treeNode.SelectedImageIndex = (int)feedTreeImageEnum.feed;
									break;
								case "feedUrl":
									((TreeNodeTag)(treeNode.Tag)).feedUrl = reader.Value.ToString();
									((TreeNodeTag)(treeNode.Tag)).nodeType = nodeTypeEnum.feedNode;
									treeNode.ImageIndex = (int)feedTreeImageEnum.feed;
									treeNode.SelectedImageIndex = (int)feedTreeImageEnum.feed;
									break;

								case "title":
								case "text":
									treeNode.Text = reader.Value;
									break;

									//	NOTE::: IMPORTANT "type" should be last attribute
								case "type":
									string nodeTypeValue = reader.Value;

									if(nodeTypeValue != null)
										nodeTypeValue = nodeTypeValue.ToUpper();
									else
										nodeTypeValue = "";

									if(nodeTypeValue.CompareTo("FOLDER") == 0)
									{
										treeNode.ImageIndex = (int)feedTreeImageEnum.folder;
										treeNode.SelectedImageIndex = (int)feedTreeImageEnum.folder;
										((TreeNodeTag)(treeNode.Tag)).nodeType = ((TreeNodeTag)(treeNode.Tag)).nodeType | nodeTypeEnum.folderNode;
										ProcessXML(reader, treeNode);	//	recursion
									}

									break;

									//	NOTE::: "opmlUrl" should be last attribute
									//	type and opmlUrl should not be present together
									//	opmlUrl by default indicates a FOLDER type node
								case "opmlUrl":
									try
									{
										treeNode.ImageIndex = (int)feedTreeImageEnum.opml;
										treeNode.SelectedImageIndex = (int)feedTreeImageEnum.opml;
										string opmlUrl = reader.Value;
										((TreeNodeTag)(treeNode.Tag)).nodeType = nodeTypeEnum.opmlNode;
										((TreeNodeTag)(treeNode.Tag)).opmlUrl = opmlUrl;

										DebugLog.Instance.DEBUG2("Processing OPML URL " + opmlUrl);
										Utility utility = new Utility();
										string opmlCacheFile = utility.GetCacheFileNameFromUrl(opmlUrl);

										DOMDocument30Class opmlXMLDoc = 
											utility.DownloadAndSave(opmlUrl, opmlCacheFile, true);

										try
										{
											Marshal.ReleaseComObject(opmlXMLDoc);
										}
										catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

										if(File.Exists(opmlCacheFile))
										{
											XmlTextReader opmlReader = 
												new XmlTextReader(opmlCacheFile);

											ProcessXML(opmlReader, treeNode);	//	recursion
											opmlReader.Close();
										}
										else
										{
											DebugLog.Instance.REPORT("OPML file '" + opmlCacheFile + "' not found!");
										}
									}
									catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
									break;
							}
						}

						if(    ((((TreeNodeTag)(treeNode.Tag)).nodeType & nodeTypeEnum.feedNode) == nodeTypeEnum.feedNode)
							&& (((TreeNodeTag)(treeNode.Tag)).feedUrl != null) )
						{
							try { feedList[((TreeNodeTag)(treeNode.Tag)).feedUrl] = treeNode.Text; } 
							catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
						}
					}
				}
				catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			}
		}

		private void ExitApplication(object sender, EventArgs e)
		{
			try
			{
				if( ((AppOptions.Instance.GetOption("clearHTMLCacheOnExit")).CompareTo("1")) == 0)
				{
					Utility utility = new Utility();
					utility.ClearCacheFiles("*.html");
				}

				if( ((AppOptions.Instance.GetOption("clearXMLCacheOnExit")).CompareTo("1")) == 0)
				{
					Utility utility = new Utility();
					utility.ClearCacheFiles("*.xml");
				}
				AppOptions.Instance.SetOption("selNodeWhenAppExited", tvFeeds.SelectedNode.Text);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			trayRSSConnect.Visible = false;
			Application.Exit();
		}

		private bool LoadFavXMLInDOM()
		{
			bool result = false;
			try
			{
				if(favXMLDoc == null)
				{
					favXMLDoc = new XmlDocument();
					if(favFileName == null)
						favFileName = ConfigurationSettings.AppSettings["FavoritesDataFile"];
					if(favFileName == null)
						favFileName = "Fav.xml";
					if(favFileName.Length <= 0)
						favFileName = "Fav.xml";

					DebugLog.Instance.DEBUG2("Loading " + favFileName + "...");
					favXMLDoc.Load(favFileName);
					result = true;
				}
				else
				{
					DebugLog.Instance.DEBUG2(favFileName + " already loaded into DOM.");
					result = true;
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			return result;
		}

		private void ExportToDatabase()
		{
			try
			{
				Cursor = Cursors.WaitCursor;
				TreeNode treeNode = tvFeeds.SelectedNode;
				string feedUrl = null;
				if(treeNode != null && treeNode.Tag != null && ((TreeNodeTag)(treeNode.Tag)).feedUrl != null)
				{
					feedUrl = ((TreeNodeTag)(treeNode.Tag)).feedUrl;

					Utility utility = new Utility();
					int[] counts = utility.ExportFeedToDatabase(feedUrl);

					MessageBox.Show(counts[0].ToString() + " entries processed. " +  counts[1].ToString()
						+ " entries exported to the database.", Application.ProductName);
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			finally { Cursor = Cursors.Default;}
		}

		private void LoadFavMenuItems()
		{
			try
			{
				Cursor = Cursors.WaitCursor;
				EnableDisableMenuItems();

				LoadFavXMLInDOM();

				//	clear any existing fav menu items
				int totalFavs = menuFav.MenuItems.Count; 
				int iIndex;
				for(iIndex=2; iIndex < totalFavs; iIndex++)
					menuFav.MenuItems.RemoveAt(2);

				//	add new menu items
				XmlNodeList favItemNodes = favXMLDoc.SelectNodes("/Fav/add");
				foreach(XmlNode favNode in favItemNodes)
				{
					string feedTitle = favNode.Attributes["value"].Value;
					string feedUrl = favNode.Attributes["key"].Value;
					MenuItem newMenuItem = menuFav.MenuItems.Add(feedTitle);
					favList[feedUrl] = feedTitle;
					newMenuItem.Click += new EventHandler(showFavFeed_Click);
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			finally
			{
				Cursor = Cursors.Default;
			}
		}

		private bool RemoveFavorite(string favFeedUrl)
		{
			bool result = false;
			try
			{
				//	Load fav.xml (if not already loaded into DOM)
				LoadFavXMLInDOM();

				if(favFeedUrl != null)
				{
					XmlNode favNode = favXMLDoc.SelectSingleNode("/Fav/add[@key='" + favFeedUrl + "']");

					if(favNode != null)
					{
						favNode.RemoveAll();
						favNode.ParentNode.RemoveChild(favNode);
						favXMLDoc.Save(favFileName);
						result = true;
					}
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			return result;
		}

		private bool AddSelectedNodeToFav()
		{
			bool result = false;
			try
			{
				//	Load fav.xml (if not already loaded into DOM)
				LoadFavXMLInDOM();

				//	Get the currently selected node
				TreeNode treeNode = tvFeeds.SelectedNode;

				//	Only "Feed" type nodes can be added to Favorites
				if(treeNode != null && treeNode.Tag != null && ((TreeNodeTag)(treeNode.Tag)).feedUrl != null)
				{
					string feedUrl = ((TreeNodeTag)(treeNode.Tag)).feedUrl;
					string nodeText = treeNode.Text;

					XmlNode favNode = favXMLDoc.SelectSingleNode("/Fav/add[@key='" + feedUrl + "']");

					if(favNode == null)
					{
						DebugLog.Instance.DEBUG3("Adding new Favorite node " + feedUrl + " " + nodeText);
						favNode = favXMLDoc.CreateElement("add");

						favXMLDoc.DocumentElement.AppendChild(favNode);
					}
					else
					{
						DebugLog.Instance.DEBUG3("Updating existing Favorite node " + feedUrl + " " + nodeText);
						favNode.Attributes.RemoveAll();
					}

					((XmlElement)favNode).SetAttribute("key", "", feedUrl);
					nodeText = nodeText.Replace("&", "&&");
					((XmlElement)favNode).SetAttribute("value", "", nodeText);

					favList[feedUrl] = nodeText;

					//	Save the updated favorites XML document
					favXMLDoc.Save(favFileName);
					result = true;
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			return result;
		}

		//	For operations such as rename, delete, add, load FeedXML into DOM as required
		private bool LoadFeedXMLInDOM()
		{
			bool result = false;
			try
			{
				if(feedsXMLDoc == null)
				{
					feedsXMLDoc = new XmlDocument();
					if(feedsFileName == null)
						feedsFileName = ConfigurationSettings.AppSettings["FeedsXmlFile"];
					if(feedsFileName == null)
						feedsFileName = "Feeds.xml";
					if(feedsFileName.Length <= 0)
						feedsFileName = "Feeds.xml";

					DebugLog.Instance.DEBUG2("Loading " + feedsFileName + "...");
					feedsXMLDoc.Load(feedsFileName);
					result = true;
				}
				else
				{
					DebugLog.Instance.DEBUG2(feedsFileName + " already loaded into DOM.");
					result = true;
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			return result;
		}

		private TreeNode GetNodeByName(string nodeName, TreeNodeCollection nodesToSearch)
		{
			TreeNode resultNode=null;

			foreach(TreeNode childNode in nodesToSearch)
			{
				if( ((childNode.Text.CompareTo(nodeName)) == 0) )
					resultNode = childNode;
				else if (childNode.Nodes.Count > 0)
					resultNode = GetNodeByName(nodeName, childNode.Nodes);

				if (resultNode != null)
					break;
			}
			return resultNode;
		}

		private XmlNode GetFeedXmlNodeByName(string nodeName)
		{
			XmlNode result = null;
			try
			{
				LoadFeedXMLInDOM();

				if((nodeName.CompareTo(tvFeeds.Nodes[0].Text)) == 0)
					result = feedsXMLDoc.DocumentElement;
				else
				{
					string XPathExpr;
					if(nodeName.IndexOf("'") >= 0)
						XPathExpr = "//treenode[@text=\"" + nodeName + "\"]";
					else
						XPathExpr = "//treenode[@text='" + nodeName + "']";

					result = feedsXMLDoc.SelectSingleNode(XPathExpr);
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			return result;
		}

		//	All the code should call this method
		//	This method then calls the other ShowRSS overloaded method
		private bool ShowRSS(bool forceRefresh)
		{
			bool result = false;
			TreeNode treeNode = tvFeeds.SelectedNode;

			try
			{
				if(treeNode != null && treeNode.Tag == null && treeNode.Parent == null)	//	root node
				{
					BrowseToHomePage();
				}
				else
				{
					Cursor = Cursors.WaitCursor;
					try
					{
						bool applyXSLT = menuViewFeedHTML.Checked;

						//	if rssUrl present as node tag
						if(treeNode != null && treeNode.Tag != null && ((TreeNodeTag)(treeNode.Tag)).feedUrl != null)
						{
							result = ShowRSS(((TreeNodeTag)(treeNode.Tag)).feedUrl, //	rssUrl
								treeNode.Text, //	Node text, 
								forceRefresh, //	force refresh or use cache
								applyXSLT	//	apply XSLT or show raw XML
								);
						}
						else
						{
							if(treeNode != null && treeNode.Text != null)
								statusBarPanelTreeInfo.Text = treeNode.Text;
						}

						if(treeNode != null && treeNode.Tag != null)
						{
							if( ((TreeNodeTag)(treeNode.Tag)).opmlUrl != null)
								statusBarPanelTreeInfo.Text += GetOPMLLastUpdatedDateTime(tvFeeds.SelectedNode);
							else
							{
								int childNodesCount = tvFeeds.SelectedNode.Nodes.Count;
								if(childNodesCount > 0)
								{
									if (childNodesCount == 1)
										statusBarPanelTreeInfo.Text += " [one node]";
									else
										statusBarPanelTreeInfo.Text += " [" + childNodesCount.ToString() + " nodes]";
								}
							}
						}

						if(forceRefresh)
						{
							lock(threadSyncData)
							{
								threadSyncData.IsInThread = true;
							}
						}
					}
					catch(Exception exp) 
					{
						DebugLog.Instance.REPORT(exp); 
						MessageBox.Show(exp.ToString(), "Error");}
					finally
					{
						EnableDisableMenuItems();
						Cursor = Cursors.Default;
					}
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			finally 
			{
				lock(threadSyncData)
				{
					DebugLog.Instance.DEBUG3("Resetting the thread synchronization variable...");
					threadSyncData.IsInThread = false;
				}
			}

			return result;
		}
		
		private bool ShowRSS(string rssUrl, string strNodeText, bool refreshCache, bool applyXSLT)
		{
			bool result = false;
			string cacheFileDate;

			DOMDocument30Class rssXMLDoc = null;
			try
			{
				TreeNode treeNode = tvFeeds.SelectedNode;

				statusBarPanelTreeInfo.Text = strNodeText;

				string feedUrl = rssUrl.ToString();
				DebugLog.Instance.DEBUG3("feedUrl = " + feedUrl);
				Utility utility = new Utility();

				string feedUrlLocalFileName = utility.GetCacheFileNameFromUrl(feedUrl);
				DebugLog.Instance.DEBUG3("cache File Name= " + feedUrlLocalFileName);

				rssXMLDoc = utility.DownloadAndSave(feedUrl, feedUrlLocalFileName, !refreshCache);

				if(applyXSLT)
				{
					//	HTML View: Apply the XSLT
					string xsltStylesheet = AppOptions.Instance.GetOption("xsltFile");

					xsltStylesheet = Application.StartupPath + @"\style\" + xsltStylesheet;
					DebugLog.Instance.DEBUG3("Loading the XSLT stylesheet: " + xsltStylesheet);

					DOMDocument30Class xsltDoc = new DOMDocument30Class();
					xsltDoc.async = false;
					xsltDoc.validateOnParse = false;
					xsltDoc.resolveExternals = false;

					if(xsltDoc.load(xsltStylesheet))
					{
						//	Generate the cache HTML document - a file that we'll browse to
						string cacheHTMLFile = feedUrlLocalFileName + ".html";
						StreamWriter htmlWriter = new StreamWriter(cacheHTMLFile, false, Encoding.Unicode);
						DebugLog.Instance.DEBUG3("Applying the stylesheet...");
						try
						{
							//	Following line can produce an exception in XSLT transformation fails
							htmlWriter.Write(rssXMLDoc.transformNode(xsltDoc));
							htmlWriter.Close();
							htmlWriter = null;

							DebugLog.Instance.DEBUG3("Navigating to HTML page...");
							BrowseWebSite(cacheHTMLFile, false);
						}
						catch(Exception exp) {DebugLog.Instance.REPORT(exp);
							MessageBox.Show(exp.ToString(), "Error");
						}
						finally
						{
							try
							{
								if(htmlWriter != null)
									htmlWriter.Close();
							}
							catch(Exception){}
						}
					}
					else
					{
						string loadError = "Failed to load XSLT stylesheet file '" + xsltStylesheet + "'.\n\nError: " + 
							xsltDoc.parseError.reason;
						MessageBox.Show(loadError, "Error");
						DebugLog.Instance.DEBUG1(loadError);
					}

					try
					{
						//	Decrements the reference count so that COM object can be freed
						Marshal.ReleaseComObject(xsltDoc);
					}
					catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
				}
				else
				{
					//	XML View: Browse to the XML file
					BrowseWebSite(feedUrlLocalFileName, false);
				}

				try
				{
					if(File.Exists(feedUrlLocalFileName))
					{
						cacheFileDate = File.GetLastWriteTime(feedUrlLocalFileName).ToString();
						if(cacheFileDate != null && cacheFileDate.Length > 0)
							statusBarPanelTreeInfo.Text += " (local cache last updated: " + cacheFileDate + ")";
					}
				}
				catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

				try
				{
					//	If showing folder icon, but actually all child nodes are deleted
					//	and if feedUrl is not null, set the feed tree icon
					if(treeNode != null && treeNode.Tag != null && treeNode.Nodes.Count <= 0)
					{
						if( ((TreeNodeTag)(treeNode.Tag)).feedUrl != null &&
							((((TreeNodeTag)(treeNode.Tag)).nodeType & nodeTypeEnum.folderNode) ==  nodeTypeEnum.folderNode)
						  )
						{
							treeNode.ImageIndex = (int)feedTreeImageEnum.feed;
							treeNode.SelectedImageIndex = (int)feedTreeImageEnum.feed;
						}
					}
				}
				catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			finally 
			{
				try
				{
					//	Decrements the reference count so that COM object can be freed
					if(rssXMLDoc != null)
						Marshal.ReleaseComObject(rssXMLDoc);
				}
				catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			}

			return result;
		}

		private void BuildSkinsMenu()
		{
			try
			{
				Cursor = Cursors.WaitCursor;

				//	clear any existing skins menu items
				int totalFavs = menuViewSkin.MenuItems.Count; 
				for(int iIndex=2; iIndex < totalFavs; iIndex++)
					menuViewSkin.MenuItems.RemoveAt(2);
				
				string xsltStylesheet = AppOptions.Instance.GetOption("xsltFile");

				string[] skinFiles = Directory.GetFiles(Application.StartupPath + @"\style", "*.xsl");
				
				int iShortcutKeyIndex=0; //	Assign Ctrl+1 through Ctrl+9 shortcut keys
				foreach (string skinFile in skinFiles)
				{
					string menuItemText = Path.GetFileNameWithoutExtension(skinFile);
					MenuItem newMenuItem = menuViewSkin.MenuItems.Add(menuItemText);
					iShortcutKeyIndex++;

					if(iShortcutKeyIndex < 10)
						newMenuItem.ShowShortcut = true;

					switch(iShortcutKeyIndex)
					{
						case 1: newMenuItem.Shortcut = Shortcut.Ctrl1;
							break;
						case 2: newMenuItem.Shortcut = Shortcut.Ctrl2;
							break;
						case 3: newMenuItem.Shortcut = Shortcut.Ctrl3;
							break;
						case 4: newMenuItem.Shortcut = Shortcut.Ctrl4;
							break;
						case 5: newMenuItem.Shortcut = Shortcut.Ctrl5;
							break;
						case 6: newMenuItem.Shortcut = Shortcut.Ctrl6;
							break;
						case 7: newMenuItem.Shortcut = Shortcut.Ctrl7;
							break;
						case 8: newMenuItem.Shortcut = Shortcut.Ctrl8;
							break;
						case 9: newMenuItem.Shortcut = Shortcut.Ctrl9;
							break;
					}

					newMenuItem.Click += new EventHandler(changeSkinMenu_Click);
				
					if( (xsltStylesheet.ToUpper().CompareTo(Path.GetFileName(skinFile).ToUpper()) ) == 0)
						newMenuItem.Checked = true;
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			finally 
			{
				Cursor = Cursors.Default;
			}
		}

		private void BrowseToHomePage()
		{
			try
			{
				tabControlMain.SelectedIndex = 0;
				string homePageUrl = AppOptions.Instance.GetOption("homepage");
				if(homePageUrl != null)
				{
					tvFeeds.SelectedNode = rootNode;
					BrowseWebSite(homePageUrl, true);
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}
	
		private void ProcessStartupOptions()
		{
			//	showStatusBar
			try
			{
				bool showStatusBar = AppOptions.Instance.GetOption("showStatusBar").CompareTo("1") == 0;
				statusMain.Visible = showStatusBar;
				menuViewStatusBar.Checked = showStatusBar;
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			//	showFeedTree
			try
			{
				bool showLeftFrame = AppOptions.Instance.GetOption("showFeedTree").CompareTo("1") == 0;
				tvFeeds.Visible = showLeftFrame;
				tvWebSites.Visible = showLeftFrame;
				splitter1.Visible = showLeftFrame;
				tabControlMain.Visible  = showLeftFrame;
				menuViewFeedListTree.Checked = showLeftFrame;
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			//	navigationBar
			try
			{
				bool showNavigationBar = AppOptions.Instance.GetOption("navigationBar").CompareTo("1") == 0;
				panelBrowserNavigation.Visible = showNavigationBar;
				menuViewWebNavigation.Checked = showNavigationBar;
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			//	mainWndMaximized
			try
			{
				if((AppOptions.Instance.GetOption("mainWndMaximized").CompareTo("1")) == 0)
					WindowState = FormWindowState.Maximized;
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			//	Create XSLT Stylesheets Skins Menu items (based on .xsl files in style\ folder)
			BuildSkinsMenu();

			EnableDisableMenuItems();
		}

		private void EnableDisableMenuItems()
		{
			try
			{
				TreeNode treeNode = tvFeeds.SelectedNode;

				//	Rootnode enable/disables
				//	Enable items if NOT root node AND NOT child node of an OPML node
				bool itemEnabled = (rootNode != treeNode);
				tcmDelete.Enabled = itemEnabled;
				tcmProperties.Enabled = itemEnabled;
				tcmRename.Enabled = itemEnabled;
				menuViewHomePage.Enabled = itemEnabled;

				//	OPML node enable disables
				if(treeNode!= null && treeNode.Tag != null)
				{
					itemEnabled = ((((TreeNodeTag)(treeNode.Tag)).nodeType & nodeTypeEnum.childNodeToOPML) != nodeTypeEnum.childNodeToOPML);
					tcmDelete.Enabled = itemEnabled;
					tcmRename.Enabled = itemEnabled;
					tcmAdd.Enabled =  itemEnabled;
					menuNewFeed.Enabled =  itemEnabled;

					tcmRefreshOPML.Enabled = (((TreeNodeTag)(treeNode.Tag)).nodeType == nodeTypeEnum.opmlNode);
				}
				
				//	Other nodes enable/disables
				itemEnabled = treeNode != null && treeNode.Tag != null && ((TreeNodeTag)(treeNode.Tag)).feedUrl != null;
				menuExport.Enabled = itemEnabled;
				tcmExport.Enabled = itemEnabled;
				tcmRefresh.Enabled = itemEnabled;
				tcmAddToFav.Enabled  = itemEnabled;
				menuAddToFav.Enabled = itemEnabled;
				menuRefreshCurrentFeed.Enabled = itemEnabled;
				menuViewFeedHTML.Enabled = itemEnabled;
				menuViewFeedXML.Enabled = itemEnabled;
				menuViewSkin.Enabled = itemEnabled;

				tcmDeleteChilds.Enabled = ( (tvFeeds.SelectedNode.Nodes.Count > 0) && (!tcmRefreshOPML.Enabled) );
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}
	
		private void ShowAsTrayIcon(bool flag)
		{
			trayRSSConnect.Visible = flag;
			this.Visible = !flag;

			if(!flag)
				WindowState = FormWindowState.Maximized;
		}
		
		private void SwitchToXML(bool xml)
		{
			try
			{
				menuViewFeedXML.Checked = xml;
				menuViewFeedHTML.Checked = !xml;

				ShowRSS(false);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private bool LoadWebSitesTree()
		{
			bool result = false;
			try
			{
				Cursor = Cursors.WaitCursor;
				string favFolderPath = Environment.GetFolderPath(Environment.SpecialFolder.Favorites);

				//	Disables any redrawing of the tree view till we are done
				tvWebSites.BeginUpdate();

				LoadFavFromFolder(new DirectoryInfo(favFolderPath), webSitesRootNode);
				LoadFavFromPath(favFolderPath, webSitesRootNode);

				result = true;
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			finally 
			{
				Cursor = Cursors.Default;
				tvWebSites.EndUpdate();
			}

			return result;
		}

		private void LoadFavFromFolder(DirectoryInfo curDirInfo, TreeNode curNode) 
		{
			try
			{
				TreeNode newNode;

				foreach (DirectoryInfo dirInfo in curDirInfo.GetDirectories())
				{
					if (curNode == null) 
						newNode = tvWebSites.Nodes.Add(dirInfo.Name);
					else
						newNode = curNode.Nodes.Add(dirInfo.Name);

					if (dirInfo.GetDirectories().Length == 0) 
						LoadFavFromPath(dirInfo.FullName, newNode);
					else 
						LoadFavFromFolder(dirInfo, newNode);
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void LoadFavFromPath(string curPath, TreeNode curNode)
		{
			try
			{
				DirectoryInfo curDirInfo = new DirectoryInfo(curPath);

				foreach (FileInfo objFile in curDirInfo.GetFiles("*.url")) 
				{
					TreeNode newNode = new TreeNode();

					string fileName = objFile.FullName;
					newNode.Tag = GetURLValue(fileName);
					newNode.Text = Path.GetFileNameWithoutExtension(fileName);
					newNode.ImageIndex = 2;
					newNode.SelectedImageIndex = 2;

					if (curNode == null)
						tvWebSites.Nodes.Add(newNode);
					else 
						curNode.Nodes.Add(newNode);
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		//	Reading favorites file as INI file getting the value of URL=
		private string GetURLValue(string fileName)
		{
			string strURL = null;
			StreamReader reader=null;
			try
			{
				reader = new StreamReader(fileName);
				string fileLine;
				int iIndex=-1;
				while((fileLine = reader.ReadLine()) != null)
				{
					if(fileLine != null)
					{
						if((iIndex = fileLine.IndexOf("URL=")) >= 0)
						{
							strURL = fileLine.Substring(iIndex+4);
							break;
						}
					}
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			finally
			{
				try { if(reader != null) reader.Close();} 
				catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			}

			return strURL;
		}

		private TreeNode AddFolderNode(TreeNode curNode, string newNodeName, bool beginRename)
		{
			TreeNode newTreeNode = new TreeNode(newNodeName);
			try
			{
				if(curNode == null || curNode.Text == null)
					return newTreeNode;

				string nodeText = curNode.Text;

				//	Update the XML Document
				LoadFeedXMLInDOM();
				XmlNode parentNode;
				if(curNode == rootNode)
				{
					parentNode = feedsXMLDoc.DocumentElement;
				}
				else
				{
					parentNode = GetFeedXmlNodeByName(nodeText);
				}

				XmlElement newNode = feedsXMLDoc.CreateElement("treenode");
				newNode.SetAttribute("text", newNodeName);
				newNode.SetAttribute("type", "folder");

				//	NOTE:: IMPORTANT: making sure to create </treenode>
				//	for folder nodes
				newNode.InnerText = newNodeName;

				parentNode.AppendChild(newNode);
				((XmlElement)parentNode).SetAttribute("type", "folder");

				feedsXMLDoc.Save(feedsFileName);

				//	update the UI
				newTreeNode.Tag = new TreeNodeTag();
				((TreeNodeTag)(newTreeNode.Tag)).nodeType = nodeTypeEnum.folderNode;

				newTreeNode.Text = newNodeName;
				curNode.Nodes.Add(newTreeNode);

				newTreeNode.ImageIndex = (int)feedTreeImageEnum.folder;
				newTreeNode.SelectedImageIndex = (int)feedTreeImageEnum.folder;

				tvFeeds.SelectedNode = newTreeNode;
				if(beginRename)
				{
					//	allow user to rename the node
					newTreeNode.BeginEdit();
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			return newTreeNode;
		}

		public void RefreshOPMLNode(TreeNode treeNode)
		{
			try
			{
				Cursor = Cursors.WaitCursor;
				string opmlUrl = ((TreeNodeTag)(treeNode.Tag)).opmlUrl;
				DebugLog.Instance.DEBUG2("Reloading OPML URL " + opmlUrl);

				Utility utility = new Utility();
				string opmlCacheFile = utility.GetCacheFileNameFromUrl(opmlUrl);
				
				DOMDocument30Class opmlXMLDoc = 
					utility.DownloadAndSave(opmlUrl, opmlCacheFile, false);
				try
				{
					Marshal.ReleaseComObject(opmlXMLDoc);
				}
				catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

				if(File.Exists(opmlCacheFile))
				{
					XmlTextReader opmlReader = 
						new XmlTextReader(opmlCacheFile);

					treeNode.Nodes.Clear();

					ProcessXML(opmlReader, treeNode);	//	recursive function
					opmlReader.Close();
					statusBarPanelTreeInfo.Text = GetOPMLLastUpdatedDateTime(tvFeeds.SelectedNode);
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			finally {Cursor = Cursors.Default;}
		}

		private string GetOPMLLastUpdatedDateTime(TreeNode treeNode)
		{
			string result = null;
			try
			{
				string opmlUrl = ((TreeNodeTag)(treeNode.Tag)).opmlUrl;
				DebugLog.Instance.DEBUG3("Getting OPML cache file updated time for " + opmlUrl);
				Utility utility = new Utility();
				string opmlCacheFile = utility.GetCacheFileNameFromUrl(opmlUrl);
				string cacheFileDate = File.GetLastWriteTime(opmlCacheFile).ToString();
				string nodesMsg;
				int nodeCount = treeNode.Nodes.Count;
				if(nodeCount == 1)
					nodesMsg = "1 node.";
				else
					nodesMsg = nodeCount.ToString() + " nodes.";

				if(cacheFileDate != null && cacheFileDate.Length > 0)
					result = " {OPML list last updated: " + cacheFileDate + "} " + nodesMsg;
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			return result;
		}

		private void AddFeedNodeWithUI()
		{
			try
			{
				frmAddNew addNewFeedForm = new frmAddNew();
				if(addNewFeedForm.ShowDialog() == DialogResult.OK)
				{
					AddFeedNode(addNewFeedForm.feedTitle, 
						addNewFeedForm.feedUrl, tvFeeds.SelectedNode);
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		public void AddFeedNode(string nodeTitle, string feedUrl, string parentNodeName)
		{
			try
			{
				DebugLog.Instance.DEBUG2("Finding parent node " + parentNodeName);
				TreeNode parentNode;
				if((parentNodeName.CompareTo(tvFeeds.Nodes[0].Text)) == 0)
					parentNode = rootNode;
				else
					parentNode = GetNodeByName(parentNodeName, rootNode.Nodes);
				if(parentNode == null)
				{
					DebugLog.Instance.DEBUG2("Not found! Creating a new node under root node.");
					parentNode = AddFolderNode(rootNode, parentNodeName, false);
					if(parentNode == null)
					{
						DebugLog.Instance.DEBUG2("Failed while creating new tree node. Using default root node...");
						parentNode = rootNode;
					}
				}
				AddFeedNode(nodeTitle, feedUrl, parentNode);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void UpdateNode(string oldNodeText, string oldFeedUrl, string oldOPMLUrl, string newNodeText, string newFeedUrl, string newOPMLUrl, TreeNode treeNode)
		{
			try
			{
				//	Update the XML Document first
				DebugLog.Instance.DEBUG2("Finding node by name " + oldNodeText);
				XmlNode nodeToBeUpdated = GetFeedXmlNodeByName(oldNodeText);
				if(nodeToBeUpdated != null)
				{
					DebugLog.Instance.DEBUG2("Updating attributes... " );

					if(newNodeText != null)
						((XmlElement)(nodeToBeUpdated)).SetAttribute("text", newNodeText);

					if(newFeedUrl != null)
					{
						//	Update Feed list
						try
						{
							feedList[oldFeedUrl] = null;
						}
						catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

						if(newFeedUrl.Length <= 0)
							((XmlElement)(nodeToBeUpdated)).RemoveAttribute("feedUrl");
						else
						{
							((XmlElement)(nodeToBeUpdated)).SetAttribute("feedUrl", newFeedUrl);
							try
							{
								feedList[newFeedUrl] = newNodeText;
							}
							catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
						}

					}

					if(newOPMLUrl != null)
						((XmlElement)(nodeToBeUpdated)).SetAttribute("opmlUrl", newOPMLUrl);

					//	Making sure type="folder" is the last attribute
					if(nodeToBeUpdated.Attributes["type"] != null)
					{
						//	delete
						string nodeTypeValue = nodeToBeUpdated.Attributes["type"].Value;
						((XmlElement)(nodeToBeUpdated)).RemoveAttribute("type");

						//	and re-create type attribute
						((XmlElement)(nodeToBeUpdated)).SetAttribute("type", nodeTypeValue);
					}

					DebugLog.Instance.DEBUG2("Saving updated XML document... " );
					feedsXMLDoc.Save(feedsFileName);
				}

				//	Updating the Tree Node
				DebugLog.Instance.DEBUG2("Updating UI... " );
				if( (newNodeText != null) && (treeNode.Text.CompareTo(newNodeText)) != 0)
					treeNode.Text = newNodeText;

				if(newFeedUrl != null)
				{
					if(newFeedUrl.Length <= 0)
					{	
						((TreeNodeTag)(treeNode.Tag)).nodeType = 
							((TreeNodeTag)(treeNode.Tag)).nodeType & ~nodeTypeEnum.feedNode;
						((TreeNodeTag)(treeNode.Tag)).feedUrl = null;
					}
					else
						((TreeNodeTag)(treeNode.Tag)).feedUrl = newFeedUrl;
				}

				if(newOPMLUrl != null)
					((TreeNodeTag)(treeNode.Tag)).opmlUrl = newOPMLUrl;

				//	Refresh the RSS View
				ShowRSS(true);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void AddFeedNode(string nodeTitle, string feedUrl, TreeNode treeNode)
		{
			try
			{
				if(treeNode == null || treeNode.Text == null)
					return;

				string parentNodeText = treeNode.Text;

				//	Update the XML Document
				LoadFeedXMLInDOM();
				XmlNode parentNode;
				if(treeNode == rootNode)
					parentNode = feedsXMLDoc.DocumentElement;
				else
					parentNode = GetFeedXmlNodeByName(parentNodeText);

				if(parentNode == null)
				{
					DebugLog.Instance.REPORT("Creating new XML folder node " + parentNodeText);
					parentNode = feedsXMLDoc.CreateElement("treenode");
					((XmlElement)parentNode).SetAttribute("text", parentNodeText);
					((XmlElement)parentNode).SetAttribute("type", "folder");
					parentNode.InnerText = parentNodeText;
					feedsXMLDoc.DocumentElement.AppendChild(parentNode);
				}

				XmlElement newNode = feedsXMLDoc.CreateElement("treenode");
				newNode.SetAttribute("text", nodeTitle);
				newNode.SetAttribute("feedUrl", feedUrl);

				parentNode.AppendChild(newNode);
				((XmlElement)parentNode).SetAttribute("type", "folder");

				feedsXMLDoc.Save(feedsFileName);

				//	update the UI
				TreeNode newTreeNode = new TreeNode();
				newTreeNode.Tag = new TreeNodeTag();
				((TreeNodeTag)(newTreeNode.Tag)).nodeType = nodeTypeEnum.feedNode;
				((TreeNodeTag)(newTreeNode.Tag)).feedUrl = feedUrl;
				newTreeNode.Text = nodeTitle;
				treeNode.Nodes.Add(newTreeNode);

				newTreeNode.ImageIndex = (int)feedTreeImageEnum.feed;
				newTreeNode.SelectedImageIndex = (int)feedTreeImageEnum.feed;

				try { feedList[feedUrl] = nodeTitle; } 
				catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

				tvFeeds.SelectedNode = newTreeNode;
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void BrowseWebSite(string webSitUrl, bool showAddrOnStatusBar)
		{
			try
			{
				Object o = null;
				axFeedReaderWebBrowser.Navigate(webSitUrl, ref o, ref o, ref o, ref o);
				if(showAddrOnStatusBar)
					statusBarPanelTreeInfo.Text = webSitUrl;
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void CleanFeedListForNode(TreeNode treeNode)
		{
			try
			{
				foreach(TreeNode curNode in treeNode.Nodes)
				{
					if(curNode != null && curNode.Tag != null)
					{
						if (((TreeNodeTag)(curNode.Tag)).feedUrl != null)
						{
							try {feedList.Remove(((TreeNodeTag)(curNode.Tag)).feedUrl);} 
							catch(Exception exp)  {DebugLog.Instance.REPORT(exp);}
						}
					}

					if(curNode != null && curNode.Tag != null)
					{
						if ((((TreeNodeTag)(treeNode.Tag)).nodeType & nodeTypeEnum.folderNode) == nodeTypeEnum.folderNode)
							CleanFeedListForNode(curNode);
					}
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

		}

		private void BrowseSearchPage(string searchUrl, string searchText, string menuText)
		{
			try
			{
				searchText = System.Web.HttpUtility.UrlEncode(searchText);

				searchUrl =  searchUrl + searchText;
				
				AppOptions.Instance.SetOption("searchUsing", menuText);
				
				BrowseWebSite(searchUrl, true);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}
		private void MoveNode(TreeNode nodeToBeMoved, TreeNode DestinationNode)
		{
			try
			{
				string movingNodeText = nodeToBeMoved.Text;
				string destNodeText = DestinationNode.Text;
				DebugLog.Instance.DEBUG2("Moving " + movingNodeText + " to " + destNodeText);
					 
				//	1. Update the UI
				//	Prevent drag/drop of parent node on the child
				if(DestinationNode.FullPath.IndexOf(nodeToBeMoved.FullPath) >= 0)
					return;

				//	Prevent drag/drop on the same (current) parent node
				if(DestinationNode == nodeToBeMoved.Parent)
					return;

				if(DestinationNode.TreeView == nodeToBeMoved.TreeView)
				{   
					TreeNode clonedNode = (TreeNode) nodeToBeMoved.Clone();
					//	Remove Original Node
					nodeToBeMoved.Remove();

					DestinationNode.Nodes.Add(clonedNode);
					DestinationNode.ImageIndex = (int)feedTreeImageEnum.folder;
					DestinationNode.SelectedImageIndex = (int)feedTreeImageEnum.folder;
					tvFeeds.SelectedNode = clonedNode;
				}

				//	2. Save Feed XML
				LoadFeedXMLInDOM();
				XmlNode xmlNodeToBeMoved = GetFeedXmlNodeByName(movingNodeText);
				if(xmlNodeToBeMoved != null)
				{
					XmlNode xmlDestNode = GetFeedXmlNodeByName(destNodeText);
					if(xmlDestNode != null)
					{
						xmlDestNode.AppendChild(xmlNodeToBeMoved);
						((XmlElement)(xmlDestNode)).SetAttribute("type", "folder");

						feedsXMLDoc.Save(feedsFileName);
					}
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void ShowHideTree()
		{
			try
			{
				menuViewFeedListTree.Checked = !menuViewFeedListTree.Checked;
				tvFeeds.Visible = menuViewFeedListTree.Checked;
				tvWebSites.Visible = menuViewFeedListTree.Checked;
				splitter1.Visible  = menuViewFeedListTree.Checked;
				tabControlMain.Visible  = menuViewFeedListTree.Checked;

				if(menuViewFeedListTree.Checked)
					AppOptions.Instance.SetOption("showFeedTree", "1");
				else
					AppOptions.Instance.SetOption("showFeedTree", "0");
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}
		
		private void DeleteNode(bool deleteOnlyChildNodes)
		{
			try
			{
				TreeNode treeNode = tvFeeds.SelectedNode;
				if(!deleteOnlyChildNodes  && treeNode == rootNode)
					return;

				if(treeNode != null)
				{
					bool deleteConfirmed = true;
					string treeNodeText = treeNode.Text;

					string deleteMessage = "Are you sure you want to delete '" + treeNodeText + "'?";
					if(treeNode.Nodes.Count > 0)
					{
						if(deleteOnlyChildNodes)
							deleteMessage = "Are you sure you want to delete all child nodes of '" + treeNodeText +"' ?";
						else
							deleteMessage = "Are you sure you want to delete '" + treeNodeText + "' and all its child nodes?";
					}

					if( (AppOptions.Instance.GetOption("confirmDelete").CompareTo("1")) == 0 )
					{
						if( MessageBox.Show(deleteMessage, "Confirm Delete", MessageBoxButtons.YesNo) ==
							DialogResult.No)
						{
							deleteConfirmed = false;
						}
					}
					if(deleteConfirmed)
					{
						DebugLog.Instance.DEBUG3("Deletion Confirmed.");

						XmlNode nodeToBeDeleted = GetFeedXmlNodeByName(treeNodeText);

						if(nodeToBeDeleted != null)
						{
							DebugLog.Instance.DEBUG2("Node found!");

							if(deleteOnlyChildNodes)
							{
								int childNodeCount = nodeToBeDeleted.ChildNodes.Count;
								for(int iIndex=0; iIndex < childNodeCount; iIndex++)
									nodeToBeDeleted.RemoveChild(nodeToBeDeleted.ChildNodes.Item(0));
							}
							else
							{
								nodeToBeDeleted.RemoveAll();
								nodeToBeDeleted.ParentNode.RemoveChild(nodeToBeDeleted);
							}


							DebugLog.Instance.DEBUG2("Saving the updated document...");
							feedsXMLDoc.Save(feedsFileName);

							if(treeNode != null && treeNode.Tag != null)
							{
								if (((TreeNodeTag)(treeNode.Tag)).feedUrl != null)
								{
									try {feedList.Remove(((TreeNodeTag)(treeNode.Tag)).feedUrl);} 
									catch(Exception exp)  {DebugLog.Instance.REPORT(exp);}
								}
							}

							//	If folder node, recursively clean up feedList
							if(treeNode != null && treeNode.Tag != null)
							{
								if ((((TreeNodeTag)(treeNode.Tag)).nodeType & nodeTypeEnum.folderNode) == nodeTypeEnum.folderNode)
								{
									DebugLog.Instance.DEBUG3("Recursively cleaning up FeedList for folder " + treeNodeText);
									CleanFeedListForNode(treeNode);
								}
							}

							DebugLog.Instance.DEBUG2("Refreshing the tree...");
							if(deleteOnlyChildNodes)
								treeNode.Nodes.Clear();
							else
								treeNode.Remove();
						}
						else
						{
							DebugLog.Instance.DEBUG2("Node not found!");
						}
					}
				}
			}
			catch(Exception exp) 
			{
				DebugLog.Instance.REPORT(exp);
				MessageBox.Show(exp.ToString(), "Error");
			}
		}
		
		public void ImportOPML(TreeNode treeNode, string opmlFile)
		{//1.0.0.1 change
			try
			{
				//	1. Updating Feeds XML File
				//	1a. Loads Feeds XML document if not already loaded
				LoadFeedXMLInDOM();
			
				//	1b. Load OPML XML doc
				XmlDocument opmlDoc = new XmlDocument();
				opmlDoc.Load(opmlFile);
				
				//	1c. Transform OPML document to format expected by Feeds XML
				XslTransform opmlToFeedsXSLT = new XslTransform();
				opmlToFeedsXSLT.Load(Application.StartupPath + @"\OPMLToFeeds.xslt");
				MemoryStream memStream = new MemoryStream();
				//	To support .NET Framework 1.0, not passing the XmlResolver
				//opmlToFeedsXSLT.Transform(opmlDoc, null, memStream, null);
				XsltArgumentList xslArg = new XsltArgumentList();
				string importOPMLFileNameNoExt = Path.GetFileNameWithoutExtension(opmlFile);
				xslArg.AddParam("sourceFileName", "", importOPMLFileNameNoExt);
				opmlToFeedsXSLT.Transform(opmlDoc, xslArg, memStream);

				//	Load trasnformed XML document
				memStream.Position = 0;
				opmlDoc = new XmlDocument();
				opmlDoc.XmlResolver= null;
				opmlDoc.Load(memStream);
				
				TreeNode curNode = tvFeeds.SelectedNode;
				XmlNode nodeToAddTo = GetFeedXmlNodeByName(curNode.Text);
				if(nodeToAddTo != null)
				{
					XmlNode opmlDocNode = nodeToAddTo.OwnerDocument.ImportNode(opmlDoc.DocumentElement, true);
					nodeToAddTo.AppendChild(opmlDocNode);
					feedsXMLDoc.Save(feedsFileName);
				}

				//	2. Updating UI
				memStream.Position = 0;
				XmlTextReader opmlReader = null;
				try
				{
					if(File.Exists(opmlFile))
					{
						opmlReader = new XmlTextReader(memStream, opmlDoc.NameTable);
						ProcessXML(opmlReader, curNode);
					}
				}
				catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
				finally 
				{
					try { if(opmlReader != null) opmlReader.Close(); } 
					catch(Exception) {}

					try { if(memStream != null) memStream.Close(); }
					catch(Exception) {}
				}
			}
			catch(Exception exp) 
			{
				DebugLog.Instance.REPORT(exp);
				MessageBox.Show(exp.ToString(), Application.ProductName);
			}
		}
		
		#endregion
	}	
}	
