#region USING
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
#endregion
namespace RSSConnect
{
	/// <summary>
	/// Options Form
	/// </summary>
	public class frmOptions : System.Windows.Forms.Form
	{
		#region PUBLIC_PRIVATE_FIELDS
		//	List of favorites that user wants to delete from the Favorites list
		public ArrayList removedFavs;

		//	Current Favorites List
		private Hashtable favList;

		//	Options tree root node
		private TreeNode rootNode;

		private System.Windows.Forms.TreeView tvOptions;
		private System.Windows.Forms.Panel panelEnvGeneral;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.CheckBox chkTrayWhenMinimized;
		private System.Windows.Forms.CheckBox chkTrayWhenClose;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.CheckBox chkSplash;
		private System.Windows.Forms.CheckBox chkMaximized;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Panel panelEnvStartup;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.ComboBox comboHomePage;
		private System.Windows.Forms.Panel panelEnvOnExit;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.Panel panelUpdatesGeneral;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.GroupBox groupBox5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.ComboBox comboUpdatesURL;
		private System.Windows.Forms.Panel panelDatabaseGeneral;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.GroupBox groupBox6;
		private System.Windows.Forms.RadioButton radioOLEDB;
		private System.Windows.Forms.RadioButton radioSQL;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.ComboBox comboSQLServer;
		private System.Windows.Forms.ComboBox comboOLEDBConnStr;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.TextBox txtLoginID;
		private System.Windows.Forms.TextBox txtPassword;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.CheckBox chkNTAuthentication;
		private System.Windows.Forms.ComboBox comboDatabase;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Panel panelDatabaseIndexing;
		private System.Windows.Forms.GroupBox groupBox7;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Button btnIndexNow;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.CheckBox chkConfirmDelete;
		private System.Windows.Forms.CheckBox chkClearHTMLCache;
		private System.Windows.Forms.CheckBox chkClearXMLCache;
		private System.Windows.Forms.PictureBox warningImage;
		private System.Windows.Forms.Label warningText;
		private System.Windows.Forms.Button btnTestConnection;
		private System.Windows.Forms.CheckBox chkSavePassword;
		private System.Windows.Forms.Button btnClearHTMLCache;
		private System.Windows.Forms.Button btnClearXMLCache;
		private System.Windows.Forms.ToolTip ctrlToolTip;
		private System.Windows.Forms.Panel panelEnvFavorites;
		private System.Windows.Forms.ListView lvFavorites;
		private System.Windows.Forms.ColumnHeader colTitle;
		private System.Windows.Forms.ColumnHeader colFeedUrl;
		private System.Windows.Forms.Button btnRemoveFav;
		private System.Windows.Forms.GroupBox groupBox8;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.ImageList imageListOptionsTree;
		private System.Windows.Forms.Label lblCacheFolderSize;
		private System.Windows.Forms.Label lblLastIndexDate;
		private System.Windows.Forms.CheckBox chkEmptyPassword;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.CheckBox chkIndexAfterExport;
		private System.ComponentModel.IContainer components;
		#endregion
		#region CTOR_DTOR
		public frmOptions(Hashtable favList)
		{
			InitializeComponent();

			this.removedFavs = new ArrayList();
			this.favList = favList;
		}
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmOptions));
			this.tvOptions = new System.Windows.Forms.TreeView();
			this.imageListOptionsTree = new System.Windows.Forms.ImageList(this.components);
			this.panelEnvGeneral = new System.Windows.Forms.Panel();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.chkConfirmDelete = new System.Windows.Forms.CheckBox();
			this.chkTrayWhenClose = new System.Windows.Forms.CheckBox();
			this.chkTrayWhenMinimized = new System.Windows.Forms.CheckBox();
			this.label1 = new System.Windows.Forms.Label();
			this.panelEnvStartup = new System.Windows.Forms.Panel();
			this.comboHomePage = new System.Windows.Forms.ComboBox();
			this.label3 = new System.Windows.Forms.Label();
			this.chkMaximized = new System.Windows.Forms.CheckBox();
			this.chkSplash = new System.Windows.Forms.CheckBox();
			this.label2 = new System.Windows.Forms.Label();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.panelEnvOnExit = new System.Windows.Forms.Panel();
			this.lblCacheFolderSize = new System.Windows.Forms.Label();
			this.btnClearXMLCache = new System.Windows.Forms.Button();
			this.btnClearHTMLCache = new System.Windows.Forms.Button();
			this.chkClearXMLCache = new System.Windows.Forms.CheckBox();
			this.chkClearHTMLCache = new System.Windows.Forms.CheckBox();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.label4 = new System.Windows.Forms.Label();
			this.panelUpdatesGeneral = new System.Windows.Forms.Panel();
			this.comboUpdatesURL = new System.Windows.Forms.ComboBox();
			this.label6 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.groupBox5 = new System.Windows.Forms.GroupBox();
			this.panelDatabaseGeneral = new System.Windows.Forms.Panel();
			this.chkEmptyPassword = new System.Windows.Forms.CheckBox();
			this.btnTestConnection = new System.Windows.Forms.Button();
			this.chkSavePassword = new System.Windows.Forms.CheckBox();
			this.comboDatabase = new System.Windows.Forms.ComboBox();
			this.label11 = new System.Windows.Forms.Label();
			this.chkNTAuthentication = new System.Windows.Forms.CheckBox();
			this.txtPassword = new System.Windows.Forms.TextBox();
			this.label10 = new System.Windows.Forms.Label();
			this.txtLoginID = new System.Windows.Forms.TextBox();
			this.label9 = new System.Windows.Forms.Label();
			this.comboSQLServer = new System.Windows.Forms.ComboBox();
			this.label8 = new System.Windows.Forms.Label();
			this.radioSQL = new System.Windows.Forms.RadioButton();
			this.comboOLEDBConnStr = new System.Windows.Forms.ComboBox();
			this.radioOLEDB = new System.Windows.Forms.RadioButton();
			this.groupBox6 = new System.Windows.Forms.GroupBox();
			this.label7 = new System.Windows.Forms.Label();
			this.panelDatabaseIndexing = new System.Windows.Forms.Panel();
			this.label15 = new System.Windows.Forms.Label();
			this.lblLastIndexDate = new System.Windows.Forms.Label();
			this.label13 = new System.Windows.Forms.Label();
			this.btnIndexNow = new System.Windows.Forms.Button();
			this.groupBox7 = new System.Windows.Forms.GroupBox();
			this.label12 = new System.Windows.Forms.Label();
			this.warningImage = new System.Windows.Forms.PictureBox();
			this.warningText = new System.Windows.Forms.Label();
			this.ctrlToolTip = new System.Windows.Forms.ToolTip(this.components);
			this.panelEnvFavorites = new System.Windows.Forms.Panel();
			this.groupBox8 = new System.Windows.Forms.GroupBox();
			this.label14 = new System.Windows.Forms.Label();
			this.btnRemoveFav = new System.Windows.Forms.Button();
			this.lvFavorites = new System.Windows.Forms.ListView();
			this.colTitle = new System.Windows.Forms.ColumnHeader();
			this.colFeedUrl = new System.Windows.Forms.ColumnHeader();
			this.chkIndexAfterExport = new System.Windows.Forms.CheckBox();
			this.panelEnvGeneral.SuspendLayout();
			this.panelEnvStartup.SuspendLayout();
			this.panelEnvOnExit.SuspendLayout();
			this.panelUpdatesGeneral.SuspendLayout();
			this.panelDatabaseGeneral.SuspendLayout();
			this.panelDatabaseIndexing.SuspendLayout();
			this.panelEnvFavorites.SuspendLayout();
			this.SuspendLayout();
			// 
			// tvOptions
			// 
			this.tvOptions.HideSelection = false;
			this.tvOptions.ImageIndex = 4;
			this.tvOptions.ImageList = this.imageListOptionsTree;
			this.tvOptions.Location = new System.Drawing.Point(8, 8);
			this.tvOptions.Name = "tvOptions";
			this.tvOptions.Nodes.AddRange(new System.Windows.Forms.TreeNode[] {
																				  new System.Windows.Forms.TreeNode("Options", new System.Windows.Forms.TreeNode[] {
																																									   new System.Windows.Forms.TreeNode("Environment", new System.Windows.Forms.TreeNode[] {
																																																																new System.Windows.Forms.TreeNode("General"),
																																																																new System.Windows.Forms.TreeNode("Startup"),
																																																																new System.Windows.Forms.TreeNode("On Exit"),
																																																																new System.Windows.Forms.TreeNode("Favorites")}),
																																									   new System.Windows.Forms.TreeNode("Updates", new System.Windows.Forms.TreeNode[] {
																																																															new System.Windows.Forms.TreeNode("General")}),
																																									   new System.Windows.Forms.TreeNode("Database", new System.Windows.Forms.TreeNode[] {
																																																															 new System.Windows.Forms.TreeNode("General"),
																																																															 new System.Windows.Forms.TreeNode("Indexing")})})});
			this.tvOptions.SelectedImageIndex = 4;
			this.tvOptions.ShowLines = false;
			this.tvOptions.ShowRootLines = false;
			this.tvOptions.Size = new System.Drawing.Size(152, 272);
			this.tvOptions.TabIndex = 0;
			this.tvOptions.AfterExpand += new System.Windows.Forms.TreeViewEventHandler(this.tvOptions_AfterExpand);
			this.tvOptions.AfterCollapse += new System.Windows.Forms.TreeViewEventHandler(this.tvOptions_AfterCollapse);
			this.tvOptions.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.tvOptions_AfterSelect);
			// 
			// imageListOptionsTree
			// 
			this.imageListOptionsTree.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit;
			this.imageListOptionsTree.ImageSize = new System.Drawing.Size(16, 16);
			this.imageListOptionsTree.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageListOptionsTree.ImageStream")));
			this.imageListOptionsTree.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// panelEnvGeneral
			// 
			this.panelEnvGeneral.Controls.Add(this.groupBox1);
			this.panelEnvGeneral.Controls.Add(this.chkConfirmDelete);
			this.panelEnvGeneral.Controls.Add(this.chkTrayWhenClose);
			this.panelEnvGeneral.Controls.Add(this.chkTrayWhenMinimized);
			this.panelEnvGeneral.Controls.Add(this.label1);
			this.panelEnvGeneral.Location = new System.Drawing.Point(168, 8);
			this.panelEnvGeneral.Name = "panelEnvGeneral";
			this.panelEnvGeneral.Size = new System.Drawing.Size(352, 264);
			this.panelEnvGeneral.TabIndex = 1;
			this.panelEnvGeneral.Visible = false;
			// 
			// groupBox1
			// 
			this.groupBox1.Location = new System.Drawing.Point(51, 12);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(293, 4);
			this.groupBox1.TabIndex = 5;
			this.groupBox1.TabStop = false;
			// 
			// chkConfirmDelete
			// 
			this.chkConfirmDelete.Location = new System.Drawing.Point(24, 80);
			this.chkConfirmDelete.Name = "chkConfirmDelete";
			this.chkConfirmDelete.Size = new System.Drawing.Size(312, 16);
			this.chkConfirmDelete.TabIndex = 4;
			this.chkConfirmDelete.Text = "&Confirm when deleting tree nodes";
			this.ctrlToolTip.SetToolTip(this.chkConfirmDelete, "If checked, you will be prompted for each tree node delete operation.");
			// 
			// chkTrayWhenClose
			// 
			this.chkTrayWhenClose.Location = new System.Drawing.Point(24, 56);
			this.chkTrayWhenClose.Name = "chkTrayWhenClose";
			this.chkTrayWhenClose.Size = new System.Drawing.Size(312, 16);
			this.chkTrayWhenClose.TabIndex = 3;
			this.chkTrayWhenClose.Text = "S&how as tray icon when closed";
			this.ctrlToolTip.SetToolTip(this.chkTrayWhenClose, "If checked, RSSConnect application will not exit when you click on the Close butt" +
				"on, and will keep running as a system tray icon.");
			// 
			// chkTrayWhenMinimized
			// 
			this.chkTrayWhenMinimized.Location = new System.Drawing.Point(24, 32);
			this.chkTrayWhenMinimized.Name = "chkTrayWhenMinimized";
			this.chkTrayWhenMinimized.Size = new System.Drawing.Size(312, 16);
			this.chkTrayWhenMinimized.TabIndex = 2;
			this.chkTrayWhenMinimized.Text = "&Show as tray icon when minimized";
			this.ctrlToolTip.SetToolTip(this.chkTrayWhenMinimized, "If checked, RSSConnect will not appear on task bar when minimized, but will be av" +
				"ailable as a system tray icon.");
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(45, 16);
			this.label1.TabIndex = 0;
			this.label1.Text = "General";
			// 
			// panelEnvStartup
			// 
			this.panelEnvStartup.Controls.Add(this.comboHomePage);
			this.panelEnvStartup.Controls.Add(this.label3);
			this.panelEnvStartup.Controls.Add(this.chkMaximized);
			this.panelEnvStartup.Controls.Add(this.chkSplash);
			this.panelEnvStartup.Controls.Add(this.label2);
			this.panelEnvStartup.Controls.Add(this.groupBox2);
			this.panelEnvStartup.Location = new System.Drawing.Point(168, 8);
			this.panelEnvStartup.Name = "panelEnvStartup";
			this.panelEnvStartup.Size = new System.Drawing.Size(352, 264);
			this.panelEnvStartup.TabIndex = 2;
			this.panelEnvStartup.Visible = false;
			// 
			// comboHomePage
			// 
			this.comboHomePage.Items.AddRange(new object[] {
															   "http://www.PerfectXML.com",
															   "http://www.google.com",
															   "about:blank",
															   "http://www.msdn.com",
															   "http://www-106.ibm.com/developerworks",
															   "http://java.sun.com",
															   "http://otn.oracle.com"});
			this.comboHomePage.Location = new System.Drawing.Point(24, 96);
			this.comboHomePage.Name = "comboHomePage";
			this.comboHomePage.Size = new System.Drawing.Size(320, 21);
			this.comboHomePage.TabIndex = 5;
			this.ctrlToolTip.SetToolTip(this.comboHomePage, "This is the URL to which RSSConnect will browse to when it starts up or when you " +
				"select to browse to home page.");
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(24, 80);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(320, 16);
			this.label3.TabIndex = 4;
			this.label3.Text = "&Home Page URL";
			// 
			// chkMaximized
			// 
			this.chkMaximized.Location = new System.Drawing.Point(24, 56);
			this.chkMaximized.Name = "chkMaximized";
			this.chkMaximized.Size = new System.Drawing.Size(320, 16);
			this.chkMaximized.TabIndex = 3;
			this.chkMaximized.Text = "&Open Maximized";
			this.ctrlToolTip.SetToolTip(this.chkMaximized, "If checked, RSSConnect window will be maximized during startup.");
			// 
			// chkSplash
			// 
			this.chkSplash.Location = new System.Drawing.Point(24, 32);
			this.chkSplash.Name = "chkSplash";
			this.chkSplash.Size = new System.Drawing.Size(320, 16);
			this.chkSplash.TabIndex = 2;
			this.chkSplash.Text = "&Show Splash Screen";
			this.ctrlToolTip.SetToolTip(this.chkSplash, "If checked, RSSConnect splash screen will be shown on startup.");
			// 
			// label2
			// 
			this.label2.AutoSize = true;
			this.label2.Location = new System.Drawing.Point(8, 8);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(41, 16);
			this.label2.TabIndex = 0;
			this.label2.Text = "Startup";
			// 
			// groupBox2
			// 
			this.groupBox2.Location = new System.Drawing.Point(51, 12);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(293, 4);
			this.groupBox2.TabIndex = 1;
			this.groupBox2.TabStop = false;
			// 
			// groupBox3
			// 
			this.groupBox3.Location = new System.Drawing.Point(168, 276);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(352, 4);
			this.groupBox3.TabIndex = 3;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "groupBox3";
			// 
			// btnOK
			// 
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.Location = new System.Drawing.Point(352, 296);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 4;
			this.btnOK.Text = "OK";
			this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(440, 296);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 5;
			this.btnCancel.Text = "Cancel";
			// 
			// panelEnvOnExit
			// 
			this.panelEnvOnExit.Controls.Add(this.lblCacheFolderSize);
			this.panelEnvOnExit.Controls.Add(this.btnClearXMLCache);
			this.panelEnvOnExit.Controls.Add(this.btnClearHTMLCache);
			this.panelEnvOnExit.Controls.Add(this.chkClearXMLCache);
			this.panelEnvOnExit.Controls.Add(this.chkClearHTMLCache);
			this.panelEnvOnExit.Controls.Add(this.groupBox4);
			this.panelEnvOnExit.Controls.Add(this.label4);
			this.panelEnvOnExit.Location = new System.Drawing.Point(168, 8);
			this.panelEnvOnExit.Name = "panelEnvOnExit";
			this.panelEnvOnExit.Size = new System.Drawing.Size(352, 264);
			this.panelEnvOnExit.TabIndex = 6;
			this.panelEnvOnExit.Visible = false;
			// 
			// lblCacheFolderSize
			// 
			this.lblCacheFolderSize.Enabled = false;
			this.lblCacheFolderSize.Location = new System.Drawing.Point(24, 136);
			this.lblCacheFolderSize.Name = "lblCacheFolderSize";
			this.lblCacheFolderSize.Size = new System.Drawing.Size(312, 64);
			this.lblCacheFolderSize.TabIndex = 7;
			// 
			// btnClearXMLCache
			// 
			this.btnClearXMLCache.Location = new System.Drawing.Point(200, 96);
			this.btnClearXMLCache.Name = "btnClearXMLCache";
			this.btnClearXMLCache.Size = new System.Drawing.Size(136, 23);
			this.btnClearXMLCache.TabIndex = 6;
			this.btnClearXMLCache.Text = "C&lear XML cache now";
			this.btnClearXMLCache.Click += new System.EventHandler(this.btnClearXMLCache_Click);
			// 
			// btnClearHTMLCache
			// 
			this.btnClearHTMLCache.Location = new System.Drawing.Point(24, 96);
			this.btnClearHTMLCache.Name = "btnClearHTMLCache";
			this.btnClearHTMLCache.Size = new System.Drawing.Size(136, 23);
			this.btnClearHTMLCache.TabIndex = 5;
			this.btnClearHTMLCache.Text = "&Clear HTML cache now";
			this.btnClearHTMLCache.Click += new System.EventHandler(this.btnClearHTMLCache_Click);
			// 
			// chkClearXMLCache
			// 
			this.chkClearXMLCache.Location = new System.Drawing.Point(24, 56);
			this.chkClearXMLCache.Name = "chkClearXMLCache";
			this.chkClearXMLCache.Size = new System.Drawing.Size(320, 16);
			this.chkClearXMLCache.TabIndex = 4;
			this.chkClearXMLCache.Text = "Clear &XML Cache";
			this.ctrlToolTip.SetToolTip(this.chkClearXMLCache, "If checked, while exiting, RSSConnect will remove *.xml files from its cache fold" +
				"er.");
			// 
			// chkClearHTMLCache
			// 
			this.chkClearHTMLCache.Location = new System.Drawing.Point(24, 32);
			this.chkClearHTMLCache.Name = "chkClearHTMLCache";
			this.chkClearHTMLCache.Size = new System.Drawing.Size(320, 16);
			this.chkClearHTMLCache.TabIndex = 3;
			this.chkClearHTMLCache.Text = "Clear &HTML Cache (Recommended)";
			this.ctrlToolTip.SetToolTip(this.chkClearHTMLCache, "If checked, while exiting, RSSConnect will remove *.html files from its cache fol" +
				"der.");
			// 
			// groupBox4
			// 
			this.groupBox4.Location = new System.Drawing.Point(51, 12);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(293, 4);
			this.groupBox4.TabIndex = 2;
			this.groupBox4.TabStop = false;
			// 
			// label4
			// 
			this.label4.AutoSize = true;
			this.label4.Location = new System.Drawing.Point(8, 8);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(41, 16);
			this.label4.TabIndex = 0;
			this.label4.Text = "On Exit";
			// 
			// panelUpdatesGeneral
			// 
			this.panelUpdatesGeneral.Controls.Add(this.comboUpdatesURL);
			this.panelUpdatesGeneral.Controls.Add(this.label6);
			this.panelUpdatesGeneral.Controls.Add(this.label5);
			this.panelUpdatesGeneral.Controls.Add(this.groupBox5);
			this.panelUpdatesGeneral.Location = new System.Drawing.Point(168, 8);
			this.panelUpdatesGeneral.Name = "panelUpdatesGeneral";
			this.panelUpdatesGeneral.Size = new System.Drawing.Size(352, 264);
			this.panelUpdatesGeneral.TabIndex = 7;
			this.panelUpdatesGeneral.Visible = false;
			// 
			// comboUpdatesURL
			// 
			this.comboUpdatesURL.Items.AddRange(new object[] {
																 "http://www.PerfectXML.com/RSSConnect/newFeeds.xml"});
			this.comboUpdatesURL.Location = new System.Drawing.Point(16, 48);
			this.comboUpdatesURL.Name = "comboUpdatesURL";
			this.comboUpdatesURL.Size = new System.Drawing.Size(320, 21);
			this.comboUpdatesURL.TabIndex = 5;
			this.ctrlToolTip.SetToolTip(this.comboUpdatesURL, "RSSConnect will use this URL to get the new feeds information.");
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(14, 32);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(320, 16);
			this.label6.TabIndex = 4;
			this.label6.Text = "Use following &URL to check for new feeds:";
			// 
			// label5
			// 
			this.label5.AutoSize = true;
			this.label5.Location = new System.Drawing.Point(8, 8);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(46, 16);
			this.label5.TabIndex = 0;
			this.label5.Text = "Updates";
			// 
			// groupBox5
			// 
			this.groupBox5.Location = new System.Drawing.Point(54, 12);
			this.groupBox5.Name = "groupBox5";
			this.groupBox5.Size = new System.Drawing.Size(290, 4);
			this.groupBox5.TabIndex = 3;
			this.groupBox5.TabStop = false;
			// 
			// panelDatabaseGeneral
			// 
			this.panelDatabaseGeneral.Controls.Add(this.chkEmptyPassword);
			this.panelDatabaseGeneral.Controls.Add(this.btnTestConnection);
			this.panelDatabaseGeneral.Controls.Add(this.chkSavePassword);
			this.panelDatabaseGeneral.Controls.Add(this.comboDatabase);
			this.panelDatabaseGeneral.Controls.Add(this.label11);
			this.panelDatabaseGeneral.Controls.Add(this.chkNTAuthentication);
			this.panelDatabaseGeneral.Controls.Add(this.txtPassword);
			this.panelDatabaseGeneral.Controls.Add(this.label10);
			this.panelDatabaseGeneral.Controls.Add(this.txtLoginID);
			this.panelDatabaseGeneral.Controls.Add(this.label9);
			this.panelDatabaseGeneral.Controls.Add(this.comboSQLServer);
			this.panelDatabaseGeneral.Controls.Add(this.label8);
			this.panelDatabaseGeneral.Controls.Add(this.radioSQL);
			this.panelDatabaseGeneral.Controls.Add(this.comboOLEDBConnStr);
			this.panelDatabaseGeneral.Controls.Add(this.radioOLEDB);
			this.panelDatabaseGeneral.Controls.Add(this.groupBox6);
			this.panelDatabaseGeneral.Controls.Add(this.label7);
			this.panelDatabaseGeneral.Location = new System.Drawing.Point(168, 8);
			this.panelDatabaseGeneral.Name = "panelDatabaseGeneral";
			this.panelDatabaseGeneral.Size = new System.Drawing.Size(352, 264);
			this.panelDatabaseGeneral.TabIndex = 8;
			this.panelDatabaseGeneral.Visible = false;
			// 
			// chkEmptyPassword
			// 
			this.chkEmptyPassword.Location = new System.Drawing.Point(224, 151);
			this.chkEmptyPassword.Name = "chkEmptyPassword";
			this.chkEmptyPassword.Size = new System.Drawing.Size(112, 16);
			this.chkEmptyPassword.TabIndex = 18;
			this.chkEmptyPassword.Text = "E&mpty Password";
			// 
			// btnTestConnection
			// 
			this.btnTestConnection.Location = new System.Drawing.Point(232, 240);
			this.btnTestConnection.Name = "btnTestConnection";
			this.btnTestConnection.Size = new System.Drawing.Size(104, 23);
			this.btnTestConnection.TabIndex = 17;
			this.btnTestConnection.Text = "&Test Connection";
			this.btnTestConnection.Click += new System.EventHandler(this.btnTestConnection_Click);
			// 
			// chkSavePassword
			// 
			this.chkSavePassword.Location = new System.Drawing.Point(224, 131);
			this.chkSavePassword.Name = "chkSavePassword";
			this.chkSavePassword.Size = new System.Drawing.Size(112, 16);
			this.chkSavePassword.TabIndex = 15;
			this.chkSavePassword.Text = "S&ave Password";
			this.chkSavePassword.CheckedChanged += new System.EventHandler(this.chkSavePassword_CheckedChanged);
			// 
			// comboDatabase
			// 
			this.comboDatabase.Items.AddRange(new object[] {
															   "RSSConnect"});
			this.comboDatabase.Location = new System.Drawing.Point(32, 212);
			this.comboDatabase.Name = "comboDatabase";
			this.comboDatabase.Size = new System.Drawing.Size(304, 21);
			this.comboDatabase.TabIndex = 16;
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(32, 196);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(304, 16);
			this.label11.TabIndex = 15;
			this.label11.Text = "&Database:";
			// 
			// chkNTAuthentication
			// 
			this.chkNTAuthentication.Location = new System.Drawing.Point(32, 171);
			this.chkNTAuthentication.Name = "chkNTAuthentication";
			this.chkNTAuthentication.Size = new System.Drawing.Size(152, 16);
			this.chkNTAuthentication.TabIndex = 14;
			this.chkNTAuthentication.Text = "&Windows Authentication";
			this.chkNTAuthentication.CheckedChanged += new System.EventHandler(this.chkNTAuthentication_CheckedChanged);
			// 
			// txtPassword
			// 
			this.txtPassword.Location = new System.Drawing.Point(128, 144);
			this.txtPassword.Name = "txtPassword";
			this.txtPassword.PasswordChar = '*';
			this.txtPassword.Size = new System.Drawing.Size(80, 20);
			this.txtPassword.TabIndex = 13;
			this.txtPassword.Text = "";
			this.txtPassword.TextChanged += new System.EventHandler(this.txtPassword_TextChanged);
			// 
			// label10
			// 
			this.label10.AutoSize = true;
			this.label10.Location = new System.Drawing.Point(128, 128);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(57, 16);
			this.label10.TabIndex = 12;
			this.label10.Text = "&Password:";
			// 
			// txtLoginID
			// 
			this.txtLoginID.Location = new System.Drawing.Point(32, 144);
			this.txtLoginID.Name = "txtLoginID";
			this.txtLoginID.Size = new System.Drawing.Size(80, 20);
			this.txtLoginID.TabIndex = 11;
			this.txtLoginID.Text = "";
			// 
			// label9
			// 
			this.label9.AutoSize = true;
			this.label9.Location = new System.Drawing.Point(32, 128);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(49, 16);
			this.label9.TabIndex = 10;
			this.label9.Text = "&Login ID:";
			// 
			// comboSQLServer
			// 
			this.comboSQLServer.Items.AddRange(new object[] {
																"."});
			this.comboSQLServer.Location = new System.Drawing.Point(32, 104);
			this.comboSQLServer.Name = "comboSQLServer";
			this.comboSQLServer.Size = new System.Drawing.Size(304, 21);
			this.comboSQLServer.TabIndex = 9;
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(32, 88);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(304, 16);
			this.label8.TabIndex = 8;
			this.label8.Text = "S&erver:";
			// 
			// radioSQL
			// 
			this.radioSQL.Location = new System.Drawing.Point(16, 72);
			this.radioSQL.Name = "radioSQL";
			this.radioSQL.Size = new System.Drawing.Size(320, 16);
			this.radioSQL.TabIndex = 7;
			this.radioSQL.Text = "&SQL Server or MSDE 2000";
			this.radioSQL.CheckedChanged += new System.EventHandler(this.radioSQL_CheckedChanged);
			// 
			// comboOLEDBConnStr
			// 
			this.comboOLEDBConnStr.Items.AddRange(new object[] {
																   "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=RSSConnect.MDB"});
			this.comboOLEDBConnStr.Location = new System.Drawing.Point(32, 40);
			this.comboOLEDBConnStr.Name = "comboOLEDBConnStr";
			this.comboOLEDBConnStr.Size = new System.Drawing.Size(304, 21);
			this.comboOLEDBConnStr.TabIndex = 6;
			// 
			// radioOLEDB
			// 
			this.radioOLEDB.Location = new System.Drawing.Point(16, 24);
			this.radioOLEDB.Name = "radioOLEDB";
			this.radioOLEDB.Size = new System.Drawing.Size(320, 16);
			this.radioOLEDB.TabIndex = 5;
			this.radioOLEDB.Text = "&OLE DB";
			this.radioOLEDB.CheckedChanged += new System.EventHandler(this.radioOLEDB_CheckedChanged);
			// 
			// groupBox6
			// 
			this.groupBox6.Location = new System.Drawing.Point(63, 12);
			this.groupBox6.Name = "groupBox6";
			this.groupBox6.Size = new System.Drawing.Size(278, 4);
			this.groupBox6.TabIndex = 4;
			this.groupBox6.TabStop = false;
			// 
			// label7
			// 
			this.label7.AutoSize = true;
			this.label7.Location = new System.Drawing.Point(8, 8);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(53, 16);
			this.label7.TabIndex = 0;
			this.label7.Text = "Database";
			this.ctrlToolTip.SetToolTip(this.label7, "RSS Feeds can be exported into this database, and then RSSConnect allows you to d" +
				"o search in this database.");
			// 
			// panelDatabaseIndexing
			// 
			this.panelDatabaseIndexing.Controls.Add(this.chkIndexAfterExport);
			this.panelDatabaseIndexing.Controls.Add(this.label15);
			this.panelDatabaseIndexing.Controls.Add(this.lblLastIndexDate);
			this.panelDatabaseIndexing.Controls.Add(this.label13);
			this.panelDatabaseIndexing.Controls.Add(this.btnIndexNow);
			this.panelDatabaseIndexing.Controls.Add(this.groupBox7);
			this.panelDatabaseIndexing.Controls.Add(this.label12);
			this.panelDatabaseIndexing.Location = new System.Drawing.Point(168, 8);
			this.panelDatabaseIndexing.Name = "panelDatabaseIndexing";
			this.panelDatabaseIndexing.Size = new System.Drawing.Size(352, 264);
			this.panelDatabaseIndexing.TabIndex = 9;
			this.panelDatabaseIndexing.Visible = false;
			// 
			// label15
			// 
			this.label15.Location = new System.Drawing.Point(24, 88);
			this.label15.Name = "label15";
			this.label15.Size = new System.Drawing.Size(320, 59);
			this.label15.TabIndex = 10;
			this.label15.Text = "This operation will update the RSSConnect database indexes. Depending on the numb" +
				"er of records, it may take few seconds to several minutes to complete. Refreshin" +
				"g the database indexes produces up-to-date results when search is performed.";
			// 
			// lblLastIndexDate
			// 
			this.lblLastIndexDate.Location = new System.Drawing.Point(24, 160);
			this.lblLastIndexDate.Name = "lblLastIndexDate";
			this.lblLastIndexDate.Size = new System.Drawing.Size(320, 40);
			this.lblLastIndexDate.TabIndex = 9;
			this.lblLastIndexDate.Visible = false;
			// 
			// label13
			// 
			this.label13.Enabled = false;
			this.label13.Location = new System.Drawing.Point(24, 224);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(320, 32);
			this.label13.TabIndex = 8;
			this.label13.Text = "(Database Indexing Scheduler to be available in the next release.)";
			// 
			// btnIndexNow
			// 
			this.btnIndexNow.Location = new System.Drawing.Point(24, 56);
			this.btnIndexNow.Name = "btnIndexNow";
			this.btnIndexNow.Size = new System.Drawing.Size(168, 24);
			this.btnIndexNow.TabIndex = 7;
			this.btnIndexNow.Text = "&Refresh Index Now";
			this.ctrlToolTip.SetToolTip(this.btnIndexNow, "This operation will update the RSSConnect database indexes. Depending on the numb" +
				"er of records, it may take few seconds to several minutes to complete. Refreshin" +
				"g the database indexes produces up-to-date results when search is performed.");
			this.btnIndexNow.Click += new System.EventHandler(this.btnIndexNow_Click);
			// 
			// groupBox7
			// 
			this.groupBox7.Location = new System.Drawing.Point(56, 12);
			this.groupBox7.Name = "groupBox7";
			this.groupBox7.Size = new System.Drawing.Size(285, 4);
			this.groupBox7.TabIndex = 6;
			this.groupBox7.TabStop = false;
			// 
			// label12
			// 
			this.label12.AutoSize = true;
			this.label12.Location = new System.Drawing.Point(8, 8);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(47, 16);
			this.label12.TabIndex = 5;
			this.label12.Text = "Indexing";
			// 
			// warningImage
			// 
			this.warningImage.Image = ((System.Drawing.Image)(resources.GetObject("warningImage.Image")));
			this.warningImage.Location = new System.Drawing.Point(8, 288);
			this.warningImage.Name = "warningImage";
			this.warningImage.Size = new System.Drawing.Size(32, 32);
			this.warningImage.TabIndex = 10;
			this.warningImage.TabStop = false;
			this.warningImage.Visible = false;
			// 
			// warningText
			// 
			this.warningText.Location = new System.Drawing.Point(40, 291);
			this.warningText.Name = "warningText";
			this.warningText.Size = new System.Drawing.Size(280, 32);
			this.warningText.TabIndex = 11;
			this.warningText.Text = "Password will be saved as clear text in Options.xml configuration file.";
			this.warningText.Visible = false;
			// 
			// panelEnvFavorites
			// 
			this.panelEnvFavorites.Controls.Add(this.groupBox8);
			this.panelEnvFavorites.Controls.Add(this.label14);
			this.panelEnvFavorites.Controls.Add(this.btnRemoveFav);
			this.panelEnvFavorites.Controls.Add(this.lvFavorites);
			this.panelEnvFavorites.Location = new System.Drawing.Point(168, 8);
			this.panelEnvFavorites.Name = "panelEnvFavorites";
			this.panelEnvFavorites.Size = new System.Drawing.Size(352, 264);
			this.panelEnvFavorites.TabIndex = 12;
			// 
			// groupBox8
			// 
			this.groupBox8.Location = new System.Drawing.Point(58, 12);
			this.groupBox8.Name = "groupBox8";
			this.groupBox8.Size = new System.Drawing.Size(288, 4);
			this.groupBox8.TabIndex = 7;
			this.groupBox8.TabStop = false;
			// 
			// label14
			// 
			this.label14.AutoSize = true;
			this.label14.Location = new System.Drawing.Point(8, 8);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(51, 16);
			this.label14.TabIndex = 6;
			this.label14.Text = "Favorites";
			// 
			// btnRemoveFav
			// 
			this.btnRemoveFav.Enabled = false;
			this.btnRemoveFav.Location = new System.Drawing.Point(272, 232);
			this.btnRemoveFav.Name = "btnRemoveFav";
			this.btnRemoveFav.TabIndex = 1;
			this.btnRemoveFav.Text = "&Remove";
			this.btnRemoveFav.Click += new System.EventHandler(this.btnRemoveFav_Click);
			// 
			// lvFavorites
			// 
			this.lvFavorites.CheckBoxes = true;
			this.lvFavorites.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						  this.colTitle,
																						  this.colFeedUrl});
			this.lvFavorites.FullRowSelect = true;
			this.lvFavorites.GridLines = true;
			this.lvFavorites.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lvFavorites.Location = new System.Drawing.Point(8, 32);
			this.lvFavorites.Name = "lvFavorites";
			this.lvFavorites.Size = new System.Drawing.Size(336, 192);
			this.lvFavorites.TabIndex = 0;
			this.lvFavorites.View = System.Windows.Forms.View.Details;
			this.lvFavorites.ItemCheck += new System.Windows.Forms.ItemCheckEventHandler(this.lvFavorites_ItemCheck);
			// 
			// colTitle
			// 
			this.colTitle.Text = "Title";
			this.colTitle.Width = 139;
			// 
			// colFeedUrl
			// 
			this.colFeedUrl.Text = "Feed URL";
			this.colFeedUrl.Width = 187;
			// 
			// chkIndexAfterExport
			// 
			this.chkIndexAfterExport.Location = new System.Drawing.Point(24, 32);
			this.chkIndexAfterExport.Name = "chkIndexAfterExport";
			this.chkIndexAfterExport.Size = new System.Drawing.Size(312, 16);
			this.chkIndexAfterExport.TabIndex = 11;
			this.chkIndexAfterExport.Text = "Immediately update Index after Export";
			this.ctrlToolTip.SetToolTip(this.chkIndexAfterExport, "If checked, the database Index will be updated every time any feed is exported to" +
				" the database.");
			// 
			// frmOptions
			// 
			this.AcceptButton = this.btnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(522, 327);
			this.Controls.Add(this.panelDatabaseIndexing);
			this.Controls.Add(this.panelDatabaseGeneral);
			this.Controls.Add(this.panelUpdatesGeneral);
			this.Controls.Add(this.panelEnvOnExit);
			this.Controls.Add(this.panelEnvFavorites);
			this.Controls.Add(this.panelEnvGeneral);
			this.Controls.Add(this.panelEnvStartup);
			this.Controls.Add(this.warningText);
			this.Controls.Add(this.warningImage);
			this.Controls.Add(this.tvOptions);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.groupBox3);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "frmOptions";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Options";
			this.Load += new System.EventHandler(this.frmOptions_Load);
			this.panelEnvGeneral.ResumeLayout(false);
			this.panelEnvStartup.ResumeLayout(false);
			this.panelEnvOnExit.ResumeLayout(false);
			this.panelUpdatesGeneral.ResumeLayout(false);
			this.panelDatabaseGeneral.ResumeLayout(false);
			this.panelDatabaseIndexing.ResumeLayout(false);
			this.panelEnvFavorites.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion
		#region EVENT_HANDLERS
		private void frmOptions_Load(object sender, System.EventArgs e)
		{
			try
			{
				rootNode = tvOptions.Nodes[0];
				tvOptions.PathSeparator = @"\";
				Cursor = Cursors.WaitCursor;

				//	Load Options from options.xml
				LoadOptions();
			}
			catch(Exception exp)
			{
				DebugLog.Instance.REPORT(exp);
				Cursor = Cursors.Default;
				MessageBox.Show(exp.ToString(), "Error");
			}
			finally
			{
				Cursor = Cursors.Default;
			}
		}

		private void tvOptions_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			//	Change Panel
			try
			{
				PanelVisibleAll(false);

				string curPath;
				if(tvOptions.SelectedNode == rootNode)
				{
					curPath = tvOptions.SelectedNode.Nodes[0].FullPath;
				}
				else 
				{
					curPath = tvOptions.SelectedNode.FullPath;
				}

				switch(tvOptions.SelectedNode.FullPath)
				{
					case @"Options":
					case @"Options\Environment":
					case @"Options\Environment\General":
						panelEnvGeneral.Visible = true;
						break;
					case @"Options\Environment\Startup":
						panelEnvStartup.Visible = true;
						break;
					case @"Options\Environment\On Exit":
						panelEnvOnExit.Visible = true;
						break;
					case @"Options\Environment\Favorites":
						panelEnvFavorites.Visible = true;
						break;

					case @"Options\Updates":
					case @"Options\Updates\General":
						panelUpdatesGeneral.Visible = true;
						break;

					case @"Options\Database":
					case @"Options\Database\General":
						panelDatabaseGeneral.Visible = true;
						break;
					case @"Options\Database\Indexing":
						panelDatabaseIndexing.Visible = true;
						break;
				}

				SetTreeNodeIcons(rootNode);
				if(tvOptions.SelectedNode == rootNode && rootNode.Nodes.Count > 0 && rootNode.Nodes[0].Nodes.Count > 0)
					rootNode.Nodes[0].Nodes[0].ImageIndex = 2;
				else if(tvOptions.SelectedNode.Nodes.Count > 0)
					tvOptions.SelectedNode.Nodes[0].ImageIndex = 2;

			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void radioOLEDB_CheckedChanged(object sender, System.EventArgs e)
		{
			if(radioOLEDB.Checked)
				ChangeDBType(DBType.OLEDB);
		}
		private void radioSQL_CheckedChanged(object sender, System.EventArgs e)
		{
			if(radioSQL.Checked)
				ChangeDBType(DBType.SQLorMSDE);
		}

		private void chkNTAuthentication_CheckedChanged(object sender, System.EventArgs e)
		{
			txtLoginID.Enabled = !chkNTAuthentication.Checked;
			txtPassword.Enabled = !chkNTAuthentication.Checked;
			chkSavePassword.Enabled = !chkNTAuthentication.Checked;
			chkEmptyPassword.Enabled = ((!chkNTAuthentication.Checked) && (txtPassword.Text.Trim().Length <= 0));
			warningImage.Visible = (!chkNTAuthentication.Checked) && chkSavePassword.Checked;
			warningText.Visible = (!chkNTAuthentication.Checked) && chkSavePassword.Checked;
		}
		private void chkSavePassword_CheckedChanged(object sender, System.EventArgs e)
		{
			warningImage.Visible = chkSavePassword.Checked;
			warningText.Visible = chkSavePassword.Checked;
		}

		private void btnOK_Click(object sender, System.EventArgs e)
		{
			try
			{
				Cursor = Cursors.WaitCursor;
				SaveOptions();
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			finally {Cursor = Cursors.Default;}
		}

		private void btnClearHTMLCache_Click(object sender, System.EventArgs e)
		{
			try
			{
				Cursor = Cursors.WaitCursor;
				Utility utility = new Utility();
				utility.ClearCacheFiles("*.html");
				btnClearHTMLCache.Enabled = false;
				RefreshCacheFolderSizeMessage();
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			finally {Cursor = Cursors.Default;}
		}

		private void btnClearXMLCache_Click(object sender, System.EventArgs e)
		{
			try
			{
				Cursor = Cursors.WaitCursor;
				Utility utility = new Utility();
				utility.ClearCacheFiles("*.xml");
				btnClearXMLCache.Enabled = false;
				RefreshCacheFolderSizeMessage();
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			finally {Cursor = Cursors.Default;}
		}

		private void lvFavorites_ItemCheck(object sender, System.Windows.Forms.ItemCheckEventArgs e)
		{
			btnRemoveFav.Enabled = ( (e.NewValue == CheckState.Checked) || (lvFavorites.CheckedItems.Count > 1) );
		}

		private void btnRemoveFav_Click(object sender, System.EventArgs e)
		{
			foreach(ListViewItem item in lvFavorites.CheckedItems)
			{
				removedFavs.Add(item.SubItems[1].Text);
				lvFavorites.Items.Remove(item);
			}
			btnRemoveFav.Enabled = false;
		}

		private void tvOptions_AfterExpand(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			if (e.Node != rootNode)
			{
				e.Node.SelectedImageIndex = 1;
				e.Node.ImageIndex = 1;
			}
		}

		private void tvOptions_AfterCollapse(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			if (e.Node != rootNode)
			{
				e.Node.SelectedImageIndex = 0;
				e.Node.ImageIndex = 0;
			}
		}

		private void btnTestConnection_Click(object sender, System.EventArgs e)
		{
			bool result = false;
			Cursor = Cursors.WaitCursor;
			DBHelperBase dbObject=null;
			try
			{
				if(radioOLEDB.Checked)
				{
					dbObject = new OLEDBHelper(comboOLEDBConnStr.Text);
				}
				else
				{
					dbObject = new SQLMSDEHelper(GetSQLConnectionString(true));
				}
				result = dbObject.TestConnection();
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			Cursor = Cursors.Default;

			if(result)
			{
				MessageBox.Show("Test connection succeeded!", Application.ProductName);
			}
			else
			{
				if(dbObject != null && dbObject.LastError != null)
					MessageBox.Show("Test connection failed!\n\n" + dbObject.LastError, Application.ProductName);
				else
					MessageBox.Show("Test connection failed!", Application.ProductName);
			}
		}

		private void btnIndexNow_Click(object sender, System.EventArgs e)
		{
			try
			{
				Cursor = Cursors.WaitCursor;
				Utility utility = new Utility();
				int recordsIndexed = utility.RefreshDBIndex();
				MessageBox.Show(recordsIndexed + " records indexed.", Application.ProductName);
				btnIndexNow.Enabled = false;
				AppOptions.Instance.SetOption("dbLastIndexed", System.DateTime.Now.ToString());
				lblLastIndexDate.Text = "Database Index last updated on: " + System.DateTime.Now.ToString();
				lblLastIndexDate.Visible = true;
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
			finally { Cursor = Cursors.Default;}
		
		}

		private void txtPassword_TextChanged(object sender, System.EventArgs e)
		{
			chkEmptyPassword.Enabled = txtPassword.Text.Trim().Length <= 0;
			chkEmptyPassword.Checked = txtPassword.Text.Trim().Length <= 0;
		}

		#endregion
		#region SUPPORTING_FUNCTIONS
		private void PanelVisibleAll(bool state)
		{
			try
			{
				foreach (Control control in this.Controls)
				{
					if(control.GetType().ToString() == "System.Windows.Forms.Panel")
						((Panel)(control)).Visible = state;
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void ChangeDBType(DBType newType)
		{
			bool sqlEnabled = (newType == DBType.SQLorMSDE) ;
			
			comboSQLServer.Enabled = sqlEnabled;
			txtLoginID.Enabled = sqlEnabled;
			txtPassword.Enabled = sqlEnabled;
			chkNTAuthentication.Enabled = sqlEnabled;
			comboDatabase.Enabled = sqlEnabled;
			chkSavePassword.Enabled = sqlEnabled;
			chkEmptyPassword.Enabled = sqlEnabled;

			comboOLEDBConnStr.Enabled = !sqlEnabled;
		}

		private void LoadOptions()
		{
			rootNode.Expand();

			try
			{
				//	Environment\General
				chkTrayWhenMinimized.Checked = 
					(AppOptions.Instance.GetOption("hideWhenMinimized").CompareTo("1") == 0);
				chkTrayWhenClose.Checked = 
					(AppOptions.Instance.GetOption("hideWhenClosed").CompareTo("1") == 0);
				chkConfirmDelete.Checked = 
					(AppOptions.Instance.GetOption("confirmDelete").CompareTo("1") == 0);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			try
			{
				//	Environment\Startup
				chkSplash.Checked = 
					(AppOptions.Instance.GetOption("showSplashScreen").CompareTo("1") == 0);
				chkMaximized.Checked = 
					(AppOptions.Instance.GetOption("mainWndMaximized").CompareTo("1") == 0);
				comboHomePage.Text = 
					AppOptions.Instance.GetOption("homepage");
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			try
			{
				//	Environment\On Exit
				chkClearHTMLCache.Checked = 
					(AppOptions.Instance.GetOption("clearHTMLCacheOnExit").CompareTo("1") == 0);
				chkClearXMLCache.Checked = 
					(AppOptions.Instance.GetOption("clearXMLCacheOnExit").CompareTo("1") == 0);

				RefreshCacheFolderSizeMessage();

			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			try
			{
				//	Environment\Favorites
				foreach(DictionaryEntry favEntry in favList)
				{
					ListViewItem newRow = new ListViewItem(favEntry.Value.ToString().Replace("&&", "&"));	//title
					newRow.SubItems.Add(favEntry.Key.ToString());	//	feedUrl

					lvFavorites.Items.Add(newRow);
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			try
			{
				//	Updates\General
				comboUpdatesURL.Text = 
					AppOptions.Instance.GetOption("newFeedsUrl");
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			try
			{
				//	Database\General
				string connString = AppOptions.Instance.GetOption("connectionString");
				if( (AppOptions.Instance.GetOption("dbType").ToUpper().CompareTo("OLEDB")) == 0 )
				{
					comboOLEDBConnStr.Text = connString;
					radioOLEDB.Checked = true;
				}
				else
				{
					radioSQL.Checked = true;
					string[] connStringParams = connString.Split(';');
					foreach(string param in connStringParams)
					{
						string[] nameValuePair = param.Split('=');
						
						if(nameValuePair[0] != null)
							nameValuePair[0] = nameValuePair[0].ToUpper();
						
						switch(nameValuePair[0])
						{
							case "SERVER":
							case "DATA SOURCE":
								comboSQLServer.Text = nameValuePair[1];
								break;

							case "INTEGRATED SECURITY":
								chkNTAuthentication.Checked = nameValuePair[1] != null && (nameValuePair[1].ToUpper().CompareTo("SSPI") == 0);
								break;

							case "USER ID":
							case "UID":
								chkNTAuthentication.Checked = false;
								txtLoginID.Text = nameValuePair[1];
								break;

							case "PASSWORD":
							case "PWD":
								chkNTAuthentication.Checked = false;
								chkSavePassword.Checked = true;
								txtPassword.Text = nameValuePair[1];
								if(txtPassword.Text.Length <= 0)
									chkEmptyPassword.Checked = true;
								break;

							case "INITIAL CATALOG":
							case "DATABASE":
								comboDatabase.Text = nameValuePair[1];
								break;
						}
					}
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			try
			{
				//	Database\Indexing
				try
				{
					chkIndexAfterExport.Checked = 
						(AppOptions.Instance.GetOption("updateIndexAfterExport").CompareTo("1") == 0);
				}
				catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

				string lastIndexDate = AppOptions.Instance.GetOption("dbLastIndexed");
				if(lastIndexDate.Length > 0)
				{
					lblLastIndexDate.Text = "Database Index last updated on: " + lastIndexDate;
					lblLastIndexDate.Visible = true;
				}

			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			//	show "last tab" (tab selected when dialog was last closed)
			try
			{
				string nodePath = AppOptions.Instance.GetOption("optionsDlgTab");
				if(nodePath.Length > 0)
				{
					nodePath = nodePath.ToUpper();
					if( (rootNode.FullPath.ToUpper().CompareTo(nodePath)) == 0)
						tvOptions.SelectedNode = rootNode;
					else
						SelectNodeByPath(nodePath, rootNode);
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void SetTreeNodeIcons(TreeNode treeNode)
		{
			try
			{
				foreach(TreeNode curNode in treeNode.Nodes)
				{
					if(curNode.Nodes.Count > 0)
					{
						if(curNode.IsExpanded)
						{
							curNode.ImageIndex = 1;
							curNode.SelectedImageIndex = 1;
						}
						else
						{
							curNode.ImageIndex = 0;
							curNode.SelectedImageIndex = 0;
						}
						SetTreeNodeIcons(curNode);
					}
					else if(curNode == tvOptions.SelectedNode)
					{
						curNode.ImageIndex = 2;
						curNode.SelectedImageIndex = 2;
					}
					else
					{
						curNode.ImageIndex = 3;
						curNode.SelectedImageIndex = 3;
					}
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void SelectNodeByPath(string nodePath, TreeNode treeNode)
		{
			try
			{
				foreach(TreeNode curNode in treeNode.Nodes)
				{
					if( (curNode.FullPath.ToUpper().CompareTo(nodePath)) == 0)
					{
						tvOptions.SelectedNode = curNode;
						return;
					}
					else
					{
						SelectNodeByPath(nodePath, curNode);
					}
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}

		private void SaveOptions()
		{
			try
			{
				//	Environment\General
				if(chkTrayWhenMinimized.Checked)
					AppOptions.Instance.SetOption("hideWhenMinimized", "1");
				else
					AppOptions.Instance.SetOption("hideWhenMinimized", "0");

				if(chkTrayWhenClose.Checked)
					AppOptions.Instance.SetOption("hideWhenClosed",  "1");
				else
					AppOptions.Instance.SetOption("hideWhenClosed",  "0");

				if(chkConfirmDelete.Checked)
					AppOptions.Instance.SetOption("confirmDelete",  "1");
				else
					AppOptions.Instance.SetOption("confirmDelete",  "0");
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			try
			{
				//	Environment\Startup
				if(chkSplash.Checked)
					AppOptions.Instance.SetOption("showSplashScreen",  "1");
				else
					AppOptions.Instance.SetOption("showSplashScreen",  "0");

				if(chkMaximized.Checked)
					AppOptions.Instance.SetOption("mainWndMaximized",  "1");
				else
					AppOptions.Instance.SetOption("mainWndMaximized",  "0");

				if(comboHomePage.Text != null)
					AppOptions.Instance.SetOption("homepage", comboHomePage.Text);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			try
			{
				//	Environment\On Exit
				if(chkClearHTMLCache.Checked)
					AppOptions.Instance.SetOption("clearHTMLCacheOnExit",  "1");
				else
					AppOptions.Instance.SetOption("clearHTMLCacheOnExit",  "0");
				
				if(chkClearXMLCache.Checked)
					AppOptions.Instance.SetOption("clearXMLCacheOnExit",  "1");
				else
					AppOptions.Instance.SetOption("clearXMLCacheOnExit",  "0");
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			try
			{
				//	Updates\General
				if(comboUpdatesURL.Text != null)
					AppOptions.Instance.SetOption("newFeedsUrl", comboUpdatesURL.Text);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			try
			{
				//	Database\General
				if(radioOLEDB.Checked)
				{
					AppOptions.Instance.SetOption("dbType", "OLEDB");
					AppOptions.Instance.SetOption("connectionString", comboOLEDBConnStr.Text);
				}
				else
				{
					AppOptions.Instance.SetOption("dbType", "SQLorMSDE");
					AppOptions.Instance.SetOption("connectionString", GetSQLConnectionString(false));
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			try
			{	//	Database\Indexing
				if(chkIndexAfterExport.Checked)
					AppOptions.Instance.SetOption("updateIndexAfterExport",  "1");
				else
					AppOptions.Instance.SetOption("updateIndexAfterExport",  "0");
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

			//	save "last tab" (tab selected when dialog was last closed)
			try
			{
				AppOptions.Instance.SetOption("optionsDlgTab", tvOptions.SelectedNode.FullPath);
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}

		}

		private string GetSQLConnectionString(bool getPassword)
		{
			string connString="";
			//	Server
			if(comboSQLServer.Text.Length > 0)
				connString = "SERVER=" + comboSQLServer.Text + ";";
					
			//	Login details
			if(chkNTAuthentication.Checked)
				connString += "INTEGRATED SECURITY=SSPI;";
			else
			{
				if(txtLoginID.Text.Length > 0)
					connString += "User ID=" + txtLoginID.Text + ";";
				if(chkEmptyPassword.Checked)
					connString += "Password=;";
				else if(getPassword || chkSavePassword.Checked)
					connString += "Password=" + txtPassword.Text + ";";
			}

			//	Initial Catalog
			if(comboDatabase.Text != null && comboDatabase.Text.Length > 0)
				connString += "Database=" + comboDatabase.Text + ";";

			return connString;
		}
		private void RefreshCacheFolderSizeMessage()
		{
			try
			{
				string cacheFolderPath = Application.StartupPath + @"\cache";
				Utility utility = new Utility();
				System.IO.DirectoryInfo di = new System.IO.DirectoryInfo(cacheFolderPath);
				long folderSizeInBytes = utility.GetDirSizeInBytes(di); 
				string folderSizeMessage = utility.FolderSizeToString(folderSizeInBytes);
				lblCacheFolderSize.Text = "Cache folder (" + cacheFolderPath + ") current size: " +
					folderSizeMessage + ".";
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}
		#endregion
	}
}
