#region USING
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
#endregion
namespace RSSConnect
{
	/// <summary>
	/// Splash and "About RSSConnect" form
	/// </summary>
	public class frmSplash : System.Windows.Forms.Form
	{
		#region PUBLIC_PRIVATE_FIELDS
		public bool showAsAboutBox;

		private System.Windows.Forms.Button btnOK;
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Label lblVersion;
		private System.Windows.Forms.Label lblVersionText;
		private System.Windows.Forms.LinkLabel pxmlLink;
		#endregion
		#region CTOR_DTOR
		public frmSplash()
		{
			InitializeComponent();
			showAsAboutBox = false;
		}
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmSplash));
			this.btnOK = new System.Windows.Forms.Button();
			this.lblVersion = new System.Windows.Forms.Label();
			this.lblVersionText = new System.Windows.Forms.Label();
			this.pxmlLink = new System.Windows.Forms.LinkLabel();
			this.SuspendLayout();
			// 
			// btnOK
			// 
			this.btnOK.BackColor = System.Drawing.SystemColors.Control;
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.Location = new System.Drawing.Point(360, 240);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 1;
			this.btnOK.Text = "OK";
			this.btnOK.Visible = false;
			// 
			// lblVersion
			// 
			this.lblVersion.ForeColor = System.Drawing.Color.Gray;
			this.lblVersion.Location = new System.Drawing.Point(56, 224);
			this.lblVersion.Name = "lblVersion";
			this.lblVersion.Size = new System.Drawing.Size(48, 16);
			this.lblVersion.TabIndex = 2;
			this.lblVersion.Text = "Version:";
			// 
			// lblVersionText
			// 
			this.lblVersionText.ForeColor = System.Drawing.Color.Gray;
			this.lblVersionText.Location = new System.Drawing.Point(64, 240);
			this.lblVersionText.Name = "lblVersionText";
			this.lblVersionText.Size = new System.Drawing.Size(56, 16);
			this.lblVersionText.TabIndex = 3;
			// 
			// pxmlLink
			// 
			this.pxmlLink.BackColor = System.Drawing.Color.Transparent;
			this.pxmlLink.Cursor = System.Windows.Forms.Cursors.Hand;
			this.pxmlLink.Location = new System.Drawing.Point(136, 8);
			this.pxmlLink.Name = "pxmlLink";
			this.pxmlLink.Size = new System.Drawing.Size(312, 64);
			this.pxmlLink.TabIndex = 4;
			this.pxmlLink.MouseUp += new System.Windows.Forms.MouseEventHandler(this.pxmlLink_MouseUp);
			// 
			// frmSplash
			// 
			this.AcceptButton = this.btnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.White;
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.CancelButton = this.btnOK;
			this.ClientSize = new System.Drawing.Size(450, 300);
			this.Controls.Add(this.pxmlLink);
			this.Controls.Add(this.lblVersionText);
			this.Controls.Add(this.lblVersion);
			this.Controls.Add(this.btnOK);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "frmSplash";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "About RSSConnect";
			this.Load += new System.EventHandler(this.frmSplash_Load);
			this.ResumeLayout(false);

		}
		#endregion
		#region EVENT_HANDLERS
		private void frmSplash_Load(object sender, System.EventArgs e)
		{
			try
			{
				Assembly assembly = Assembly.GetExecutingAssembly();
				lblVersionText.Text = assembly.GetName().Version.ToString();

				if(showAsAboutBox)
				{
					btnOK.Visible = true;
					this.FormBorderStyle = FormBorderStyle.FixedToolWindow;
					btnOK.Focus();
				}
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		}
		private void pxmlLink_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			try
			{
				System.Diagnostics.Process.Start("http://www.PerfectXML.com");
			}
			catch(Exception exp) {DebugLog.Instance.REPORT(exp);}
		
		}
		#endregion
	}
}
