<xsl:stylesheet version='1.0' xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
		xmlns:content = 'http://purl.org/rss/1.0/modules/content/'
		xmlns:xhtml='http://www.w3.org/1999/xhtml'
		xmlns:slash='http://purl.org/rss/1.0/modules/slash/'
		xmlns:dc="http://purl.org/dc/elements/1.1/">

		<xsl:output method="html" encoding="UTF-16"/> 
		<xsl:template match='/'>
		<html><head>
		<title><xsl:value-of select='/rss/channel/title'/></title>
		<style>
			<![CDATA[
			body		{ 	
				font-family: Verdana,Arial,Helvetica,sans-serif;
				font-size: 8px;
				color: #000000;
				margin:0px
			}
			.small_text {  font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; line-height: 16px; color: #000000; }
			.title		{ font-size:16pt;}
			.newsItemTitle { font-size:11pt;font-weight:bold;}
			.date		{ font-size:9pt; }
			div {font-family: Verdana,Arial,Helvetica,sans-serif; 	font-size: 11px; 	color: #333333;}
			div.content { font-family:Verdana,Arial;font-size:11pt;margin:10pt;padding:5pt;  }
			div.entry
			{
				border: 1px solid #EEEEEE;
				margin-bottom: 1em;
			}
			h3.entryTitle
			{
				margin-top: 0;
				margin-bottom: 0;
				font-family:Verdana;
				font-size: 12px;
				background: #EEEEEE;
				color: #336699;
				padding: .1em;
			}
			p.entryFooter
			{
				font-size: .9em;
				text-align: right;
				margin: .5em;
			}

			.LM1 {
				font-family: Verdana,Arial,Helvetica,sans-serif;
				font-size: 11px;
				font-weight: bold;
				color: #003399
			}

			A.LM1, A.LM1:visited {
				color: #003399;
				text-decoration: none
			}

			A.LM1:hover {
				text-decoration: underline
			}

			.LM2 {
				font-family: Verdana,Arial,Helvetica,sans-serif;
				font-size: 11px;
				color: #333333
			}

			A.LM2, A.LM2:visited {
				text-decoration: none
			}

			A.LM2:hover {
				color: #003399;
				text-decoration: underline
			}

		]]>
		</style>
		<script language="JavaScript">
			function ExpandCollapse(oImage, oBlock)
			{
				if ((oBlock.style.display == "") || (oBlock.style.display == "none"))	{
					oBlock.style.display = "block";
					oImage.src = "http://www.PerfectXML.com/ni/minus.gif";
				}	else {
					oBlock.style.display = "none";
					oImage.src = "http://www.PerfectXML.com/ni/plus.gif";
				}
				return false;
			}
		</script>

		</head>
		<body bgcolor="#FFFFFF" topmargin="0" leftmargin="0" marginwidth="0" marginheight="0"><a name="top"></a>
		<table width="100%" bgcolor="#336699" cellpadding="3" cellspacing="0" border="0" height="35">
		<tr>
	  	  <td>
	  		<xsl:if test="string(/rss/channel/image/url)">
	  			<a href="{/rss/channel/image/link}"><img align="right" hspace="7" vspace="3" border="0" alt="{/rss/channel/image/title}" src="{/rss/channel/image/url}"/></a>
	  		</xsl:if>
	  		<span class='title'><font color="white"><xsl:value-of select='/rss/channel/title'/></font></span>
	  		<br/>
	  		<span class='date'><font color="white"><i><xsl:value-of select='/rss/channel/description'/></i></font></span>
	  	  </td>
		 </tr>
		</table>
		<xsl:if test="string(/rss/channel/link)">
			<div align='right' ><span class='date'><b>Source: </b></span><a class='LM1' target='_blank' href='{/rss/channel/link}'><xsl:value-of select='/rss/channel/link'/></a></div>
		</xsl:if>
		<table color="black" width="99%" cellpadding="3" cellspacing="0" border="0" bgcolor="#FFFFFF"><tr><td bgcolor="#FFFFFF" color="black" >
			<xsl:for-each select="/rss/channel/item">
					<xsl:variable name="imageID">img<xsl:value-of select="position()"/></xsl:variable>
					<xsl:variable name="blockID">block<xsl:value-of select="position()"/></xsl:variable>
			
					<img src='http://www.PerfectXML.com/ni/plus.gif' width='16' height='16' style="cursor: hand" alt="Collapse/Expand" border="0">
						<xsl:attribute name="ID"><xsl:value-of select="$imageID"/></xsl:attribute>
						<xsl:attribute name="onClick">ExpandCollapse(<xsl:value-of select="$imageID"/>, <xsl:value-of select="$blockID"/>);</xsl:attribute>
					</img>

					<a href="JavaScript:" class="LM2"> <xsl:attribute name="onClick">ExpandCollapse(<xsl:value-of select="$imageID"/>, <xsl:value-of select="$blockID"/>);</xsl:attribute> <b><xsl:value-of select="title"/></b></a>
					<div>
						<xsl:attribute name="ID"><xsl:value-of select="$blockID"/></xsl:attribute>
						<script>
							<xsl:value-of select="$blockID"/>.style.display='none';
						</script>
						<xsl:text>   </xsl:text>
						<span class="small_text"><font color="gray">
						<xsl:if test="pubDate">
							<xsl:value-of select="pubDate"/>
						</xsl:if>
						<xsl:if test="dc:date">
							<xsl:value-of select="dc:date"/>
						</xsl:if>
						<xsl:if test="dc:creator">
							<xsl:text> (</xsl:text><xsl:value-of select="dc:creator"/><xsl:text>) </xsl:text>
						</xsl:if>
						</font></span>
						


						<p class="small_text" style="padding-left:8px;"><span class="small_text">
						<xsl:choose>
							<xsl:when test='xhtml:body'>
								<xsl:copy-of select='xhtml:body'/>
							</xsl:when>
							<xsl:when test='content:encoded'>
								<xsl:value-of  disable-output-escaping='yes' select='content:encoded'/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of disable-output-escaping='yes' select='description'/>
							</xsl:otherwise>
						</xsl:choose>

						<table width="100%" cellpadding="0" cellspacing="1" bgcolor="#FFFFFF">
							<tr>
								<td align="left" bgcolor="#FFFFFF">
									<xsl:choose>
										<xsl:when test="string(link)">
											<a target="_blank" class="LM1" href='{link}'><b>Read on...</b></a>
										</xsl:when> 
										<xsl:when test="string(guid)">
											<a target="_blank" class="LM1" href='{guid}'><b>Read on...</b></a>
										</xsl:when> 
									</xsl:choose>
								</td>
								<xsl:if test='comments'>
									<td align="right">
										<a target="_blank" class="LM1" href='{comments}'><b>Comments...</b></a>
									</td>
								</xsl:if>
						</tr></table>
						</span></p>
						<div class="entry">
						</div>
					</div>
					 <br/><br/>
				
			</xsl:for-each>
		</td></tr></table>

		</body></html>
		</xsl:template>

		</xsl:stylesheet>