<xsl:stylesheet version='1.0' xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
		xmlns:content = 'http://purl.org/rss/1.0/modules/content/'
		xmlns:xhtml='http://www.w3.org/1999/xhtml'
		xmlns:slash='http://purl.org/rss/1.0/modules/slash/'
		xmlns:dc="http://purl.org/dc/elements/1.1/">

		<xsl:output method="html" encoding="UTF-16"/> 
		<xsl:template match='/'>

		<html><head>
		<title><xsl:value-of select='/rss/channel/title'/></title>

		<style>
			<![CDATA[
					body		{ 	
						font-family: Verdana,Arial,Helvetica,sans-serif;
						font-size: 8px;
						background: white;
						margin:0;
						color: #000000
					}

					TBODY TR{
						cursor:default;
						color:#003366;
						padding:2px;
					}

					.feedTable A {
						color: #003399;
					}

					.feedTable A:Hover {
						color: red;
					}

					.LM1 {
						font-family: Verdana,Arial,Helvetica,sans-serif;
						font-size: 11px;
						text-decoration: underline;
						color: #003399
					}

					A.LM1, A.LM1:visited {
						color: #003399;
						text-decoration: none
					}

					A.LM1:hover {
						color: red;
						text-decoration: underline
					}
					.small_text {  font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; line-height: 16px; color: #000000; }
					.title		{ font-size:16pt;}
					.newsItemTitle { font-size:11pt;font-weight:bold;}
					.date		{ font-size:9pt; }
			]]>
		</style>

		<script language="JavaScript">
			function ExpandCollapse(oBlock)
			{
				if ((oBlock.style.display == "") || (oBlock.style.display == "none"))	{
					oBlock.style.display = "block";
				}	else {
					oBlock.style.display = "none";
				}
				return false;
			}
		</script>

		</head>
		<body><a name="top"></a>
		<table width="100%" bgcolor="#336699" cellpadding="3" cellspacing="0" border="0" height="35">
		<tr>
	  	  <td>
	  		<xsl:if test="string(/rss/channel/image/url)">
	  			<a href="{/rss/channel/image/link}"><img align="right" hspace="7" vspace="3" border="0" alt="{/rss/channel/image/title}" src="{/rss/channel/image/url}"/></a>
	  		</xsl:if>
	  		<span class='title'><font color="white"><xsl:value-of select='/rss/channel/title'/></font></span>
	  		<br/>
	  		<span class='date'><font color="white"><i><xsl:value-of select='/rss/channel/description'/></i></font></span>
	  	  </td>
		 </tr>
		</table>
		<xsl:if test="string(/rss/channel/link)">
			<div align='right' ><span class='date'><b>Source: </b></span><a class='LM1' target='_blank' href='{/rss/channel/link}'><xsl:value-of select='/rss/channel/link'/></a></div>
		</xsl:if>
		<br /><center>
		<table width="98%" cellspacing="0" cellpadding="2" border="0" style="border:1px solid #9999cc;">
			<TR bgcolor="#9999cc" >
				<TD class="small_text"><font color="white"><b>Title</b></font></TD>
				<TD class="small_text"><font color="white"><b>Created</b></font></TD>
				<TD class="small_text"><font color="white"><b>Creator</b></font></TD>
			</TR>
		<xsl:for-each select="/rss/channel/item">
			<xsl:variable name="blockID">block<xsl:value-of select="position()"/></xsl:variable>
				
			<tr class="small_text">
					<xsl:attribute name="bgcolor"><xsl:choose ><xsl:when test="position() mod 2">#ffffff</xsl:when><xsl:otherwise>#eeeeee</xsl:otherwise></xsl:choose></xsl:attribute>
					<td valign="top">
						<a href="JavaScript:" class="LM1"> <xsl:attribute name="onClick">ExpandCollapse(<xsl:value-of select="$blockID"/>);</xsl:attribute> <xsl:value-of select="title"/></a>
					</td>
					<td valign="top" nowrap="true">
						<span class="small_text"><font color="gray">
						<xsl:if test="pubDate">
							<xsl:value-of select="pubDate"/>
						</xsl:if>
						<xsl:if test="dc:date">
							<xsl:value-of select="dc:date"/>
						</xsl:if>
						</font></span>
					</td>
					<td valign="top" nowrap="true">
						<span class="small_text">
							<xsl:if test="dc:creator">
								<xsl:value-of select="dc:creator"/>
							</xsl:if>
						</span>
					</td>
				</tr>
				<tr>
					<td colspan="3">
						<div>
							<xsl:attribute name="ID"><xsl:value-of select="$blockID"/></xsl:attribute>
							<script language="JavaScript">
								<xsl:value-of select="$blockID"/>.style.display="none";
							</script>
							<table width="100%" cellpadding="2" cellspacing="1" border="0" bgcolor="#000000"><tr><td valign="top" align="left" bgcolor="#FFFFFF">
								<span class="small_text">
									<xsl:choose>
										<xsl:when test='xhtml:body'>
											<xsl:copy-of select='xhtml:body'/>
										</xsl:when>
										<xsl:when test='content:encoded'>
											<xsl:value-of  disable-output-escaping='yes' select='content:encoded'/>
										</xsl:when>
										<xsl:otherwise>
											<xsl:value-of disable-output-escaping='yes' select='description'/>
										</xsl:otherwise>
									</xsl:choose>
								</span>

								<table width="100%" cellpadding="0" cellspacing="1" >
									<tr>
										<td align="left" >
											<xsl:choose>
												<xsl:when test="string(link)">
													<a target="_blank" class="LM1" href='{link}'><b>Read on...</b></a>
												</xsl:when> 
												<xsl:when test="string(guid)">
													<a target="_blank" class="LM1" href='{guid}'><b>Read on...</b></a>
												</xsl:when> 
											</xsl:choose>
										</td>
										<xsl:if test='comments'>
											<td align="right">
												<a target="_blank" class="LM1" href='{comments}'><b>Comments...</b></a>
											</td>
										</xsl:if>
									</tr>
								</table>
							</td></tr></table>
						</div>
					</td>
				</tr>
			</xsl:for-each>
		</table>
		</center>
		</body></html>
		</xsl:template>

		</xsl:stylesheet>